<?php 

class CommonsTS
{

	public function changeFormatDate($dateStr){
		$date = str_replace('/', '-', $dateStr);
		return date('Y-m-d', strtotime($date));
	}

	public function callApi($pApiKey, $pSecret, $pEndpoint, $pMethod, $pParams){

	    $signature = hash("sha256", $pApiKey.$pSecret.time());
		
        $body = new http\Message\Body;
        $body->append($pParams);

		$request = new http\Client\Request;
        $request->setRequestUrl($pEndpoint);
        $request->setRequestMethod($pMethod);
        $request->setBody($body);
        $request->setHeaders(array(
            /*'Api-Key'      => $pApiKey,
	      	'X-Signature'  => $signature,*/
	      	'Content-Type' => 'application/xml',
	      	'Accept'       => 'application/xml',
	      	//'Accept- encoding' => 'Gzip'
        ));
        
		try
		{
		    $client = new http\Client;
		    $client->enqueue($request)->send();
		    $response = $client->getResponse();

		    if ($response->getResponseCode() != 200) {  
		       return printf("%s returned '%s' (%d) '%s'\n",
		           $response->getTransferInfo("effective_url"),
		           $response->getInfo(),
		           $response->getResponseCode(),
		           $pParams
		       );

		    } else {
		       return $response->getBody();
		    }

		} catch (Exception $ex) {
		    return printf("Error while sending request, reason: %s\n",$ex->getMessage());
		}
	}
}

?>