
<main>
    <div class="container" style="margin-top: 7rem;">
        <div class="row">
            <div class="col-9">
                <!-- <h3>Demo:</h3> -->
                <div class="img-container">
                    <img id="image" src="<?= Yii::app()->baseUrl ."/vue/tests/test-crop-map.jpg" ?>" alt="Picture">
                </div>
            </div>
            <div class="col-3">
                <!-- <h3>Preview:</h3> -->
                <div class="docs-preview clearfix">
                    <div class="img-preview preview-lg"></div>
                    <div class="img-preview preview-md"></div>
                    <div class="img-preview preview-sm"></div>
                    <div class="img-preview preview-xs"></div>
                </div>
            </div>
        </div>
        <div class="row" id="actions">
            <div class="col-md-9 docs-buttons">
                <div class="btn-group">
                    <label class="btn btn-primary btn-upload" for="inputImage" title="Upload image file">
                        <input type="file" class="sr-only" id="inputImage" name="file" accept="image/*">
                        <span class="docs-tooltip" data-toggle="tooltip" title="Subir una imagen">
                            <span class="fa fa-upload"></span>
                        </span>
                    </label>
                </div>

                <div class="btn-group btn-group-crop">
                    <button type="button" class="btn btn-success" data-method="getCroppedCanvas" data-option="{ &quot;maxWidth&quot;: 4096, &quot;maxHeight&quot;: 4096 }">
                        <span class="docs-tooltip" data-toggle="tooltip" title="cropper.getCroppedCanvas({ maxWidth: 4096, maxHeight: 4096 })">
                            Previsualizar
                        </span>
                    </button>
                </div>

            </div><!-- /.docs-buttons -->

            <div class="col-md-3 docs-toggles">
                <!-- <h3>Toggles:</h3> -->
                <div class="btn-group d-flex flex-nowrap" data-toggle="buttons">
                    <label class="btn btn-primary active">
                        <input type="radio" class="sr-only" id="aspectRatio1" name="aspectRatio" value="1.7777777777777777">
                        <span class="docs-tooltip" data-toggle="tooltip" title="aspectRatio: 16 / 9">
                            16:9
                        </span>
                    </label>
                    <label class="btn btn-primary">
                        <input type="radio" class="sr-only" id="aspectRatio2" name="aspectRatio" value="1.3333333333333333">
                        <span class="docs-tooltip" data-toggle="tooltip" title="aspectRatio: 4 / 3">
                            4:3
                        </span>
                    </label>
                    <label class="btn btn-primary">
                        <input type="radio" class="sr-only" id="aspectRatio3" name="aspectRatio" value="1">
                        <span class="docs-tooltip" data-toggle="tooltip" title="aspectRatio: 1 / 1">
                            1:1
                        </span>
                    </label>
                    <label class="btn btn-primary">
                        <input type="radio" class="sr-only" id="aspectRatio4" name="aspectRatio" value="0.6666666666666666">
                        <span class="docs-tooltip" data-toggle="tooltip" title="aspectRatio: 2 / 3">
                            2:3
                        </span>
                    </label>
                    <label class="btn btn-primary">
                        <input type="radio" class="sr-only" id="aspectRatio5" name="aspectRatio" value="NaN">
                        <span class="docs-tooltip" data-toggle="tooltip" title="aspectRatio: NaN">
                            Libre
                        </span>
                    </label>
                </div>

            </div><!-- /.docs-toggles -->
        </div>
    </div>
</main>

<style>
    .modal {
        margin-bottom: 0em!important;
        padding-top: 2em!important;
    }
    
</style>

<!-- Show the cropped image in modal -->
<div class="modal fade docs-cropped" id="getCroppedCanvasModal" role="dialog" aria-hidden="true" aria-labelledby="getCroppedCanvasTitle" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="getCroppedCanvasTitle">Cropped</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body"></div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                <a class="btn btn-primary" id="download" href="javascript:void(0);" download="cropped.jpg">Guardar</a>
            </div>
        </div>
    </div>
</div><!-- /.modal -->

<?php
	Yii::app()->clientScript->registerScript('id', '
		var rmt_url = "https://'. $_SERVER['SERVER_NAME'] . Yii::app()->baseUrl .'"'
	, CClientScript::POS_HEAD);

	Yii::app()->clientScript->registerCssFile("https://cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.6/cropper.css");
	Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl ."/vue/tests/cropImage.css?v=". time());

	Yii::app()->clientScript->registerScriptFile("https://cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.6/cropper.js", CClientScript::POS_END);
	Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl ."/vue/tests/mainCropper.js?v=". time(), CClientScript::POS_END);

	//Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl ."/vue/tests/cropImage.js?v=". time(), CClientScript::POS_END);
?>