<?php 

if(!empty($model->tipo_cambio)){
   $totalAgencia = round($model->total_tc * $model->tipo_cambio,2);
   $comisionAgencia = $totalAgencia*($model->comision/100);
   $saldoAgencia = $totalAgencia - ($comisionAgencia);
}else{
    $totalAgencia = $model->importe;
    $comisionAgencia = $model->importe * ($model->comision/100);
    $saldoAgencia = $model->importe - ($comisionAgencia);
}

?>
<style>
    .table > thead > tr > th, .table > tbody > tr > td, .table > tfoot > tr > td, .table > tbody > tr > th, .table > tfoot > tr > th {
        padding: 4px 8px;
    }
</style>

 <table class="table table-striped table-sm mt-3">
    <tbody>
        <tr>
            <th>Tarifa pública</th>
            <td align="right">$ <?=number_format($totalAgencia,2)?></td>
        </tr>
        <tr>
            <th> - Comisión agencia</th>
            <td align="right">$ <?=number_format($comisionAgencia,2)?></td>
        </tr>
        <tr>
            <th>Tarifa agencia</th>
            <td align="right">$ <?=number_format($totalAgencia - $comisionAgencia,2)?></td>
        </tr>
    </tbody>
</table>
<h4>Pagos Realizados</h4>
<table class="table table-striped table-condensed"><thead>
    <tr>
        <th >Folio</th><th >Fecha</th>
        <th>Importe</th>
        <!-- <th>Comisión</th> -->
        <th>F.P.</th></tr>
    </thead>
    <tbody>
        <?php 
        $totalrecibos = 0;
        foreach ($pagos as $row){
            $recibo = Recibo::model()->findByPk($row->id_recibo);
            if($recibo->estado != 'C'){
                $totalrecibos += $row->importe; ?>
                <tr>
                    <td><a href="<?=Yii::app()->createUrl('pagos/GeneratePdf',array('idrecibo'=>$recibo->id_recibo))?>" target="_blank" ><i class="fa fa-file-text-o"></i> <?php echo $recibo->id_recibo; ?></a></td>
                    <td><?php echo $recibo->log; ?></td>
                    <td align="right">$<?php echo number_format($row->importe,'2','.',','); ?></td>
                    <!-- <td align="right"><?php echo $recibo->comision; ?>%</td> -->
                    <td><?php echo $recibo->idTipo->descripcion; ?></td>
                </tr>
            <?php } } ?>
        </tbody>
        <tfoot style="display: none;">
            <tr>
                <td></td>
                <td>Total</td>
                <td align="right">$<?php echo number_format($totalrecibos,'2','.',','); ?></span></td>
                <td align="right"><span id="totalcomisiones"></span></td>
                <td></td>
            </tr>
            <tr>
                <td></td>
                <td><strong>Saldo</strong></td>
                <td align="right">
                   <?php 
                   $saldoNuevo = round($saldoAgencia-$totalrecibos,2);
                   if($saldoNuevo != $model->saldo && $model->saldo != 0){
                       $model->saldo = $saldoNuevo;
                       $model->save();
                   }
                   ?>
                   $<?php echo $model->saldo; ?>
                   <input type="hidden" id="totalimporte" value="<?=$model->saldo?>" />
                   <input type="hidden" id="totalimporte_sc" value="<?=empty($model->tipo_cambio) ? $model->importe:round($model->total_tc * $model->tipo_cambio,2)?>" />
               </td>
               <td></td>
               <td></td>
           </tr>

       </tfoot>
   </table>
   <?php 
 $ordenController = Yii::app()->createController('reservas')[0];
 $detalles = $ordenController->consultaOrdenDetalles($model->id_tourReservacion,'Tour'); 
 $totalComprobante = 0;

 $hoy = date('Y-m-d');
$inicio = '2020-06-14';

if (strtotime(date('Y-m-d')) > strtotime($inicio)){

 ?>
 
<table class="table table-striped table-sm">
    <thead>
        <tr>
            <th>Abonos</th>
            <th style="text-align: center;">Fecha</th>
            <th style="text-align: right;">Importe</th>
        </tr>
    </thead>
    <tbody>
        <?php if (count($detalles) > 0): ?>
            <?php 
            foreach ($detalles as $orden){
                $totalComprobante += $orden['importe'];
                ?>
                <tr>
                    <td> 
                        <a href="<?= Yii::app()->createUrl('admin/contabilidad/ordenPago/GeneratePdf', array('idOrden' => $orden["id_orden_pago"],'formato'=>'orden')) ?>" target="_blank">
                            <i class="fa fa-file-text-o"></i> <?=$orden['id_orden_pago']?>
                        </a>
                    </td>
                    <td align="center"><?=date('d/m/Y',strtotime($orden['log']))?></td>
                    <td align="right">$ <?=number_format($orden['importe'],2)?></td>
                </tr>
                <?php 
            } 
            ?>
        <?php endif ?>
    </tbody>
    <tfoot>
        <tr>
            <td></td>
            <td align="right">Total de pagos:</td>
            <td align="right">$ <?php echo number_format($totalComprobante + $totalrecibos, '2', '.', ','); ?></span></td>
        </tr>
        <tr>
            <?php 
            $saldo_favor = 0;
            $saldoNuevo = round($saldoNuevo - $totalComprobante, 2);
            if ($saldoNuevo != $model->saldo && $model->saldo != 0) {
                $model->saldo = $saldoNuevo;
                $model->save();
            }
            if ($saldoNuevo < 0) {
                $saldo_favor = $saldoNuevo * (-1);
                $model->saldo = 0;
                $model->save();
            }
            ?>
            <th colspan="2"><strong>Saldo Restante</strong></th>
            <td align="right"><strong>$ <?=number_format($model->saldo,2)?></strong></td>
            <input type="hidden" id="totalimporte" value="<?=$model->saldo?>" />
            <input type="hidden" id="totalimporte_sc" value="<?=empty($model->tipo_cambio) ? $model->importe:round($model->total_tc * $model->tipo_cambio,2)?>" />
        </tr>
        <tr>
            <?php if ($saldo_favor > 0 && $_SESSION['agenciaUsuario'] == 9): ?>
                <th colspan="2"><strong>Saldo a favor</strong></th>
                <td align="right"><strong>$ <?=number_format($saldo_favor,2)?></strong></td>
            <?php endif ?>
        </tr>
    </tfoot>
</table>
<?php } ?>