<?php
//error_reporting(E_ERROR | E_WARNING | E_PARSE);
require_once('../api/beds/HotelApi.php');
Yii::import('application.extensions.phpmailer.JPhpMailer');
class ReservacionController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='//layouts/column1';
	public $palaceResorts = array('BP'=>1,'CZ'=>1,'IM'=>1,'LBC'=>1,'MPS'=>1,'PL'=>1,'SP'=>1,'MPG'=>1,'ZPLB'=>1,'ZCJG'=>1);
	public $clientUrl = "http://api.palaceresorts.com/EnterpriseServiceInterface/ServiceInterface.asmx?wsdl";
	public $outlet;
	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}
	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		$rules = AuthFuncion::model()->findAll('controlador="'.Yii::app()->controller->id.'"');
		$array = array();
		foreach($rules as $row){
			$rule = array('allow',
						'actions'=>array($row->funcion),
						'roles'=>array($row->operacion),
					);
			array_push($array,$rule);
		}
		array_push($array,
			array('allow',  // allow all users to perform 'index' and 'view' actions
				'actions'=>array('Ver','Buscar'),
				'users'=>array('@'),
			),
			array('allow', // allow authenticated user to perform 'create' and 'update' actions
				'actions'=>array('Pagoscupon','Agregarhabitacion','Buscarplan','Cargarhabitaciones','Cargarbase','Cargaradultos','Cargarmenores',
								'Cargarrestriccion','Cotizar','Sumardias','GeneratePdf','GenerateExcel','Prefetch','Process','TcProcess','Condiciones','error','Ecomerce', 'TcProcessBanco', 'CambioMoneda','CreateReservacion'),
				'users'=>array('@'),
			),
			array('allow',
				'actions'=>array('Validarfechalimite', 'TcProcess','reservacionProvisional','guardarBooking','ecomerceAgencias'),
				'users'=>array('*'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			)
		);
		return $array;
	}
	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{

		
			
		$this->layout = "//layouts/ansonika_site";
		$outlet=Outlet::model()->find('estatus=1');
		$estatus=$this->eventoOutlet($outlet);
		/*if($estatus){
			echo "1";
		}*/


		/*
		$model=$this->loadModel($id);
		$agencia=$this->loadModelAgencia($model->id_agencia);
		$hoteles=$this->loadModelHotel($model->id_hotel);			
		$this->render('view',array(
			'model'=>$model,
			'agencia'=>$agencia,
			'hoteles'=>$hoteles
		));
		*/
		$id_reservacion=$id;


		$this->reservacion($id_reservacion);
//		$this->reservacion($id_reservacion);
	}
	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionError(){
		$this->layout='//layouts/error';
		$this->render('error');
	}
	public function actionCondiciones($id)
	{
		$model = Politica::model()->findByPk($id);
		$this->layout='//layouts/terminosycondiciones';
		$this->render('/condiciones/privacidad',array('model'=>$model));
	}
	public function actionCreate()
	{
		$session=new CHttpSession;
		$session->open();
		$model=new Reservacion;
		if(isset($_POST['Reservacion']))
		{
			unset($_SESSION['ecomerce']);
			if($_POST['Reservacion']['manual'] == 1 && !empty($_POST['Reservacion']['id_bloqueo'])){
				$clave = $this->verificaClave($_POST['clave']);
				if(empty($clave)){
					$this->redirect(array('bloqueo','id'=>$_POST['Reservacion']['id_bloqueo'],'hab'=>$_POST['roomlist'],'error_clave'=>1));
				}
			}
			$model = $this->guardarReservacion($model);
			$operacion = Yii::app()->createController('operacionesLog');
			$operacion = $operacion[0];
			$operacion->Create($model->id_reservacion,3);
			if(isset($_POST['carrito'])){
				$this->quitarCarrito($_POST['carrito']);
				if(empty($_SESSION['pagado'])){
					echo CJSON::encode(array('cupon'=>$model->id_reservacion));
				}
				else{
					unset($_SESSION['itemcarrito'],$_SESSION['pagado']);
					$this->redirect(array('view','id'=>$model->id_reservacion));
				}
			}
			else if(isset($_POST['roomlist'])){
				$roomlistHabs = explode(',',$_POST['roomlist']);
				for($i=0;$i<count($roomlistHabs);$i++)
				{
					$roomlistRow = Roominglist::model()->find('id_bloqueo='.$model->id_bloqueo.' and habitacion='.$roomlistHabs[$i]);
					$roomlistRow->id_reservacion = $model->id_reservacion;
					$roomlistRow->id_agencia = $model->id_agencia;
					$roomlistRow->save();
				}
				$this->redirect(array('bloqueos/view','id'=>$model->id_bloqueo));
			}else{
				$this->redirect(array('view','id'=>$model->id_reservacion));
			}
		}
		else{
			$model->id_usuario=Yii::app()->user->id;				
			$model->subtotal=0;
			$model->comision=0;
			$model->iva=0;
			$model->saldo=0;
			if(isset($_POST['id_hotel'])){
				$model->id_hotel = $_POST['id_hotel'];
				$model->id_tipo_plan = $_POST['id_plan'];
				$model->num_habitaciones = $_POST['habitaciones'];
				$model->fecha_inicial = implode("-", array_reverse(explode("-", $_POST['fecha_inicio'])));
				$model->fecha_final = implode("-", array_reverse(explode("-", $_POST['fecha_final'])));
				$model->num_noches = $_POST['noches'];
				$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$_POST['id_hotel'].' and estatus=1');
				$base_habitacion = BaseHabitacion::model()->findAll();
				$idhab = $_POST['id_hab'];
			}
			if(isset($_GET['carrito']) && !empty($_SESSION['Datos'][$_GET['carrito']])){
				$n = $_GET['carrito'];
				$model->id_agente = $_SESSION['Datos'][$n]['id_agente'];
				$model->id_agencia = $_SESSION['Datos'][$n]['id_agencia'];
				$model->nombre_cliente = $_SESSION['Datos'][$n]['nombre_cliente'];
				$model->apellido_cliente = $_SESSION['Datos'][$n]['apellido_cliente'];
				$model->tel_cliente = $_SESSION['Datos'][$n]['tel_cliente'];
				$model->id_hotel = $_SESSION['Datos'][$n]['id_hotel'];
				$model->id_tipo_plan = $_SESSION['Datos'][$n]['id_plan'];
				$model->num_habitaciones = $_SESSION['Datos'][$n]['front_form']['habs'];
				$model->fecha_inicial = str_replace('/','-',$_SESSION['Datos'][$n]['fecha_inicio']);
				$model->fecha_final = str_replace('/','-',$_SESSION['Datos'][$n]['fecha_final']);
				$model->num_noches = $_SESSION['Datos'][$n]['noches'];
				$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$_SESSION['Datos'][$n]['id_hotel'].' and estatus=1');
				$base_habitacion = BaseHabitacion::model()->findAll();
				$idhab = $_SESSION['Datos'][$n]['id_tipo_habitacion'];
				if($_SESSION['Datos'][$n]['total']>0)
				{
					$model->total = $_SESSION['Datos'][$n]['total'];
					$model->total_tc = $_SESSION['Datos'][$n]['total'];
				}else{
					$model->total = $_SESSION['TotalCotiz'][$n][0]['total_neto'];
					$model->total_tc = $_SESSION['TotalCotiz'][$n][0]['total_tc'];					
				}
				$TotalN=0;
				$model->id_tarifa = $_SESSION['TotalCotiz'][$n][0]['tarifa'];
				$to_time = strtotime(date('Y-m-d H:i:s'));
				$from_time = strtotime($_SESSION['Datos'][$n]['fecha_cotiza']);
				$minutos = round(abs($to_time - $from_time) / 60,2);
				if($minutos > 10){
					$this->quitarCarrito($n);
					$this->render('expira',array());
				}
				else{
					$fecha_inicio = implode('-',array_reverse(explode('-',$model->fecha_inicial)));
					$avisoCancelacion = $this->cancelaciones($model,$fecha_inicio,$model->id_tarifa);
					if(!empty($model->idTarifa->fecha_limite) && strtotime($fecha_inicio) > strtotime($model->idTarifa->fecha_limite)){
						$model->fecha_limite = $model->idTarifa->fecha_limite;
					}
					else if(!empty($model->idTarifa->fecha_limite_dias)){
						$model->fecha_limite = date('Y-m-d',strtotime($fecha_inicio.' -'.($model->idTarifa->fecha_limite_dias + 2).' days'));
					} 
					else{
						$fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$fecha_inicio.'" between fecha_inicio and fecha_final');
						if(!empty($fechaLimite)){
							$model->fecha_limite = date('Y-m-d',strtotime($fecha_inicio.' -'.($fechaLimite->dias + 2).' days'));
						} 
					}
					if( ( !empty($model->fecha_limite) && strtotime($model->fecha_limite) < strtotime(date('Y-m-d')) ) || empty($model->fecha_limite) ){
						
						$hoy=date("Y-m-d");
					    
					    $datetime_fecha_inicial=new DateTime($model->fecha_inicial);
						$datetime_hoy=new DateTime($hoy);
						
						$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);
						
						$resultado_diferencia_dias= $diferencia->format('%a'); ##DIFERENCIA DE DIAS ENTRE LA FECHA ACTUAL Y LA FECHA DE ENTRADA

						if($resultado_diferencia_dias<=7 && empty($fechaLimite))
						{
					    	$fecha_limite=date("Y-m-d",strtotime($hoy));
						}else if($resultado_diferencia_dias>7 && $resultado_diferencia_dias<=15 && empty($fechaLimite))
						{
					    	$fecha_limite=date("Y-m-d",strtotime($hoy.' +1 days'));							
						}else if($resultado_diferencia_dias>15 && $resultado_diferencia_dias<=32 && empty($fechaLimite))
						{
					    	$fecha_limite=date("Y-m-d",strtotime($hoy.' +2 days'));
						}else if($resultado_diferencia_dias>32 && empty($fechaLimite))
						{
					    	$fecha_limite=date("Y-m-d",strtotime($model->fecha_inicial.' -31 days'));
						}elseif ( !empty($fechaLimite) && strtotime($fecha_inicio.' -'.$fechaLimite->dias.' days') < strtotime(date('Y-m-d')) ) {
							$fecha_limite=date("Y-m-d",strtotime($hoy));	
							$model->fecha_limite_h=date("Y-m-d",strtotime($hoy));
						}
					    
						if($fecha_limite<=$hoy)
				            $fecha_limite=$hoy;

						$model->fecha_limite = $fecha_limite;
					}

					if(isset($_SESSION['Datos'][0]['rateKey']) && $_SESSION['Datos'][0]['rateKey']!="OB")
					{
						
						if($model->idHotel->proveedor==1)
						{
							$avisoCancelacion="";
							$busquedaController = Yii::app()->createController('busqueda');
	            			$busquedaController = $busquedaController[0];
							$markup = Api::model()->findByPk(1)->markup;
							$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['fecha_limite'])));
						
						
							foreach (json_decode(base64_decode($_SESSION['Datos'][0]['rateKey'])) as $rK => $rateKey) 
							{
								
								$requestCheckrate=array();
								$requestCheckrate["rateKey"]= $rateKey;	
								$responseCheckrate=$this->consultarCheckrates(json_encode($requestCheckrate));
								$arrayCheckrate=json_decode($responseCheckrate);
								
	                            $tipohab = TipoHabitaciones::model()->find('codigo="'.$arrayCheckrate->hotel->rooms[0]->code.'" AND id_hotel='.$model->id_hotel);
	                            
	                            $descripcionHabitacion=(strlen($tipohab->descripcion)>0)?$tipohab->descripcion:$tipohab->tipo_habitacion;

	                            $responsePoliticas=$busquedaController->politicasCancelacion($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies,$model->fecha_inicial,$markup,$descripcionHabitacion,$rK,$moneda,false);
								
								
								$avisoCancelacion.=$responsePoliticas["politicasCancelacion"];


								
								if($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies)
								{
									/*foreach ($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies as $cancelacion) 
		                            {
		                                $fecha_limite=date("Y-m-d",strtotime($cancelacion->from.' -7 days'));
		                                
		                                if($model->fecha_limite<$fecha_limite && $model->fecha_limite<date("Y-m-d",strtotime($cancelacion->from)))
	                                    {
	                                        $model->fecha_limite=$fecha_limite;
	                                    }


		                            }*/
	                                
	                              $_SESSION['fecha_limite']=substr($responsePoliticas["fecha_limite"],0,10);
	                 
	                              $_SESSION['fecha_limite_h']=date('Y/m/d H:i:s',strtotime($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies[0]->from));

									$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['fecha_limite'])));
									$model->fecha_limite_h=$_SESSION['fecha_limite_h'];

		                        }else
		                        {
		                            $model->fecha_limite=date("Y-m-d");
		                            $model->fecha_limite_h=date("Y-m-d");
		                        }

								if($arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments)
		            				$rateComments[$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments;
		            			if($arrayCheckrate->hotel->rooms[0]->rates[0]->offers)
	            					$offers[$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->offers;
		            			$TotalN+=$arrayCheckrate->hotel->totalNet/$markup;

		            		}

		            		$_SESSION['fecha_limite']=$model->fecha_limite;
		            		$_SESSION['politicas_cancelacion']=$avisoCancelacion;

							//echo $TotalN."-".$model->total."<br>";


	            			$cambioTarifa = '';
		            		if ($TotalN>0) {
		            			if((string)(round($TotalN,4)) != (string)(round($model->total,4))){ 
		            				$cambioTarifa = "El importe Total de la tarifa se actualizo al momento, ¿Deseas continuar? ";
		            				$model->total = $TotalN; 
		            			}
		            		}
						}else if($model->idHotel->proveedor==3)
            			{

            				$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['fecha_limite'])));
            				$model->fecha_limite_h=implode('-',array_reverse(explode('/',$_SESSION['fecha_limite_h'])));
            				$avisoCancelacion=$_SESSION['politicas_cancelacion'];


            			}else if($model->idHotel->proveedor==4) {
            				
            				//$model->fecha_limite=date('Y-m-d H:i:s',strtotime($_SESSION['Datos'][0]['fecha_limite']));
            				$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['Datos'][0]['fecha_limite'])));
            				$model->fecha_limite_h=$_SESSION['Datos'][0]['fecha_limite_h'];
							$avisoCancelacion= $_SESSION['Datos'][0]['politicas_cancelacion'];

            			}else if($model->idHotel->proveedor==5){
							$fechaL= $_SESSION['Datos'][0]['fecha_limite'];
			                $model->fecha_limite= $fechaL; 
			                $model->fecha_limite_h= $_SESSION['Datos'][0]['fecha_limite_h']; 
							$avisoCancelacion= $_SESSION['Datos'][0]['politicas_cancelacion'];				
            			}else if($model->idHotel->proveedor==6)
            			{
            				$politicas_cancelacion=json_decode();
            				$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['Datos'][0]['ratePlan'])));
            				$avisoCancelacion=$_SESSION['Datos'][0]['aviso_cancelacion'];
            				$model->fecha_limite_h = $_SESSION['Datos'][0]['fecha_limite_h'];

            			}						

					}


					if($_SESSION['Datos'][0]['rateKey']=="OB")
					{
	            		$avisoCancelacion=$_SESSION['politicas_cancelacion'];
	            		$_SESSION['fecha_limite'];
						$model->fecha_limite=date('Y-m-d H:i:s', strtotime($_SESSION['fecha_limite']));
						$ratePlan_data=json_decode(base64_decode($_SESSION["Datos"][0]["ratePlan"]));

						$datetime_hoy=new DateTime(date("Y-m-d"));
					    $datetime_fecha_inicial=new DateTime(date("Y-m-d",strtotime($model->fecha_inicial)));
						
						$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);
						
						$resultado_diferencia_dias=$diferencia->format('%a');
						$dias_fecha_limite=$ratePlan_data->CancelPenalties->CancelPenalty->DeadLine->OffsetUnitMultiplier;

						if($dias_fecha_limite<=$resultado_diferencia_dias && (!is_null($dias_fecha_limite)))
						{
			            	$model->fecha_limite_h=date("Y-m-d H:i:s",strtotime($model->fecha_inicial.' -'.($dias_fecha_limite+1).' days'));                    	
						}else
						{							
			            	$model->fecha_limite_h=date("Y-m-d H:i:s");
						}
	            		
					} 



					$hotel= Hoteles::model()->findByPk($model->id_hotel);
					$hoy=date("Y-m-d");

					if($hotel->proveedor==0 && $hotel->Destino->destinationsCode0->code=="HUA"){
						$model->fecha_limite=date("Y-m-d H:i:s",strtotime($hoy.' +2 days'));
						
					}

					$_SESSION["fechalmt"]=date("Y-m-d H:i:s",strtotime($hoy.' +2 days'));
					$_SESSION["dest"]=$hotel->Destino->destinationsCode0->code;

					/*HOTELBEDS*/
					if(1)
            		{
            			//$markup = Api::model()->findByPk(1)->markup;
            			$this->render('reservar',array(
						'model'=>$model,'tipo_habitacion'=>$tipo_habitacion,'base_habitacion'=>$base_habitacion,'idhab'=>$idhab,'n'=>$n,'avisoCancelacion'=>$avisoCancelacion,'TotalN'=>$TotalN,'rateComments'=>$rateComments,'offers'=>$offers,'promociones'=>$_SESSION['Datos'][0]['promociones'],'markup'=>$markup
						));
					}
					else
					{
						$this->render('retornarform');
					}
				}
			}
			else if(!Yii::app()->user->checkAccess('agenciaMenu') && $_SESSION['tipoUsuario'] != "Agencia"){
				$this->render('create',array(
					'model'=>$model,'tipo_habitacion'=>$tipo_habitacion,'base_habitacion'=>$base_habitacion,'idhab'=>$idhab,
				));
			}
		}
	}

	// reemplaza a create
	public function actionguardarBooking()
	{
		// $model, $reserva, $datos, $cotizacion, $TotalCotiz, $ecomerce
		header('Access-Control-Allow-Origin: *');
		header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method");
		header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
		header("Allow: GET, POST, OPTIONS, PUT, DELETE");

		$outlet=Outlet::model()->find('estatus=1');
		$outletEstatus=$this->eventoOutlet($outlet); //fechas de outlet
		$outletControl=Yii::app()->createController('outlet');
		$tarifasOutlet=$outletControl[0]->validacionTarifas($outlet); //valida estados
		$session=new CHttpSession;
		$session->open();
		$model = new Reservacion;

		if (isset($_POST["Reservacion"])) 
		{
			unset($_SESSION['ecomerce']);
			if($_POST['Reservacion']['manual'] == 1 && !empty($_POST['Reservacion']['id_bloqueo'])){
				$clave = $this->verificaClave($_POST['clave']);
				if(empty($clave)){
					$this->redirect(array('bloqueo','id'=>$_POST['Reservacion']['id_bloqueo'],'hab'=>$_POST['roomlist'],'error_clave'=>1));
				}
			}

			$reservaApis = Yii::app()->createController('reservaBanco');
			$reservaApis = $reservaApis[0];
			$this->outlet = Outlet::model()->find('estatus=1');
		
			$model->attributes=$_POST['Reservacion'];
			$Reservacion = $_POST;
			$datos = json_decode($_POST["datos"],true);
			$cotizacion = $_GET["cotizacion"];
			$totalCotiz = $_GET["totalCotiz"];

			$datos['id_agencia'] = $model->id_agencia;
			$datos['id_agente'] = $model->id_agente;
			$datos['nombre_cliente'] = $model->nombre_cliente;
			$datos['apellido_cliente'] = $model->apellido_cliente;
			$datos['tel_cliente'] = $model->tel_cliente;


			for($i=1;$i<=$model->num_habitaciones;$i++):
				$adultos = $datos['front_form']['habitacion_'.$i]['adultos'];
				for($a=1;$a<=$adultos;$a++){
					//agregar nombres de adultos al front_form
					$datos['front_form']['habitacion_'.$i]['adulto_'.$a] = $Reservacion['Adulto_'.$a.'_'.$i]['nombre'];
					$datos['front_form']['habitacion_'.$i]['adulto_apellido_'.$a] = $Reservacion['Adulto_'.$a.'_'.$i]['apellido'];
				}
				$num_ninios = $datos['front_form']['habitacion_'.$i]['num_ninios'];
				for($m=1;$m<=$num_ninios;$m++){
					//agregar nombres de menores al front_form
					$datos['front_form']['habitacion_'.$i]['ninio_'.$m] = $Reservacion['Ninio_'.$m.'_'.$i]['nombre'];
					$datos['front_form']['habitacion_'.$i]['ninio_apellido_'.$m] = $Reservacion['Ninio_'.$m.'_'.$i]['apellido'];
				}
			endfor;
			
			### para separar datos de $Reservacion y tener menos peso la variable
			unset($Reservacion['datos']);

			// echo json_encode($Reservacion);
			// exit;
			if (empty($model->id_bloqueo)) {
				$model->fecha_inicial = implode("-", array_reverse(explode("-", $model->fecha_inicial)));
				$model->fecha_final = implode("-", array_reverse(explode("-", $model->fecha_final)));
			}

			$model->num_noches = $this->noches($model->fecha_inicial,$model->fecha_final);		
			$outletEstatus=$this->eventoOutlet($this->outlet);
			$comision = Agencias::model()->findByPk($model->id_agencia)->porcentaje_comision;
			if ($_POST['Reservacion']['id_bloqueo']) {
				$porcentaje = Bloqueos::model()->findByPk($_POST['Reservacion']['id_bloqueo'])->comision;
				if ($porcentaje>0) {
					$comision=$porcentaje;
				}
			}

			$model->comision = $comision;

			if (!empty($_POST['Reservacion']['comision']) && !empty($_POST['id_cupon_aplicado'])) {
				$model->comision = $_POST['Reservacion']['comision'];
			}

			if(empty($datos['rateKey']))
			{
				$comision_hotel = Tarifa::model()->findByPk($model->id_tarifa);

			}
			else
			{
				//pasar a variables de configuracion, tarea pendiente 14 nov 2017
				$comision_hotel=20; 
				// $model->id_tarifa=0;
				//$model->comision = 14; 
				if($model->idHotel->proveedor==1){
					$markup = Api::model()->findByPk(1)->markup;
				}else if($model->idHotel->proveedor==2){
					$markup = Api::model()->findByPk(4)->markup;
				}else if($model->idHotel->proveedor==3){
					$markup = Api::model()->findByPk(6)->markup;
				}
			}

			$model->libera_cupon=1;

			if($model->manual == 1)$model->total_tc = $model->total;
			$model->saldo = $model->total - ($model->total*($model->comision/100));
			if($model->manual != 1)$model->saldo_h = $model->total - ($model->total*($comision_hotel->comision/100));			
			$model->estatus = 'R';
			if($model->manual == 0 && $model->idTarifa->tipo_cambio != 0){
				if($model->idTarifa->tipo_cambio == 1){
					$model->tipo_cambio = $model->idHotel->tipo_cambio;
				}else if($model->idTarifa->tipo_cambio == 2){
					$model->tipo_cambio = $model->idTarifa->tasa_cambio;
				}
				$model->saldo = round($model->total_tc * $model->tipo_cambio,2);
				$model->saldo = $model->saldo - ($model->saldo*($model->comision/100));
				// $model->saldo = 0;
			}

			if (empty($datos["rateKey"])) {
				$fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$model->fecha_inicial.'" between fecha_inicio and fecha_final');

				if(!empty($model->idTarifa->fecha_limite) && strtotime($model->fecha_inicial) > strtotime($model->idTarifa->fecha_limite))
				{
					$model->fecha_limite_h = $model->idTarifa->fecha_limite;
					$model->fecha_limite = date('Y-m-d',strtotime($model->idTarifa->fecha_limite.'-2 days'));
					if (strtotime($model->idTarifa->fecha_limite) < strtotime(date('Y-m-d'))) {
								$model->fecha_limite_h = date('Y-m-d');
								$model->fecha_limite = date('Y-m-d');
					}
				}
				else if(!empty($model->idTarifa->fecha_limite_dias)){
					$model->fecha_limite = date('Y-m-d',strtotime($model->fecha_inicial.' -'.($model->idTarifa->fecha_limite_dias + 2).' days'));
					$model->fecha_limite_h = date('Y-m-d',strtotime($model->fecha_inicial.' -'.($model->idTarifa->fecha_limite_dias).' days'));
				}
				else{
					// $fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$model->fecha_inicial.'" between fecha_inicio and fecha_final');
					if(!empty($fechaLimite) && $model->idHotel->Destino->destinationsCode0->code!="HUA"){
						$model->fecha_limite = date('Y-m-d',strtotime($model->fecha_inicial.' -'.($fechaLimite->dias + 2).' days'));
						$model->fecha_limite_h = date('Y-m-d',strtotime($model->fecha_inicial.' -'.($fechaLimite->dias).' days'));
					}
				}

			/*	if (!empty($fechaLimite) && $model->idHotel->Destino->destinationsCode0->code!="HUA") {
				// echo "HUA";
					$model->fecha_limite_h = date('Y-m-d',strtotime($model->fecha_inicial.' -'.$fechaLimite->dias.' days')); 
				}*/


				if( ( !empty($model->fecha_limite) && strtotime($model->fecha_limite) < strtotime(date('Y-m-d')) && empty($model->idTarifa->fecha_limite) ) || empty($model->fecha_limite)  ){
					$hoy=date("Y-m-d");

					$datetime_fecha_inicial=new DateTime($model->fecha_inicial);
					$datetime_hoy=new DateTime($hoy);

					$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);

					$resultado_diferencia_dias= $diferencia->format('%a');

					if($resultado_diferencia_dias<=7 && empty($fechaLimite))
					{
						$fecha_limite=date("Y-m-d",strtotime($hoy));
						$fecha_limite_h=date("Y-m-d",strtotime($hoy));

					}else if($resultado_diferencia_dias>7 && $resultado_diferencia_dias<=15 && empty($fechaLimite))
					{
						$fecha_limite=date("Y-m-d",strtotime($hoy.' +1 days'));		
						$fecha_limite_h=date("Y-m-d",strtotime($hoy.' +2 days'));						

					}else if($resultado_diferencia_dias>15 && $resultado_diferencia_dias<=32 && empty($fechaLimite))
					{
						$fecha_limite=date("Y-m-d",strtotime($hoy.' +2 days'));
						$fecha_limite_h=date("Y-m-d",strtotime($hoy.' +3 days'));

					}else if($resultado_diferencia_dias>32 && empty($fechaLimite))
					{
						$fecha_limite=date("Y-m-d",strtotime($model->fecha_inicial.' -31 days'));
						$fecha_limite_h=date("Y-m-d",strtotime($model->fecha_inicial.' -30 days'));

					}elseif ( !empty($fechaLimite) && strtotime($model->fecha_inicial.' -'.$fechaLimite->dias.' days') < strtotime(date('Y-m-d')) ) {

						$fecha_limite=date("Y-m-d",strtotime($hoy));	
						$model->fecha_limite_h=date("Y-m-d",strtotime($hoy));
					}

					if($fecha_limite<=$hoy)
						$fecha_limite=$hoy;


					if (empty($fechaLimite)) {
						$model->fecha_limite_h = $fecha_limite_h;
					}

					$model->fecha_limite = $fecha_limite;
					if ($outletEstatus) {
						$fecha_limite_outlet=$outletControl[0]->fechalimiteOutlet($model->id_hotel,$model->fecha_inicial,0,null,date("Y-m-d",strtotime($model->fecha_limite)));
						$model->fecha_limite= implode('-',array_reverse(explode('/', $fecha_limite_outlet)));
					}
				}

			}else{
				switch ($model->idHotel->proveedor) {
					case 1:
						$avisoCancelacion="";
						$busquedaController = Yii::app()->createController('busqueda');
						$busquedaController = $busquedaController[0];
						$markup = Api::model()->findByPk(1)->markup;
						$TotalN = 0;

						foreach (json_decode(base64_decode($datos['rateKey'])) as $rK => $rateKey) 
						{
							$requestCheckrate=array();
							$requestCheckrate["rateKey"]= $rateKey;	
							$responseCheckrate=$this->consultarCheckrates(json_encode($requestCheckrate));

							$arrayCheckrate=json_decode($responseCheckrate);

							$tipohab = TipoHabitaciones::model()->find('codigo="'.$arrayCheckrate->hotel->rooms[0]->code.'" AND id_hotel='.$model->id_hotel);

							$descripcionHabitacion=(strlen($tipohab->descripcion)>0)?$tipohab->descripcion:$tipohab->tipo_habitacion;

							$responsePoliticas=$busquedaController->politicasCancelacion($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies,$model->fecha_inicial,$markup,$descripcionHabitacion,$rK,$moneda,false);

							$avisoCancelacion.=$responsePoliticas["politicasCancelacion"];

							if($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies)
							{

								$fecha_limite=substr($responsePoliticas["fecha_limite"],0,10);

								$fecha_limite_h=date('Y/m/d H:i:s',strtotime($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies[0]->from));

								$model->fecha_limite=implode('-',array_reverse(explode('/',$fecha_limite)));
								$model->fecha_limite_h=$fecha_limite_h;

							}else
							{
								// echo $model->fecha_limite=date("Y-m-d");
								$model->fecha_limite=date("Y-m-d");
							}

							if($arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments)
								$rateComments[$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments;
							if($arrayCheckrate->hotel->rooms[0]->rates[0]->offers)
								$offers[$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->offers;
							$TotalN+=$arrayCheckrate->hotel->totalNet/$markup;

						}
						$model->fecha_limite;
						$datos['politicas_cancelacion']=$avisoCancelacion;
						if ($TotalN>0) {
							if((string)(round($TotalN,2)) != (string)(round($model->total,2))){ 
								$model->total = $TotalN; 
							}
						}
						break;
					case 2:
						$ratePlan_data=json_decode(base64_decode($datos["ratePlan"]));

						$datetime_hoy=new DateTime(date("Y-m-d"));
						$dias_fecha_limite=$ratePlan_data->CancelPenalties->CancelPenalty->DeadLine->OffsetUnitMultiplier;
						$datetime_fecha_inicial=new DateTime(date("Y-m-d",strtotime($model->fecha_inicial)));
						$datetime_fecha_limite=new DateTime(date("Y-m-d",strtotime($model->fecha_inicial.' - '.$dias_fecha_limite)));

						$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);

						$resultado_diferencia_dias=$diferencia->format('%a');

						if($dias_fecha_limite<=$resultado_diferencia_dias)
						{
							$model->fecha_limite_h=date("Y-m-d H:i:s",strtotime($model->fecha_inicial.' -'.($dias_fecha_limite).' days'));                    	
						}else
						{							
							$model->fecha_limite_h=date("Y-m-d H:i:s");
						}

						if ($ratePlan_data->CancelPenalties->CancelPenalty->DeadLine==null) {
							$model->fecha_limite_h = date("Y-m-d H:i:s");
							$model->fecha_limite = date("Y-m-d H:i:s");
						}



						// $model->fecha_limite=$reservaApis->fechaLimite($resultado_diferencia_dias, $model->fecha_limite_h );
						// $model->fecha_limite=date('Y-m-d H:i:s', strtotime($datos['fecha_limite']));
						if (empty($model->fecha_limite)) {
							$model->fecha_limite= $datos['fecha_limite'];
						}
						break;
					case 3:
						$model->fecha_limite=implode('-',array_reverse(explode('/',$datos['fecha_limite'])));
						$model->fecha_limite_h=implode('-',array_reverse(explode('/',$datos['fecha_limite_h'])));
						break;
					case 4:
						//$model->fecha_limite=date('Y-m-d H:i:s', strtotime($datos['fecha_limite']));
						$model->fecha_limite=implode('-',array_reverse(explode('/',$datos['fecha_limite'])));
						$model->fecha_limite_h=$datos['fecha_limite_h'];
						$avisoCancelacion= $datos['politicas_cancelacion'];
						break;
					case 5:
						$fechaH= $datos['fecha_limite_h'];
						$model->fecha_limite_h = $fechaH; 
						$model->fecha_limite=$datos["fecha_limite"];
						// $model->fecha_limite=implode('-',array_reverse(explode('/',$datos['fecha_limite'])));
						break;
					case 6:
						$fechaLimite =implode('-',array_reverse(explode('/',$datos['ratePlan'])));
						$fechaH = $datos['fecha_limite_h'];
						$model->fecha_limite = $fechaLimite;
						$model->fecha_limite_h = $fechaH;
						break;
					default:
						$model->fecha_limite_h=$datos['fecha_limite_h'];
						break;
				}
			}
			
			$model->desglose_rate = "";
			if (empty($model->id_bloqueo)) {
				if(empty($datos['rateKey']))
				{
					$model->politicas_cancelacion = $this->cancelaciones($model,$model->fecha_inicial,$model->id_tarifa);
				}
				else
				{
					$model->politicas_cancelacion=$datos['politicas_cancelacion'];
				}

				if(empty($datos['rateKey']))
				{
				//Checa si tiene allotment, poner codigo
					$fechaInicio = new DateTime($model->fecha_inicial);
					$fechaFinal = new DateTime($model->fecha_final);
					do{
						$allotment = Allotment::model()->find('id_hotel='.$model->id_hotel.' and "'.$fechaInicio->format('Y-m-d').'" between fecha_inicio and fecha_final');
						$fechaInicio->modify('+1 days');
						if(!empty($allotment)){
							$model->code = "W".date('YmdHis');
							break;
						}
					}
					while($fechaInicio < $fechaFinal);
				//Fin chequeo
				}else{
					
					$tipoReservacion = 'Normal';
					//CONEXIONES AL WS SOCIOS ONLINE
					if($datos['rateKey']!="OB")
					{
						switch ($model->idHotel->proveedor) {
							case 1:
							$comisionProveedor=100-($markup*100);
							foreach (json_decode(base64_decode($datos['rateKey'])) as $i_room => $value_rateKey) 
							{
								$bookingResponse=$reservaApis->bookingBedsBanco($value_rateKey,$i_room+1 ,$Reservacion,$tipoReservacion);
								$booking=json_decode($bookingResponse);
								$bookingReference=$booking->booking->reference;
								if(empty($bookingReference)){ echo "Ocurrió un error al intentar hacer la reservacion con el Socio Online"; exit; }
								$bookingReferences.="BR".$bookingReference.",";
							}

							$supplier=$booking->booking->hotel->supplier;
							
							$bookingReferences=trim($bookingReferences, ',');
							$model->code=$bookingReferences;
							$model->manual=2;
							//DESGLOSE COMENTARIOS Y PROMOCIONES DE LA TARIFA
							
							$desglose_rate=array();
							$desglose_rate['currency']=$datos['currency'];
							$desglose_rate['rateClass']=$datos['rate_class'];
							$desglose_rate["supplier"]=array('name'=>$supplier->name, 'vatNumber'=>$supplier->vatNumber);
							
							if($datos['promociones'])
								$desglose_rate['promociones']=base64_decode($datos['promociones']);				
							
							$model->desglose_rate=json_encode($desglose_rate);
							break;
							case 3:
							$comisionProveedor=100-($markup*100);
							$travelSolutionController = Yii::app()->createController('travelSolution');
							$travelSolutionController = $travelSolutionController[0];
							$bookingResponse=$reservaApis->createBookTravelSolution($model,$datos,$Reservacion,$tipoReservacion);
							//echo '<textarea rows="10" cols="50">'.$bookingResponse.'</textarea>';
							$booking=json_decode($bookingResponse);
							$bookingReference=$booking->confirmationid;//validar el estatus internet
							$rooms=$booking->Rooms->Room;
							if (count($rooms)>1) {
								foreach ($rooms as $keyroom => $room) {
									$model->fecha_limite_h = $room->CancellationPolicy->PaymentLimitDay;
								}
								
							}else{

								$model->fecha_limite_h = $rooms->CancellationPolicy->PaymentLimitDay;
								
							}
							if (empty($model->fecha_limite_h) || strtotime($model->fecha_limite_h) <=strtotime(date('Y-m-d'))) {
								$model->fecha_limite_h=date('Y-m-d');
								$model->fecha_limite=date('Y-m-d');
							}
							if(empty($bookingReference) || $bookingReference==0){ echo "Hubo un Error al crear la reserva, la reserva no fue efectuada"; exit; }

							$comision_hotel = Api::model()->findByPk(6)->markup;
							$model->saldo_h = $this->saldoHotel($model->total,$comision_hotel,"Api");
							
							$model->code="TS".$bookingReference;
							$model->manual=2;

							$codigo_hotel=explode("/",$model->idHotel->codigo)[0];
							$hotelSocioOnline=$travelSolutionController->searchHotelTS($codigo_hotel);

							$desglose_rate=array();
							$desglose_rate['currency']=$booking->currency;
							$desglose_rate['operatorname']=$booking->operatorname;
							$desglose_rate['operatoremail']=$booking->operatoremail;
							
							if(!is_object($hotelSocioOnline->AdditionalCharges))
							{
								$hotelSocioOnline->AdditionalCharges=strip_tags($hotelSocioOnline->AdditionalCharges);
								$desglose_rate['additionalCharges']=ucfirst($hotelSocioOnline->AdditionalCharges);
							}	        	
							
							if($_POST['promociones'])
								$desglose_rate['promociones']=base64_decode($_POST['promociones']);				
							
							$model->desglose_rate=json_encode($desglose_rate);

							// $fotos = HotelesFotos::model()->findAll('id_hotel='.$model->id_hotel.' and logotipo=1 and foto LIKE "'.$hotelSocioOnline->Image.'"');
							// if(count($fotos)==0)
							// {			
							// 	$foto = new HotelesFotos;
							// 	$foto->id_hotel=$model->id_hotel;
							// 	$foto->foto=$hotelSocioOnline->Image;
							// 	$foto->logotipo=1;

							// 	if(!$foto->save())
							// 		print_r($foto->getErrors());

							// }
							
							break;
							case 4:
							$riuController=Yii::app()->createController('riu');
							$riuReservacion=$reservaApis->bookingRiuBanco($datos,$Reservacion,$tipoReservacion);
						//$riuReservacion=json_decode($riuReservacion);
							$comisionProveedor=20;
							$reservacion=json_decode($riuReservacion)[0];
							if (empty($reservacion->HotelResResponse->out->customerReservationCode) && empty($reservacion->HotelResResponse->out->hotelReservationCode) && $reservacion->HotelResResponse->out->state!="OK") {
								echo "Hubo un Error al crear la reserva, la reserva no fue efectuada";
								exit;
							}

							$comision_hotel = Api::model()->findByPk(7)->markup;


							$saldo_hotel = $this->saldoHotel($model->total,20,"comision");
							$model->saldo_h = $saldo_hotel;
							$model->code="RI".$reservacion->HotelResResponse->out->customerReservationCode."-".$reservacion->HotelResResponse->out->hotelReservationCode."-".$reservacion->HotelResResponse->out->hotelReservationID;
							break;
							case 5:
							$comisionProveedor=$model->idHotel->comision;
							$codigoHotel=explode('/', $model->idHotel->codigo);
							if (!in_array($model->id_hotel,array(177912,177889))) {
								
								$dingusReservacion=$reservaApis->bookingDingusBanco($model->idHotel->Cadena->url_dingus, $datos, $Reservacion,$tipoReservacion);
								$hotelResID=$dingusReservacion['OTA_HotelResRS']['HotelReservations']['HotelReservation']['ResGlobalInfo']['HotelReservationIDs']['HotelReservationID']['@attributes']['ResID_Value'];
								
							}else{
								$hotelResID="ESPECIAL-2020";


							}

							if (empty($hotelResID)) {
								echo "Hubo un Error al crear la reserva, la reserva no fue efectuada";
								exit;
							}

							$comision_hotel = $model->idHotel->comision;
							$saldo_hotel = $this->saldoHotel($model->total,$comision_hotel,"comision");
							$model->saldo_h = $saldo_hotel;
							//$model->code="DI";
							$model->code="DI-".$hotelResID;
							$model->politicas_cancelacion=$datos['politicas_cancelacion'];
							break;
							case 6:
								$comision_hotel = Api::model()->findByPk(9)->markup;
								$saldo_hotel = $this->saldoHotel($model->total,$comision_hotel,"Api");
								$model->saldo_h = $saldo_hotel;
							break;
							default:
							# code...
							break;
						}
					}else{

						$comisionProveedor=$model->idHotel->comision;
						$codeHotel=  explode("/",Hoteles::model()->findByPk($model->id_hotel)->codigo);				
						$return=$reservaApis->bookingOmniBeesBanco($codeHotel[0],$datos,$Reservacion,$tipoReservacion);
						$array=json_decode($return);
						$bookingReference=$array->SendHotelResResult->HotelReservationsType->HotelReservations->HotelReservation->UniqueID->ID;
						if(empty($bookingReference)){ echo $return; exit; }
						$model->code="OB".$bookingReference;
						$model->manual=2;
						$model->saldo_h=$this->saldoHotel($model->total, $comisionProveedor,"comision");
					}

				}

			}


			
			if($outletEstatus && $model->idHotel->proveedor==0)

			{
				

				if($model->code=="")
				{
					$model->code="RMT-OUTLET".date('Y-m-d');
				}
			}
			
			if (!empty($datos['tarifa_neta']) || !empty($datos['total_neto'])) {
				if ($model->idHotel->proveedor!=4) {
					$model->saldo_h = !empty($datos['tarifa_neta']) ? $datos['tarifa_neta'] : $datos['total_neto'];
				}else{
					$model->saldo_h = $this->saldoHotel($datos['total_neto'],20,"comision");
				}
			}
			$model->tarifa_agencia=$model->saldo;
			$model->tarifa_neta=$model->saldo_h;
			$model->moneda=$_POST['Reservacion']['moneda'];

			if($model->save())
			{
				if (!empty($_POST['referencia'])) {

					$logBanco=LogBanco::model()->find('reference="'.$_POST['referencia'].'" and id_recibo=0');
					if (!empty($logBanco)) {
					$logBanco->id_recibo=$model->id_reservacion;
					$logBanco->save();
					}
				}
				if($_SESSION['ecomerce']['tipo_pago']>7)
				{
					$recibo = new Recibo;
					$importeComision = $_SESSION['ecomerce']['importe']*($_SESSION['ecomerce']['comisionBancomer']/100);
					$recibo->id_tipo = $_SESSION['ecomerce']['tipo_pago'];
					$recibo->id_planpago = $_SESSION['ecomerce']['planPago'];
					$recibo->id_banco = 2;
					$recibo->id_cuenta = 16;
					$recibo->importe =  $_SESSION['ecomerce']['importe'];
					$recibo->id_agencia = $model->id_agencia;
					$recibo->comision =  $_SESSION['ecomerce']['comisionBancomer'];
					$recibo->id_user = Yii::app()->user->getId();
					$recibo->observaciones = "PAGO REALIZADO CON BANCOMER POR SISTEMA DE RESERVACIONES. TIPO DE TARIFA".$_SESSION['ecomerce']['tipo_tarifa'];
					if($recibo->save()){
						$detalle = new ReciboDetalles;
						$detalle->id_recibo = $recibo->id_recibo;
						$detalle->id_reservacion = $model->id_reservacion;
						$detalle->concepto = "Pago Total Reserva #".$model->id_reservacion." Pax: ".$model->nombre_cliente." - Hotel: ".$model->idHotel->nombre_hotel." - ".$model->num_habitaciones." Hab(s).";
						$detalle->importe =   $_SESSION['ecomerce']['importe'];

						if($detalle->save())
						{
							$model->saldo = ($detalle->importe +  $importeComision) - $model->total_tc;
							$model->save();
						}
						$notificar = Usuarios::model()->findAll('aviso LIKE "%r%"');
					}
				}

				$broker=explode('-', $model->code);
				$BR=$broker[0];
				$beds=$BR[1].$BR[0];
				$m=0;
				for($i=1;$i<=$model->num_habitaciones;$i++)
				{
					if($_POST['Habitacion_'.$i] != NULL)
					{
						if ($model->idHotel->proveedor==4||$model->idHotel->proveedor==5) {
							$Reservacion['habitacion_'.$i]['id_tipo_habitacion']=$Reservacion['habitacion_1']['id_tipo_habitacion'];
						}
						$habitacion=new ReservacionDesglose;
						$habitacion->attributes=$Reservacion['Habitacion_'.$i];
						$habitacion->id_reservacion = $model->id_reservacion;
						$habitacion->precio_adulto = 0;
						$habitacion->precio_ninio = 0;
						$desgloseB["desglose"]=array();
						for($d=0;$d<$model->num_noches;$d++)
						{
							array_push($desgloseB["desglose"], array("noche"=>$cotizacion[$m][$d][0][$i]['fecha'], "precio_adulto"=>$cotizacion[$m][$d][0][$i]['adultos'],"precio_menor"=>$cotizacion[$m][$d][0][$i]['menores']));
							$desgloseB["desglose"][$d]["precioPorMenor"]=array();
							for ($p=0; $p < $datos['front_form']['habitacion_'.$i]['num_ninios']; $p++) 
							{
								array_push($desgloseB["desglose"][$d]["precioPorMenor"],$cotizacion[$m][$d][0][$i][$p]);
							} 
						}

						$reference=explode(",", $model->code);
						$desgloseB["desglose"]["reference"]=$reference[$i-1];
						$desgloseB["desglose"]["planHotel"]=$datos['boardName'];

						if($_POST['rateComments_'.$i])
							$desgloseB["desglose"]['rateComments']=$_POST['rateComments_'.$i];

						if($_POST['offers_'.$i])
						{
							$desgloseB["desglose"]['offers']=array();
							foreach(json_decode($_POST['offers_'.$i]) as $offer)
							{
								$importeOferta=$offer->amount/$markup;
								array_push($desgloseB["desglose"]['offers'], array("code"=>$offer->name, "name"=>$offer->name,"amount"=>$importeOferta));		            		
							}
						}
						$tipoReservacion = "Normal";
						if(!empty($_POST['rateKey']))                  	
							$desgloseBeds=json_encode($desgloseB);
						else
						$desgloseBeds="";
						$habitacion->desgloseBeds=$desgloseBeds;
						if($model->manual == 0 && empty($model->id_bloqueo) && !empty($this->palaceResorts[$model->idHotel->codigo]))
						{
							if (!$outletEstatus) {
								$wsResponse = $reservaApis->palaceWsBanco($model,$habitacion,$i,$Reservacion,$tipoReservacion,$_POST['Adulto_1_'.$i]["nombre"],$_POST['Adulto_1_'.$i]["apellido"]);
							}
							$comisionProveedor=20;
							if(empty($wsResponse['error'])){
								$comision_hotel = Api::model()->findByPk(9)->markup;
								$saldo_hotel = $this->saldoHotel($model->total,$comision_hotel,"Api");
								$model->saldo_h = $saldo_hotel;

								// $model->saldo_h=$this->saldoHotel($model->total, $comisionProveedor);
								$model->code .= "WS".$wsResponse['folio'];
								$model->save();
							}
							else{
								$model->delete();
								throw new CHttpException(500,$wsResponse['error']);
							}
						}

						if($habitacion->save())
						{
							for($a=1;$a<=$habitacion->num_adultos;$a++)
							{
								$adulto=new ReservacionDesglosePersona;
								$adulto->nombre=$_POST['Adulto_'.$a.'_'.$i]["nombre"]." ".$_POST['Adulto_'.$a.'_'.$i]["apellido"];
								$adulto->tipo = 'A';
								$adulto->edad = 30;
								$adulto->id_desglose = $habitacion->id_desglose;
								$adulto->id_reservacion = $model->id_reservacion;
								$adulto->save();
							}
							for($n=1;$n<=$habitacion->num_ninios;$n++){ //Ordenar edades menores mayor a menor
								if($_POST["Ninio_".$n."_".$i.""]["edad"] < $_POST["Ninio_".($n+1)."_".$i.""]["edad"]){
									$aux = $_POST["Ninio_".$n."_".$i.""]["edad"];
									$aux2 = $_POST["Ninio_".$n."_".$i.""]["nombre"];
									$aux3 = $_POST["Ninio_".$n."_".$i.""]["apellido"];
									$_POST["Ninio_".$n."_".$i.""]["edad"] = $_POST["Ninio_".($n+1)."_".$i.""]["edad"];
									$_POST["Ninio_".$n."_".$i.""]["nombre"] = $_POST["Ninio_".($n+1)."_".$i.""]["nombre"];
									$_POST["Ninio_".$n."_".$i.""]["apellido"] = $_POST["Ninio_".($n+1)."_".$i.""]["apellido"];
									$_POST["Ninio_".($n+1)."_".$i.""]["edad"] = $aux;
									$_POST["Ninio_".($n+1)."_".$i.""]["nombre"] = $aux2; 
									$_POST["Ninio_".($n+1)."_".$i.""]["apellido"] = $aux3;
									$n=0;
								}
							}
							for($n=1;$n<=$habitacion->num_ninios;$n++)
							{
								$ninio=new ReservacionDesglosePersona;
								$ninio->attributes=$_POST['Ninio_'.$n.'_'.$i];
								$ninio->tipo = 'N';
								$ninio->nombre = $_POST['Ninio_'.$n.'_'.$i]['nombre'].' '.$_POST['Ninio_'.$n.'_'.$i]['apellido'];
								$ninio->id_desglose = $habitacion->id_desglose;
								$ninio->id_reservacion = $model->id_reservacion;
								$ninio->save();
							}
						}else
						{
							print_r($habitacion->getErrors());
						}

					}	
				}

				if (!empty($_POST['id_cupon_aplicado'])) {
					# code...
					$update_cupon = CuponesAgencias::model()->find('id_agencia='.$model->id_agencia.' AND id_cupon='.$_POST['id_cupon_aplicado']);
					// $update_cupon = CuponesAgencias::model()->findByPk($_POST['id_cupon_aplicado']);
					$update_cupon->id_reservacion = $model->id_reservacion;
					$update_cupon->estatus = 1;
					$update_cupon->save();
				}

				$notificar = Usuarios::model()->findAll('aviso LIKE "%r%"');
				foreach($notificar as $user){
					$notificacion = new Notificacion;
					$notificacion->id_item = $model->id_reservacion;
					$notificacion->tipo = 2;
					$notificacion->id_users = $user->id_usuario;
					$notificacion->visto = 0;
					$notificacion->save();
				}
				
				
				$this->enviaEmail($model);
				$operacion = Yii::app()->createController('operacionesLog');
				$operacion = $operacion[0];
				$operacion->Create($model->id_reservacion,3);

				$logHotelbeds['header'] = "bookingRMT";
				$logHotelbeds['request'] = json_encode($_POST);
				$logHotelbeds['response'] = CJSON::encode($model);
				$logHotelbeds['reference'] = $model->id_reservacion;
				$this->guardarLogRMT($logHotelbeds,'RMT');
				echo CJSON::encode(array('cupon'=>$model->id_reservacion));
				exit;
				// if(isset($_POST['carrito'])){
				// 	if(empty($_SESSION['pagado'])){
				// 		$logHotelbeds['header'] = "bookingRMT";
				// 		$logHotelbeds['request'] = json_encode($_POST);
				// 		$logHotelbeds['response'] = CJSON::encode($model);
				// 		$logHotelbeds['reference'] = $model->id_reservacion;
				// 		$this->guardarLogRMT($logHotelbeds,'RMT');
				// 		echo CJSON::encode(array('cupon'=>$model->id_reservacion));
				// 		exit;
				// 	}else{
				// 		$logHotelbeds['header'] = "bookingRMT1";
				// 		$logHotelbeds['request'] = json_encode($_POST);
				// 		$logHotelbeds['response'] = CJSON::encode(array('cupon'=>$model->id_reservacion));
				// 		$logHotelbeds['reference'] = $model->id_reservacion;
				// 		$this->guardarLogRMT($logHotelbeds,'RMT');

				// 		unset($_SESSION['itemcarrito'],$_SESSION['pagado']);
				// 		echo CJSON::encode(array('cupon'=>$model->id_reservacion));
				// 		exit;
				// 	}
				// }else if(isset($_POST['roomlist'])){
				// 	$logHotelbeds['header'] = "bookingBloqueo";
				// 	$logHotelbeds['request'] = json_encode($_POST);
				// 	$logHotelbeds['response'] = 'error en bloqueo';
				// 	$logHotelbeds['reference'] = $model->id_reservacion;
				// 	$this->guardarLogRMT($logHotelbeds,'RMT');

				// 	$roomlistHabs = explode(',',$_POST['roomlist']);
				// 	for($i=0;$i<count($roomlistHabs);$i++)
				// 	{
				// 		$roomlistRow = Roominglist::model()->find('id_bloqueo='.$model->id_bloqueo.' and habitacion='.$roomlistHabs[$i]);
				// 		$roomlistRow->id_reservacion = $model->id_reservacion;
				// 		$roomlistRow->id_agencia = $model->id_agencia;
				// 		$roomlistRow->save();
				// 	}
				// 	$this->redirect(array('bloqueos/view','id'=>$model->id_bloqueo));
				// }else{
				// 	$logHotelbeds['header'] = "bookingRMT2";
				// 	$logHotelbeds['request'] = json_encode($_POST);
				// 	$logHotelbeds['response'] = CJSON::encode(array('cupon'=>$model->id_reservacion));
				// 	$logHotelbeds['reference'] = $model->id_reservacion;
				// 	$this->guardarLogRMT($logHotelbeds,'RMT');

				// 	echo CJSON::encode(array('cupon'=>$model->id_reservacion));
				// 	exit;
				// }
			

			} ### fin de model->save
			else
			{
				$logHotelbeds['header'] = "bookingRMT";
				$logHotelbeds['request'] = json_encode($_POST);
				$logHotelbeds['response'] = "{errors:".CJSON::encode($model->getErrors())."}";
				$logHotelbeds['reference'] = 0000;
				$this->guardarLogRMT($logHotelbeds,'RMT');
				//print_r($model->getErrors());
			}

		} #### fin de if $_post["reservacion"]
		
	}
	
	public function guardarLogRMT($data, $ws){
		$data['header']='book';
		$idlogws=$this->logWsRequest($data,$ws);
		$this->logWsResponse($idlogws,$data);
	}

	// reemplaza a agregarcarritobeds
	public function createDesgloses($generales,$datosApi,$front_form,$resultadosBusqueda,$proveedor,$roomRates){
		$session=new CHttpSession;
		$session->open();

		$outletController = Yii::app()->createController('outlet');
		$outletController = $outletController[0];
		$outlet=Outlet::model()->find("estatus=1");
		$tarifaOutlet=$outletController->validacionTarifas($outlet);
		$hotelesObOutlet=$outletController->hotelesOutlet($generales['id_hotel'],$proveedor,'');
		$datos=array(); 
		$menorgratis=0;
		$error=NULL; 
		$num_habitaciones=$front_form['habs'];
		$markupPalace=Api::model()->findByPk(9);
		$Total = $generales['precio'];

		// array que reemplazaran a las sesiones
		$cotizacion = array();			
		$datos=array();
		$countCotiz=array();
		$total_noche = array();
		$totalCotiz = array();

		// sesiones actuales
		$_SESSION['Cotizacion'] = array();			
		$_SESSION['Datos'] = array();
		$_SESSION['CountCotiz'] = 0;
		$_SESSION['Total_noche']=array();
		$sup = Yii::app()->createController('reservacion');
		$sup = $sup[0];
		
		$hotel = Hoteles::model()->findByPk($generales['id_hotel']);

		$id_tipo_plan=$generales['id_plan'];

		if ($proveedor==2) {
			$rateKey = 'OB';
			$id_tipo_habitacion = $generales['id_habitacion'];
		}elseif ($proveedor==1) {
			$rateKey = base64_encode($datosApi['rateKey']);
			$id_tipo_habitacion = $datosApi['hab'];
			$promocionesBeds = $this->promocionesBeds($datosApi['promociones']);
			$datosApi['promociones'] = base64_encode($promocionesBeds);
		}elseif ($proveedor==6) {
			$rateKey = "PL";
			$id_tipo_habitacion = $generales['id_habitacion'];
		}elseif ($proveedor==3) {
			$rateKey = $datosApi['rateKey'];
			$id_tipo_habitacion = $datosApi['hab'];
			$resultHotel = explode('|',base64_decode($roomRates));
			$datosApi['promociones'] = base64_encode($datosApi['promociones']);
		}

		if ($proveedor!=3) {
			$datosApi["roomType"] = base64_encode($datosApi['roomType']);
		}


		array_push($datos,array(
					'rateKey'=>$rateKey,
					'desglose'=>null,
					// 'total'=>$generales["precio"],
					'total'=>null,
					'id_hotel'=>$generales["id_hotel"],
					'hotel'=>$generales["nombre_hotel"],
					'tarifa'=>0,
					'id_plan'=>$generales["id_plan"],
					'boardName'=>$generales["tipo_plan"],
					'fecha_inicio'=>date('d/m/Y',strtotime($resultadosBusqueda['fecha_inicial'])),
					'fecha_final'=>date('d/m/Y',strtotime($resultadosBusqueda['fecha_final'])),
					'noches'=>$resultadosBusqueda['noches'],
					'id_tipo_habitacion'=>$id_tipo_habitacion,
					'fecha_limite_h'=>null,
					'front_form'=>$front_form,
					'menorgratis'=>$menorgratis,
					'fecha_cotiza'=>date('Y-m-d H:i:s'),
					'roomRate'=>$datosApi['roomrates'],
					'ratePlan'=>$datosApi['ratePlan'],
					'roomType'=>$datosApi['roomType'],
					'totalRate'=>base64_encode($datosApi['totalRate']),
					'promociones'=>$datosApi['promociones'],
					'currency'=>$generales['moneda'],
					'rate_class'=>$datosApi['rate_class'],
					'politicas_cancelacion'=>$datosApi['politicas_cancelacion'],
					'tarifa_neta'=>$datosApi['precio_neto']
				)
		);


		if ($proveedor==2) {
			$ratePlanID=json_decode(base64_decode($datosApi['ratePlan']));
			$roomID=json_decode(base64_decode($datosApi['roomType']));
			$roomsRate=json_decode(base64_decode($roomRates));


			$keysRates = array_keys((array)$roomsRate);
			$rates=count($roomsRate);
			$markupHotel = $hotel->comision;
			$precioOB = $this->convertToFloat($generales["precio"]);
			$totalNeto=(int)($precioOB-($precioOB*($markupHotel/100)));

			// if ($tarifaOutlet) {
				$totalNeto=(int) $datosApi['precio_neto'];
			// }

			if ($markupHotel) {
				$markup=((100-$markupHotel)/100);
			}else{

				$markup = Api::model()->findByPk(4)->markup;
			}

			$tipoCambio=1;
			$iva=1;
			$taxvalue=0;

			// if(count($ratePlanType)>1){
			// 	$RateplanType=$ratePlanType[0];
			// }else{
			// 	$RateplanType=$ratePlanType;
			// }

			$taxkey=array_keys($ratePlanID->TaxPolicies->TaxPolicy);

			// if(is_numeric($taxkey[0])){
			// 	foreach ($ratePlanID->TaxPolicies->TaxPolicy as $key => $tax) {
			// 		$taxvalue+=(int)$tax->Value;
			// 	}
			// }else{
			// 	$taxvalue=$ratePlanID->TaxPolicies->TaxPolicy->Value;
			// }
			$impuestoAmbiental = 0;
			if(count($ratePlanID->TaxPolicies->TaxPolicy)>1){
				foreach ($ratePlanID->TaxPolicies->TaxPolicy as $key => $tax) {
					if ($tax->Value==16 || $tax->Value==19 || $tax->Value==3) {	
						$taxvalue+=(int)$tax->Value;
					}else {	
						$impuestoAmbiental=$tax->Value;
					}
				}
			}else{
				$taxvalue=$ratePlanID->TaxPolicies->TaxPolicy->Value;
			}

			if($ratePlanID->TaxPolicies!=NULL)
			{
				$iva=($taxvalue/100)+1;
			}else{
				$iva=1;
			}
		}

		if ($proveedor==6) {
			$fechalimiteh = null;

			$fechalimiteh = null;
			if (!empty($datosApi['fecha_limite_h'])) {
				$fechalimiteh=date('Y-m-d H:i:s', strtotime($datosApi['fecha_limite_h']));
			}
			
			$fechalimiteh=date('Y-m-d H:i:s', strtotime($datosApi['fecha_limiteH']));

			// $_SESSION['Datos'][0]['fecha_limite_h'] = $fechalimiteh;
			$datos[0]['fecha_limite_h'] = $fechalimiteh;
		}

		if($proveedor==3) ##TRAVEL SOLUTION
		{
			$travelSolution = Yii::app()->createController('travelSolution');
			$travelSolution = $travelSolution[0];

			$siteController = Yii::app()->createController('site');
			$siteController = $siteController[0];

			$code=$generales["code_hotel"];

			$responseTS=json_decode($siteController->tarifasTravelSolution(array(0=>$code),true,$front_form));

			$ratePlan=json_decode(base64_decode($datosApi['ratePlan']));
			$roomType=json_decode(base64_decode($datosApi['roomType']));

			$responseTS = $responseTS->Hotels->Hotel;

			if(count($responseTS->Rooms->Room)>1)
			{
				$ahotelTS=json_decode(json_encode($responseTS),true);
				$arrHotel=$ahotelTS["Rooms"]["Room"];
				$key = array_search($roomType->Id, array_column($arrHotel, 'Id'));
			}else
			{
				if($responseTS->Rooms->Room->Id==$roomType->Id)
				{
					$key=$responseTS->Rooms->Room;
				}else
				{
					$key=false;
				}
			}

			if ($key === false) {
				$responseTS=json_decode($siteController->tarifasTravelSolution(array(0=>$code),false,$front_form));
				$responseTS = $responseTS->Hotel;

				if(count($responseTS->Rooms->Room)>1)
				{
					$ahotelTS=json_decode(json_encode($responseTS),true);
					$arrHotel=$ahotelTS["Rooms"]["Room"];
					$key = array_search($roomType->Id, array_column($arrHotel, 'Id'));
				}else
				{
					if($responseTS->Rooms->Room->Id==$roomType->Id)
					{
						$key=$responseTS->Rooms->Room;
					}else
					{
						$key=false;
					}
				}
			}

			if($key===false){
				$roomType=false;
			}
			else{     
				if(count($responseTS->Rooms->Room)>1)
				{   
					$roomType=$responseTS->Rooms->Room[$key];
				}else
				{
					$roomType=$key;
				}
			}

			$datos[0]['roomType'] = base64_encode(json_encode($roomType));

			$modelTS=Api::model()->findByPk(6);
			$parametrosTS=json_decode($modelTS->params);

			$clave_afiliado=$parametrosTS->clave_afiliado;
			$ip="MX";
			$currency=$resultHotel[0];
			$destino=$resultHotel[1];
			$lenguage="ESP";
			$fecha_ini=explode("/", $front_form['fecha_ini']);
			$fecha_fin=explode("/", $front_form['fecha_fin']);
			$star_date=$fecha_ini[2].$fecha_ini[1].$fecha_ini[0];
			$end_date=$fecha_fin[2].$fecha_fin[1].$fecha_fin[0];
			$codigo_hotel=$resultHotel[2];
			$id_interfaceType=$resultHotel[3];
			$datos[0]['fecha_limite_h']=substr($datosApi['fecha_limiteH'],0,10);
			$_SESSION['fecha_limite_h']=substr($datosApi['fecha_limiteH'],0,10);
		}

		$n=0;
		$tarifas_diaria=json_decode(base64_decode($datosApi['tarifadiaria']));

		$rph=0;
		$costoH=0;
		
		for($i=1;$i<=$num_habitaciones;$i++)
		{
			$adultos=$front_form['habitacion_'.$i]['adultos'];				
			$menores=$front_form['habitacion_'.$i]['num_ninios'];

			if ($proveedor==2) {
				for($r=0; $r < $rates; $r++)
				{
					// if($rates>1){
					// 	$rate=$roomsRate[$r];
					// }
					// else{
					// 	$rate=$roomsRate;
					// }
					
					if (is_numeric($keysRates[0])) {
						$rate=$roomsRate[$r];

					}else{
						$rate=$roomsRate;
					}
					
					$neto=(int)$rate->Total->AmountAfterTax;


					if ($num_habitaciones==1) {
						if($rate->RatePlanID==$ratePlanID->RatePlanID && $rate->RoomID==$roomID->RoomID && $rph==$rate->RoomStayCandidateRPH && $neto==$totalNeto)
						{
							$datos[0]['roomRates'][$i]=json_encode($rate);
						}				    		
					}else{
						if($rate->RatePlanID==$ratePlanID->RatePlanID && $rate->RoomID==$roomID->RoomID && $rph==$rate->RoomStayCandidateRPH)
						{
							$datos[0]['roomRates'][$i]=json_encode($rate);

						}	
					}
				}
				$rph++;
			}

			if($proveedor==3)#TRAVELSOLUTION
			{

				$pax.="r1a=".$adultos."&";
				$pax.="r1k=".$menores."&";
				for ($j=1; $j <=$menores; $j++) 
				{
					$pax.="r1k".$j."a=".$front_form["habitacion_".$i]["edad_".$j]."&";
				}	
				$pax = trim($pax, '&');

				$request="a=".$clave_afiliado."&co=".$ip."&c=".$currency."&d=".$destino."&l=".$lenguage."&rk=".$datos[0]['rateKey']."&sd=".$star_date."&ed=".$end_date."&h=".$codigo_hotel."&ci=".$ratePlan->Contract."&mi=".$ratePlan->MarketId."&it=".$id_interfaceType."&ri=".$roomType->Id."&mp=".$ratePlan->Id."&".$pax;

					// echo $request;

				$responseDesgloseTarifa=json_decode($travelSolution->consultarDesgloseTarifa($request),true);
					// echo '<textarea rows="10" cols="50">'.json_encode($responseDesgloseTarifa).'</textarea>';
				$desgloseTarifa=$responseDesgloseTarifa["HotelRate"]["Rooms"]["Room"]["MealPlans"]["MealPlan"]["NightsDetail"]["NightlyRate"];

				if(!$desgloseTarifa[0])
				{
					$responseDesgloseTarifa["HotelRate"]["Rooms"]["Room"]["MealPlans"]["MealPlan"]["NightsDetail"]["NightlyRate"]=array();
					$responseDesgloseTarifa["HotelRate"]["Rooms"]["Room"]["MealPlans"]["MealPlan"]["NightsDetail"]["NightlyRate"][0]=$desgloseTarifa;
				}

				$_SESSION['Datos'][0]['roomRates'][$i]=json_encode($responseDesgloseTarifa["HotelRate"]["Rooms"]["Room"]["MealPlans"]["MealPlan"]);
				$datos[0]['roomRates'][$i]=json_encode($responseDesgloseTarifa["HotelRate"]["Rooms"]["Room"]["MealPlans"]["MealPlan"]);

				$pax="";

			}

			$costoH=0;
			for($d=0;$d<$resultadosBusqueda['noches'];$d++)
			{
				$importeMenor=0;

				switch ($proveedor) {
					case 1:

						$desglose=explode(',',substr($tarifas_diaria[$i-1],0,-1));
						$importeAdulto=$desglose[$d];
						$importeMenor=0;
						$costoH += $importeAdulto + $importeMenor;
						$_SESSION['fecha_limite']=substr($datosApi['fecha_limite'],0,10);
						$datos[0]['fecha_limite']=substr($datosApi['fecha_limite'],0,10);
						break;
					
					case 2:

						$ratesNight=json_decode($datos[0]['roomRates'][$i]);
						if(count($ratesNight->RatesType->Rates->Rate)==1)
						{
							$precioxPxN=$ratesNight->RatesType->Rates->Rate;
						}
						else
						{
							$precioxPxN=$ratesNight->RatesType->Rates->Rate[$d];
						}

						if($menores>0)
						{
							$p=0;
							foreach ($precioxPxN->Total->TPA_Extensions->Rates->Rate as $rate) 
							{
								if($rate->AgeQualifyingCode=='Adult')
								{
									$importeAdulto=(($rate->Total->AmountBeforeTax*$rate->MaxGuestApplicable)*$iva) + $impuestoAmbiental;
								}else
								{
									$MaxGuestApplicable = (($rate->Total->AmountBeforeTax*$rate->MaxGuestApplicable)*$iva) + $impuestoAmbiental;
									$cotizacion[0][$d][0][$i][$p]=$MaxGuestApplicable/$markup;
									if ($tarifaOutlet && !$hotelesObOutlet) {
										$cotizacion[0][$d][0][$i][$p]=($outletController->tarifaOutletVirtual($MaxGuestApplicable,0,$markup,$outlet->descuento_general))*$iva;
									}
									$importeMenor+=(($rate->Total->AmountBeforeTax*$rate->MaxGuestApplicable)*$iva);
									$p++;
								}
							}
						}else
						{
							$importeAdulto=(($precioxPxN->Total->TPA_Extensions->Rates->Rate->Total->AmountBeforeTax*$adultos)*$iva) + $impuestoAmbiental;
							$importeMenor=0;
						}

						$importeAdulto=$importeAdulto/$markup;
						$importeMenor=$importeMenor/$markup;

						if ($tarifaOutlet && !$hotelesObOutlet) {
							$importeAdulto = $outletController->tarifaOutletVirtual($importeAdulto,0,$markup,$outlet->descuento_general);
							$importeMenor = $outletController->tarifaOutletVirtual($importeMenor,0,$markup,$outlet->descuento_general);
						}

						$costoH += $importeAdulto + $importeMenor;

						$fH = explode(' ', $datosApi['fecha_limite']);
						$fechaL= implode('-', array_reverse(explode("/", $fH[0])));
						$horaL = $fH[1];
						$datos[0]['fecha_limite']=date('Y-m-d H:i:s', strtotime($fechaL." ".$horaL));
						$_SESSION['fecha_limite']=date('Y-m-d H:i:s', strtotime($fechaL." ".$horaL));
						$datos[0]['fecha_limite_h']=$datosApi['fecha_limiteH'];
						$_SESSION['fecha_limite_h']=$datosApi['fecha_limiteH'];

					break;
					
					case 3:

						$importeAdulto=$responseDesgloseTarifa["HotelRate"]["Rooms"]["Room"]["MealPlans"]["MealPlan"]["NightsDetail"]["NightlyRate"][$d]["Total"]/$modelTS->markup;
						$importeMenor=0;
						$datos[0]['fecha_limite']=substr($datosApi['fecha_limite'],0,10);
						$_SESSION['fecha_limite']=substr($datosApi['fecha_limite'],0,10);
						$costoH += $importeAdulto + $importeMenor;
					
					break;
					
					case 6:
						$roomRates = array();
						$ratesxNight=json_decode(base64_decode($datos[0]['roomRate']));
						if ($resultadosBusqueda['noches']==1) {
							$roomRatesPl = $ratesxNight[$i-1];
						}else{
							$roomRatesPl = $ratesxNight[$i-1][$d];
						}
						$importeAdulto=$roomRatesPl->Rate/$markupPalace->markup;
						$importemenor=0;
						$costoH += $importeAdulto + $importemenor;
						$datos[0]["fecha_limite"] = $datosApi["fecha_limite"];
						$datos[0]["fecha_limite_h"] = $datosApi["fecha_limiteH"];
					
					break;
					default:
						
					break;
				}
				
				$importeTotal=$importeAdulto+$importeMenor;
				$cotizacion[0][$d][0][$i]['adultos']=number_format($importeAdulto,'2','.',',');
				$cotizacion[0][$d][0][$i]['menores']=number_format($importeMenor,'2','.',',');
				$cotizacion[0][$d][0][$i]['total']=number_format($importeTotal,'2','.',',');
				$cotizacion[0][$d][0][$i]['fecha']=date('d-m-Y',strtotime($resultadosBusqueda['fecha_inicial'].'+'.$d.' day'));
				$_SESSION['politicas_cancelacion']=$datosApi['politicas_cancelacion'];

				$datos[0]['session_PC']['politicas_cancelacion']=$datosApi['politicas_cancelacion'];
				$datos[0]['total']+=$importeTotal;
				if($proveedor==2 || $proveedor==6){
					$datos[0]['total']=$generales["precio"];
				}
			}

			$costoHab[$i]["costoHabitacion"] = $costoH;

			// $totalCotiz[$rph][0]['nombre']=$generales['tipo_plan'];
			// $totalCotiz[$rph][0]['moneda']=$generales['moneda'];
			// $totalCotiz[$rph][0]['restricciones']='';
			// $totalCotiz[$rph][0]['habitaciones'] = $costoHab;

			$totalCotiz[0][0]['nombre']=$generales['tipo_plan'];
			$totalCotiz[0][0]['moneda']=$generales['moneda'];
			$totalCotiz[0][0]['restricciones']='';
			$totalCotiz[0][0]['habitaciones'] = $costoHab;

		}
		$_SESSION["Datos"] = $datos;
		$_SESSION["TotalCotiz"] = $totalCotiz;
		$_SESSION["Cotizacion"] = $cotizacion;

		return array('datos'=>$datos,'totalCotiz'=>$totalCotiz,'cotizacion'=>$cotizacion);

	}

	public function convertToFloat($number){

		return floatval(str_replace(',', '', $number));
	
	}

	public function promocionesBeds($promocionesBeds){
		$promociones.='<table border="1" class="table-tooltip tableInfo"><tbody>';
		foreach ($promocionesBeds as $key => $promos) {
        	$promociones.='<tr><th>'.$promos["descripcion"].'</th></tr>';
            foreach ($promos["promotions"] as $val => $descripcionPromo) {
            	$promociones.='<tr><td>'.$descripcionPromo["nombre"].'.'.$descripcionPromo["descuento"].'</td></tr>';
            }
		}
        $promociones.='</tbody></table>';

        return $promociones;
	}

	public function actionCreateReservacion(){

		$session=new CHttpSession;
		$session->open();
		$model=new Reservacion;
		$this->layout = "//layouts/ansonika_site";
		if(isset($_POST['datos_generales'])){
			//$this->layout = "//layouts/ansonika";
			$datos_generales = mb_convert_encoding(base64_decode($_POST["datos_generales"]),"HTML-ENTITIES", "UTF-8");
			$outletController = Yii::app()->createController('outlet');
			$outletController = $outletController[0];
			$outlet=Outlet::model()->find("estatus=1");
			$tarifaOutlet=$outletController->validacionTarifas($outlet);
			if ($datos_generales==null) {
				$datos_generales  = iconv("Windows-1252","UTF-8", base64_decode($_POST["datos_generales"]));
			}
			$datos_generales = json_decode($datos_generales,true);
			$_SESSION['Datos_generales'] = $datos_generales;
			$datos_api = iconv("Windows-1252","UTF-8", base64_decode($_POST["datos_api"]));
			if ($datos_api==null) {
				$datos_api = mb_convert_encoding(base64_decode($_POST["datos_api"]),"HTML-ENTITIES", "UTF-8");
			}
			$datos_api = json_decode($datos_api,true);
			$proveedor = $_POST["proveedor"];
			$front_form = json_decode(base64_decode($_POST["input_front_form"]),true);
			$resultadoBusquedaHoteles = json_decode(base64_decode($_POST["input_resultado_busqueda"]),true);
			$cotizacion = array();
			$datos_reservacion = array();
			$countCotiz = array();
			$total_noche = array();
			$totalCotiz = array();
			if (isset($_SESSION["Formulario_reservar"])) {
				if ($_SESSION["Formulario_reservar"][0]['key'] != $_POST["datos_generales"]) {
					unset($_SESSION["Formulario_reservar"]);
					$_SESSION["Formulario_reservar"][0]["key"] = $_POST["datos_generales"];
				}
			}else{
				$_SESSION["Formulario_reservar"][0]["key"] = $_POST["datos_generales"];
			}
			if ($front_form["habs"]>=2 && ($proveedor==0 || $proveedor==1 || $proveedor==3 || $proveedor==6)) {
				$datos_api = $datos_api[0];
			}
			if ($front_form["habs"]==1) {
				$datos_api = $datos_api[0];
			}
			switch ($proveedor) {
				case 0:
					$reemplaceSession = $this->createDesglosesRMT($datos_generales,$datos_api,$front_form,$resultadoBusquedaHoteles,$proveedor);
					$datos = $reemplaceSession["datos"];
					$cotizacion = $reemplaceSession["cotizacion"];
					$menoresArray = $reemplaceSession["menoresArray"];
					// $total_noche = $reemplaceSession["total_noche"];
					$totalCotiz = $reemplaceSession["totalCotiz"];
					$countCotiz = $reemplaceSession["countCotiz"];
				break;
				case 1:
				case 2:
				case 3: ### DO
				case 6:
					if ($proveedor==2 || $proveedor==3) {
						$roomRates = $_POST["roomRates"];
					}else{
						$roomRates = [];
					}
					$reemplaceSession = $this->createDesgloses($datos_generales,$datos_api,$front_form,$resultadoBusquedaHoteles,$proveedor,$roomRates);
					$datos = $reemplaceSession["datos"];
					$cotizacion = $reemplaceSession["cotizacion"];
					$totalCotiz = $reemplaceSession["totalCotiz"];
					$menoresArray[0] = [];
				break;
				case 4:
					$riuController = Yii::app()->createController('riu');
					$riuController = $riuController[0];
					$reemplaceSession = $riuController->createDesgloses($datos_generales,$datos_api,$front_form,$resultadoBusquedaHoteles,$proveedor);
					$datos = $reemplaceSession["datos"];
					$cotizacion = $reemplaceSession["cotizacion"];
					$total_noche = $reemplaceSession["total_noche"];
					$totalCotiz = $reemplaceSession["totalCotiz"];
					$menoresArray[0] = [];
				break;
				case 5:
					$dingusController = Yii::app()->createController('dingus');
					$dingusController = $dingusController[0];
					$reemplaceSession = $dingusController->createDesgloses($datos_generales,$datos_api,$front_form,$resultadoBusquedaHoteles,$proveedor);
					$datos = $reemplaceSession["datos"];
					$cotizacion = $reemplaceSession["cotizacion"];
					$total_noche = $reemplaceSession["total_noche"];
					$totalCotiz = $reemplaceSession["totalCotiz"];
					$menoresArray[0] = [];
				break;
				default:
				break;
			}
			if (!empty($datos_generales)) {
				// $model=new Reservacion;
				$model->id_usuario=Yii::app()->user->id;				
				$model->subtotal=0;
				$model->comision=0;
				$model->iva=0;
				$model->saldo=0;
				$num_habitaciones = $front_form["habs"];
				$Total = $datos_generales["precio"];
				$id_tipo_plan=$datos_generales["id_plan"];
				$hotel = Hoteles::model()->findByPk($datos_generales["id_hotel"]);
				if ($_SESSION['Formulario_reservar'][0]['nombre_cliente']) {
					$datos[0]['id_agente']=$_SESSION['Formulario_reservar'][0]['id_agente'];
					$datos[0]['id_agencia']=$_SESSION['Formulario_reservar'][0]['id_agencia'];
					$datos[0]['nombre_cliente']=$_SESSION['Formulario_reservar'][0]['nombre_cliente'];
					$datos[0]['apellido_cliente']=$_SESSION['Formulario_reservar'][0]['apellido_cliente'];
					$datos[0]['tel_cliente']=$_SESSION['Formulario_reservar'][0]['tel_cliente'];
					for($m=1;$m<=$num_habitaciones;$m++):
						$adultos = $datos[0]['front_form']['habitacion_'.$m]['adultos'];
						for($a=1;$a<=$adultos;$a++){
							$datos[0]['front_form']['habitacion_'.$m]['adulto_'.$a] = $_SESSION['Formulario_reservar'][0]['habitaciones'][$m]['adulto_'.$a];
							$datos[0]['front_form']['habitacion_'.$m]['adulto_apellido_'.$a] = $_SESSION['Formulario_reservar'][0]['habitaciones'][$m]['adulto_apellido_'.$a];
						}
						$num_ninios = $datos[0]['front_form']['habitacion_'.$m]['num_ninios'];
						for($b=1;$b<=$num_ninios;$b++){
							$datos[0]['front_form']['habitacion_'.$m]['ninio_'.$b] = $_SESSION['Formulario_reservar'][0]['habitaciones'][$m]['ninio_'.$b];
							$datos[0]['front_form']['habitacion_'.$m]['ninio_apellido_'.$b] = $_SESSION['Formulario_reservar'][0]['habitaciones'][$m]['ninio_apellido_'.$b];
						}
					endfor;
				}
				#### prefetch
				$model->id_agente = $datos[0]['id_agente'];
				$model->id_agencia = $datos[0]['id_agencia'];
				$model->nombre_cliente = $datos[0]['nombre_cliente'];
				$model->apellido_cliente = $datos[0]['apellido_cliente'];
				$model->tel_cliente = $datos[0]['tel_cliente'];
				######
				$model->id_hotel = $datos_generales["id_hotel"];
				$model->id_tipo_plan = $id_tipo_plan;
				$model->num_habitaciones = $front_form["habs"];
				$model->fecha_inicial = str_replace('/','-',$datos[0]["fecha_inicio"]);
				$model->fecha_final = str_replace('/','-',$datos[0]["fecha_final"]);
				$model->num_noches = $resultadoBusquedaHoteles["noches"];
				$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$hotel->id_hotel.' and estatus=1');
				$base_habitacion = BaseHabitacion::model()->findAll();
				$model->id_tarifa = $datos_generales["id_tarifa"];
				$idhab = $datos_generales["id_habitacion"];
				$tipoPrecio = Tarifa::model()->findByPk($model->id_tarifa);
				$hotelesOB=array(359,169474,169480,169481,177785,177799,169525,169496,177890,169488,169489,169490,177821,177787,177788,177789,169491,177815,169494,169516,169517,169518,169519,169541,169542,169544,169545,169563,169571);
				$hotelesDin=array(177909,177910,177911,177912,177862,177863);
				if ($datos[0]['total']>0) {
					$model->total = $datos_generales["precio"];
					$model->total_tc = $datos_generales["precio"];
				}else{
					###### en rmt
					$model->total = $totalCotiz[0][0]['total_neto'];
					$model->total_tc = $totalCotiz[0][0]['total_tc'];	
					$model->saldo_h = $datos[0]['tarifa_neta'];
				}
				$TotalN=0;
				if ($_POST['startProcess']) {
					# code...
					$time = $_POST['startProcess'];
					$startime=32+((strtotime($time)-strtotime(date('H:i:s')."+ 5 minutes"))/60);
					$segun=number_format($startime,2);
					$seg=explode('.',$segun);
					$seg=$seg[1]/100;
					$segundo=(60*$seg);
					$_SESSION['Datos'][0]['startPro']=$_POST['startProcess'];
				}
				$to_time = strtotime(date('Y-m-d H:i:s'));
				$from_time = strtotime($_SESSION['Datos'][0]['fecha_cotiza']);
				// $from_time = strtotime($datos[$n]['fecha_cotiza']);
				$minutos = round(abs($to_time - $from_time) / 60,2);
				if($minutos > 100){
					$this->render('expira',array());
				}else{
					if ($proveedor!=2) {
						switch ($proveedor) {
							case 0:
							$fecha_inicio = implode('-',array_reverse(explode('-',$model->fecha_inicial)));
							$avisoCancelacion = $this->cancelaciones($model,$fecha_inicio,$model->id_tarifa);
							$fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$fecha_inicio.'" between fecha_inicio and fecha_final');
						if(!empty($model->idTarifa->fecha_limite) && strtotime($fecha_inicio) > strtotime($model->idTarifa->fecha_limite)){
							$model->fecha_limite_h = $model->idTarifa->fecha_limite;
							$model->fecha_limite = date('Y-m-d',strtotime($model->fecha_limite_h.' -2 days'));
							if (strtotime($model->idTarifa->fecha_limite) < strtotime(date('Y-m-d'))) {
								$model->fecha_limite_h = date('Y-m-d',strtotime('-1 days '));
								$model->fecha_limite = date('Y-m-d');
								
							}
						}
						else if(!empty($model->idTarifa->fecha_limite_dias)){
							$model->fecha_limite = date('Y-m-d',strtotime($fecha_inicio.' -'.($model->idTarifa->fecha_limite_dias + 2).' days'));
							$model->fecha_limite_h = date('Y-m-d',strtotime($fecha_inicio.' -'.($model->idTarifa->fecha_limite_dias).' days'));
						}
						else{
							// $fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$fecha_inicio.'" between fecha_inicio and fecha_final');
							if(!empty($fechaLimite)){
								$model->fecha_limite = date('Y-m-d',strtotime($fecha_inicio.' -'.($fechaLimite->dias + 2).' days'));
								$model->fecha_limite_h = date('Y-m-d',strtotime($fecha_inicio.' -'.($fechaLimite->dias).' days'));
							}
						}
							if( ( !empty($model->fecha_limite) && strtotime($model->fecha_limite) < strtotime(date('Y-m-d')) && empty($model->idTarifa->fecha_limite)) || empty($model->fecha_limite) ){
								$hoy=date("Y-m-d");
								$datetime_fecha_inicial=new DateTime($model->fecha_inicial);
								$datetime_hoy=new DateTime($hoy);
								$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);
							$resultado_diferencia_dias= $diferencia->format('%a'); ##DIFERENCIA DE DIAS ENTRE LA FECHA ACTUAL Y LA FECHA DE ENTRADA
							if($resultado_diferencia_dias<=7 && empty($fechaLimite))
							{
								$fecha_limite=date("Y-m-d",strtotime($hoy));
								$fecha_limite_h=date("Y-m-d",strtotime($hoy));
							}else if($resultado_diferencia_dias>7 && $resultado_diferencia_dias<=15 && empty($fechaLimite))
							{
								$fecha_limite=date("Y-m-d",strtotime($hoy.' +1 days'));				
								$fecha_limite_h=date("Y-m-d",strtotime($hoy.' +2 days'));			
							}else if($resultado_diferencia_dias>15 && $resultado_diferencia_dias<=32 && empty($fechaLimite))
							{
								$fecha_limite=date("Y-m-d",strtotime($hoy.' +2 days'));
								$fecha_limite_h=date("Y-m-d",strtotime($hoy.' +3 days'));
							}else if($resultado_diferencia_dias>32 && empty($fechaLimite))
							{
								$fecha_limite=date("Y-m-d",strtotime($model->fecha_inicial.' -31 days'));
								$fecha_limite_h=date("Y-m-d",strtotime($model->fecha_inicial.' -30 days'));
							}elseif ( !empty($fechaLimite) && strtotime($fecha_inicio.' -'.$fechaLimite->dias.' days') < strtotime(date('Y-m-d')) ) {
								$fecha_limite=date("Y-m-d",strtotime($hoy));	
								$model->fecha_limite_h=date("Y-m-d",strtotime($hoy));
							}
							if (empty($fechaLimite)) {
								$model->fecha_limite_h = $fecha_limite_h;
							}
							$model->fecha_limite = $fecha_limite;
						}
							$hotel= Hoteles::model()->findByPk($model->id_hotel);
							$hoy=date("Y-m-d");
							if ($outletActivo) {
								
								$fecha_limite_outlet=$outletController->fechalimiteOutlet($model->id_hotel,$model->fecha_inicial,0,null,$model->fecha_limite);
								$model->fecha_limite= implode('-',array_reverse(explode('/', $fecha_limite_outlet)));
							}
							if($hotel->proveedor==0 && $hotel->Destino->destinationsCode0->code=="HUA"){
								$hua_hoy=new DateTime(date("Y-m-d"));
								$hua_fecha_inicial=new DateTime(date("Y-m-d",strtotime($model->fecha_inicial)));
								$hua_diferencia = $hua_fecha_inicial->diff($hua_hoy);
								$hua_diferencia_dias=$hua_diferencia->format('%a');
								$model->fecha_limite=date("Y-m-d H:i:s",strtotime($hoy.' +2 days'));
								if ($hua_diferencia_dias<4) {
									$model->fecha_limite=date("Y-m-d H:i:s",strtotime($hoy));
								}
								$model->fecha_limite_h = "";
							}
							$_SESSION["fechalmt"]=date("Y-m-d H:i:s",strtotime($hoy.' +2 days'));
							$fechalmtHUA = date("Y-m-d H:i:s",strtotime($hoy.' +2 days'));
							$_SESSION["dest"]=$hotel->Destino->destinationsCode0->code;
							$destHUA = $hotel->Destino->destinationsCode0->code;
							break;
							case 1:
								$avisoCancelacion="";
								$busquedaController = Yii::app()->createController('busqueda');
		            			$busquedaController = $busquedaController[0];
								$markup = Api::model()->findByPk(1)->markup;
								$model->fecha_limite=implode('-',array_reverse(explode('/',$datos[0]['fecha_limite'])));
								foreach (json_decode(base64_decode($datos[0]['rateKey'])) as $rK => $rateKey) 
								{
									$requestCheckrate=array();
									$requestCheckrate["rateKey"]= $rateKey;	
									$responseCheckrate=$this->consultarCheckrates(json_encode($requestCheckrate));
									$logHotelbeds['header'] = "CheckRate";
									$logHotelbeds['request'] = json_encode($requestCheckrate);
									$logHotelbeds['response'] = $responseCheckrate;		
									$logHotelbeds['reference'] = $model->id_hotel;
									//$this->logWs($logHotelbeds,'Beds'); 
									$arrayCheckrate=json_decode($responseCheckrate);
									$tipohab = TipoHabitaciones::model()->find('codigo="'.$arrayCheckrate->hotel->rooms[0]->code.'" AND id_hotel='.$model->id_hotel);
									$descripcionHabitacion=(strlen($tipohab->descripcion)>0)?$tipohab->descripcion:$tipohab->tipo_habitacion;
									$responsePoliticas=$busquedaController->politicasCancelacion($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies,$model->fecha_inicial,$markup,$descripcionHabitacion,$rK,$moneda,false);
									$avisoCancelacion.=$responsePoliticas["politicasCancelacion"];
									if($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies)
									{
		                                $_SESSION['fecha_limite']=substr($responsePoliticas["fecha_limite"],0,10);
		                                $_SESSION['fecha_limite_h']=date('Y-m-d H:i:s',strtotime($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies[0]->from));
		                                $datos[0]['fecha_limite']=substr($responsePoliticas["fecha_limite"],0,10);
		                                $datos[0]['fecha_limite_h']=date('Y-m-d H:i:s',strtotime($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies[0]->from));
		                                if ( strtotime(date('Y-m-d',strtotime($arrayCheckrate->hotel->rooms[0]->rates[0]->cancellationPolicies[0]->from))) <= strtotime(date("Y-m-d"))) {
		                                	$_SESSION['fecha_limite']=$_SESSION['fecha_limite_h'];
		                                	$datos[0]['fecha_limite']=$datos[0]['fecha_limite_h'];
		                                }
		                                // echo $datos[0]['fecha_limite_h'];
		                                $model->fecha_limite=implode('-',array_reverse(explode('/',$datos[0]['fecha_limite'])));
		                                $model->fecha_limite_h=$datos[0]['fecha_limite_h'];
		                            }else
		                            {
		                            	// echo $model->fecha_limite=date("Y-m-d");
		                            	$model->fecha_limite=date("Y-m-d");
		                            }
		                            if($arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments){
		                            	$rateComments[$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments;
		                            	$_SESSION['Datos'][0]['rateComments'][$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->rateComments;
		                            }
		                            if($arrayCheckrate->hotel->rooms[0]->rates[0]->offers){
		                            	$offers[$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->offers;
		                            	$_SESSION['Datos'][0]['offers'][$rK]=$arrayCheckrate->hotel->rooms[0]->rates[0]->offers;
		                            }
		                            $TotalN+=$arrayCheckrate->hotel->totalNet/$markup;
		                        }
		                        $_SESSION['fecha_limite']=$model->fecha_limite;
		                        $_SESSION['politicas_cancelacion']=$avisoCancelacion;
		                        $_SESSION['Datos'][0]['politicas_cancelacion']=$avisoCancelacion;
		                        $datos[0]['politicas_cancelacion']=$avisoCancelacion;
		                        $datos[0]['fecha_limite']=$model->fecha_limite;
		                        $datos[0]['session_PC']['politicas_cancelacion']=$avisoCancelacion;
		                        if ($tarifasOutlet && $outlet->tipo=="VERANO") {
		                        	$fecha_limite=$outletControl[0]->fechasLimite($model->fecha_limite,1,null);
		                        	$model->fecha_limite=date('Y-m-d H:i:s',$fecha_limite);
		                        }
		                        $cambioTarifa = '';
		                        if ($TotalN>0) {
		                        	// echo round($TotalN,2).'-'.round($model->total,2);
		                        	if((string)(round($TotalN,2)) != (string)(round($model->total,2))){ 
		                        		$cambioTarifa = "El importe Total de la tarifa se actualizo al momento, ¿Deseas continuar? ";
		                        		$model->total = $TotalN;
		                        	}
		                        }
		                        $_SESSION['Datos'][0]['cambioTarifa'] = $cambioTarifa;
								break;
							case 3:
	            				$model->fecha_limite=implode('-',array_reverse(explode('/',$datos[0]['fecha_limite'])));
	            				$model->fecha_limite_h=implode('-',array_reverse(explode('/',$datos[0]['fecha_limite_h'])));
	            				$avisoCancelacion=$datos[0]['politicas_cancelacion'];
								break;
							case 4:
								$model->fecha_limite=implode('-',array_reverse(explode('/',$datos[0]['fecha_limite'])));
	            				$model->fecha_limite_h=$datos[0]['fecha_limite_h'];
								$avisoCancelacion= $datos[0]['session_PC']['politicas_cancelacion'];
								break;
							case 5:
								$fechaL = $datos[0]["fecha_limite"];
								$model->fecha_limite=$fechaL;
								$model->fecha_limite_h = $datos[0]["fecha_limite_h"];
								$avisoCancelacion = $datos[0]["politicas_cancelacion"];
								break;
							case 6:
								// $politicas_cancelacion=json_decode();
	            				$model->fecha_limite=implode('-',array_reverse(explode('/',$datos[0]['fecha_limite'])));
	            				$avisoCancelacion=$datos[0]['politicas_cancelacion'];
	            				$model->fecha_limite_h = $datos[0]['fecha_limite_h'];
								break;
							default:
								# code...
								break;
						}
					}else{
						$avisoCancelacion=$datos[0]['session_PC']['politicas_cancelacion'];
						$model->fecha_limite=date('Y-m-d H:i:s', strtotime($datos[0]['fecha_limite']));
						$model->fecha_limite_h=$datos[0]['fecha_limite_h'];
						/*$ratePlan_data=json_decode(base64_decode($datos[0]["ratePlan"]));
						$_SESSION['fecha_limite'];
						$datetime_hoy=new DateTime(date("Y-m-d"));
						$datetime_fecha_inicial=new DateTime(date("Y-m-d",strtotime($model->fecha_inicial)));
						$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);
						$resultado_diferencia_dias=$diferencia->format('%a');
						$dias_fecha_limite=$ratePlan_data->CancelPenalties->CancelPenalty->DeadLine->OffsetUnitMultiplier;
						if($dias_fecha_limite<=$resultado_diferencia_dias && (!is_null($dias_fecha_limite)))
						{
							$model->fecha_limite_h=date("Y-m-d H:i:s",strtotime($model->fecha_inicial.' -'.($dias_fecha_limite+1).' days'));  
							$datos[0]["fecha_limite_h"] = $model->fecha_limite_h;                  	
						}else
						{							
							$model->fecha_limite_h=date("Y-m-d H:i:s");
						}*/
					}
					/*if ($outlet && in_array($proveedor, array(0,2,4,5)) && $model->fecha_limite>date('Y-m-d',strtotime(' + 30 days ')) ) {
						$model->fecha_limite=date('Y-m-d',strtotime(' + 30 days '));
						$datos[0]['fecha_limite']=date('d/m/Y H:i:s', strtotime($model->fecha_limite));
					}
*/
					$_SESSION['Datos'][0]['avisoCancelacion'] = $avisoCancelacion;
					
					if ( $outlet && in_array($proveedor, array(0,2,4,5)) ) {
						$_SESSION['Datos'][0]['avisoCancelacion'] = "Pago inmediato. No transferible, no reembolsable, no se aceptan modificaciones, cancelaciones, ni devoluciones.";
						$avisoCancelacion ="Pago inmediato. No transferible, no reembolsable, no se aceptan modificaciones, cancelaciones, ni devoluciones.";
					}
				$_SESSION['Datos'][0]['markup'] = $markup;
				$this->render('reservar',
					array(
						'model'=>$model,
						'hotel'=>$hotel,
						'tipo_habitacion'=>$tipo_habitacion,
						'base_habitacion'=>$base_habitacion,
						'idhab'=>$idhab,
						'avisoCancelacion'=>$avisoCancelacion,
						'TotalN'=>$TotalN,
						'rateComments'=>$rateComments,
						'offers'=>$offers,
						'promociones'=>$datos[0]['promociones'],
						'markup'=>$markup,
						'front_form'=>$front_form,
						'resultadoBusquedaHoteles'=>$resultadoBusquedaHoteles,
						'datos'=>$datos,
						'total_noche'=>$total_noche,
						'cotizacion'=>$cotizacion,
						'totalCotiz'=>$totalCotiz,
						'n'=>0,
						'datos_generales'=>$datos_generales,
						'menoresArray'=>$menoresArray,
						'countCotiz'=>$countCotiz,
						'startime'=>$startime,
						'segundo'=>$segundo,
						'cambioTarifa'=>$cambioTarifa
					));
				}
			}
		}else{
			if (isset($_GET['ref'])) {
				$log = LogBanco::model()->find('reference="'.$_GET['ref'].'"');
				$logs = json_decode($log->reserva);
				$total_noche = array();
				$modelo = json_decode(json_encode($logs->Reservacion->Reservacion),true);
				$model = new Reservacion;
				$model->attributes = $modelo;
				$hotel = Hoteles::model()->findByPk($model->id_hotel);
				$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$hotel->id_hotel.' and estatus=1');
				$base_habitacion = BaseHabitacion::model()->findAll();
				$datos = json_decode(json_encode($logs->Datos),true);
				$datos[0] = (array) $datos;
				$avisoCancelacion = $datos[0]['avisoCancelacion'];
				$idhab = $datos[0]['id_tipo_habitacion'];
				$TotalN = $model->total;
				$offers = $datos[0]['offers'];
				$rateComments = $datos[0]['rateComments'];
				$promociones = $datos[0]['promociones'];
				$markup = $datos[0]['markup'];
				$front_form = $datos[0]['front_form'];
				$resultadoBusquedaHoteles = json_decode(json_encode($logs->ResultadoBusqueda),true);
				$total_noche = empty($logs->Total_noche) ? [] : json_decode(json_encode($logs->Total_noche),true);
				$cotizacion = json_decode(json_encode($logs->carrito),true);
				$totalCotiz = json_decode(json_encode($logs->TotalCotiz),true);
				$datos_generales = json_decode(json_encode($logs->DatosGenerales),true);
				$menoresArray = json_decode(json_encode($logs->Menores),true);
				$countCotiz = $logs->CountCotiz;
				if ($datos[0]['startPro']){
					$time = $datos[0]['startPro'];
					$startime=15+((strtotime($time)-strtotime(date('H:i:s')."+ 5 minutes"))/60);
					$segun=number_format($startime,2);
					$seg=explode('.',$segun);
					$seg=$seg[1]/100;
					$segundo=(60*$seg);
				}
				$this->render('reservar',
					array(
						'model'=>$model,
						'hotel'=>$hotel,
						'tipo_habitacion'=>$tipo_habitacion,
						'base_habitacion'=>$base_habitacion,
						'idhab'=>$idhab,
						'avisoCancelacion'=>$avisoCancelacion,
						'TotalN'=>$TotalN,
						'rateComments'=>$rateComments,
						'offers'=>$offers,
						'promociones'=>$datos[0]['promociones'],
						'markup'=>$markup,
						'front_form'=>$front_form,
						'resultadoBusquedaHoteles'=>$resultadoBusquedaHoteles,
						'datos'=>$datos,
						'total_noche'=>$total_noche,
						'cotizacion'=>$cotizacion,
						'totalCotiz'=>$totalCotiz,
						'n'=>0,
						'datos_generales'=>$datos_generales,
						'menoresArray'=>$menoresArray,
						'countCotiz'=>$countCotiz,
						'startime'=>$startime,
						'segundo'=>$segundo,
						'cambioTarifa'=>$cambioTarifa
					));
			}
			$model->id_usuario=Yii::app()->user->id;				
			$model->subtotal=0;
			$model->comision=0;
			$model->iva=0;
			$model->saldo=0;
			if(!Yii::app()->user->checkAccess('agenciaMenu') && $_SESSION['tipoUsuario'] != "Agencia"){
				// $this->render('create',array(
				// 	'model'=>$model,'tipo_habitacion'=>$tipo_habitacion,'base_habitacion'=>$base_habitacion,'idhab'=>$idhab,
				// ));
				$this->redirect(array('site/index'));
			}else{
				$this->redirect(array('site/index'));
			}
		}

		
		

	}


	public function createDesglosesRMT($generales,$datosApi,$front_form,$resultadosBusqueda,$proveedor){
		

		// echo "<textarea>".json_encode($generales)."</textarea>";
		// exit;
		if(isset($_SESSION['Datos'][0]['rateKey'])){
				unset($_SESSION['Datos'],$_SESSION['Cotizacion'],$_SESSION['Menores'],$_SESSION['TotalCotiz']);
		}

			$datos=array();
			$datosArray=array();
			$menores = array();
			$menoresArray = array();
			$cotizacion = array();
			$totalCotiz = array();
			$cotizacion = array();
			$total_noche = array();

			$outletController = Yii::app()->createController('outlet');
			$outletController = $outletController[0];
			$outlet=Outlet::model()->find("estatus=1");
			$tarifaOutlet=$outletController->validacionTarifas($outlet);

			$error=NULL; $Total = array();
			$hora = "and curtime() between hora_inicio and hora_final";
			$fecha_promo = "and current_date between fecha_promo_inicio and fecha_promo";
			$early_booking = "and (early_booking is null or DATEDIFF('".$resultadosBusqueda['fecha_inicial']."',current_date) <= early_booking)";
			$release = "and (t.release is null or DATEDIFF('".$resultadosBusqueda['fecha_inicial']."',current_date) >= t.release)";

			$vip=TarifaAgencia::model()->find("id_agencia=".$_SESSION["agenciaUsuario"]);
	
		    if($_SESSION["agenciaUsuario"] != 9 && !$vip){		

		    	$tarifaAgencias = 'and not exists(select NULL from tbl_tarifa_agencia tarifaAgencias where tarifaAgencias.id_tarifa=t.id_tarifa and tarifaAgencias.id_agencia!='.$_SESSION["agenciaUsuario"].')';
				//$agenciaUsuario = Agencias::model()->findByPk($_SESSION["agenciaUsuario"]);
				$agenciaUsuario = $_SESSION["agencia"]; //$_SESSION["agenciaUsuario"];
				$tarifaEstados = 'and exists(select NULL from tbl_tarifa_estados tarifaEstados where tarifaEstados.id_tarifa=t.id_tarifa and tarifaEstados.id_estado='.$agenciaUsuario->id_estado_agencia.')';
			}

			for($dia=0;$dia<$resultadosBusqueda['noches'];$dia++)
			{
				$fecha = date("Y-m-d", strtotime($resultadosBusqueda['fecha_inicial'])+$dia*24*60*60);
				$fechadia = strtotime($resultadosBusqueda['fecha_inicial'])+$dia*24*60*60;
				$tarifa = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'t.id_tarifa='.$generales['id_tarifa'].' and id_tipo_plan='.$generales['id_plan'].' '.$fecha_promo.' '.$hora.' '.$early_booking.' '.$release.' and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final '.$tarifaAgencias.' '.$tarifaEstados.'', 'limit'=>1));
				if(empty($tarifa)){
					$tarifa = Tarifa::model()->with('tarifaDiasvalidos','tarifaDesgloses')->findAll(array('condition'=>'t.id_hotel='.$generales['id_hotel'].' and id_tipo_plan='.$generales['id_plan'].' '.$fecha_promo.' '.$hora.' '.$early_booking.' '.$release.' and ( t.id_tarifa='.$generales['id_tarifa'].' || ( t.precio IN("PROMO","OUTLET","NORMAL","VIP") and (t.id_combina='.$generales['id_tarifa'].' || t.id_combina is null) and promocontigua=1 ) ) and t.estatus=1 and id_base_habitacion=2 and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final '.$tarifaAgencias.' '.$tarifaEstados.'', 'order'=>'t.id_tipo_plan ASC, precio_normal ASC', 'limit'=>1));
					if(empty($tarifa)){
						$error = "Actualmente este hotel no dispone de tarifas para la fecha ".$fecha.". Le sugerimos modificar e intentar de nuevo, o le invitamos a contactar a nuestros ejecutivos vía telefónica o chat para la generación de una cotización.";
						break;
					}
				}
				$t=0;
				foreach($tarifa as $row)
				{
					$costoTotal = 0; $costoTotalTC = 0;
					for($i=1;$i<=$resultadosBusqueda['habitaciones'];$i++)
					{
						$num_ninios = $front_form['habitacion_'.$i]['num_ninios'];
						$num_adultos = $front_form['habitacion_'.$i]['adultos'];
						$habBloqueada = FechasBloqueadas::model()->find('id_tipo_habitacion='.$generales["id_habitacion"].' and "'.$fecha.'" between fecha_inicio and fecha_final and id_tarifa='.$row->id_tarifa);
						if(empty($habBloqueada)){						
							$tarifaDesglose = TarifaDesglose::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$generales["id_habitacion"].' and id_base_habitacion='.$front_form['habitacion_'.$i]['adultos'].' and '.$front_form['habitacion_'.$i]['num_ninios'].' <= max_menores and estatus=1');
						}
						if(empty($tarifaDesglose)){
							$error = "No se encontró una tarifa de ".$front_form['habitacion_'.$i]['adultos']." adultos que acepte un máximo numero de menores de ".$front_form['habitacion_'.$i]['num_ninios']." para la habitación ".$i.". O la habitación está bloqueada para la fecha ".$fecha;
							break;
						}
						$nocheGratis = NochesGratis::model()->find('id_tarifa='.$row->id_tarifa.' and (id_tipo_habitacion is null or id_tipo_habitacion='.$generales["id_habitacion"].')');
						$suplemento = 0;
						if(!empty($nocheGratis) && (($dia+1) % $nocheGratis->noche == 0)){
							if(($dia+1) > $nocheGratis->noche && $nocheGratis->acumulable != 1){
								$nocheGratis = false;
							}else{
								$tarifaDesglose->precio_normal = 0;
								$nocheGratis = true;
							}
						}
						$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,$tarifaDesglose->id_base_habitacion,'A',NULL);
						$costoAdultos = $tarifaDesglose->precio_normal + $suplemento;
						$costoAdultosTC = $row->tipoCambio($tarifaDesglose->precio_normal) + $row->tipoCambio($suplemento);
						$hotelesOutlet = $outletController->hotelesOutlet($generales['id_hotel'],0,'');
						if ($tarifaOutlet && $row->precio!="OUTLET" && !$hotelesOutlet) {
							$costoAdultos = $outletController->tarifaOutletVirtual($costoAdultos,0,$row->comision,$outlet->descuento_general);
							$costoAdultosTC = $outletController->tarifaOutletVirtual($costoAdultosTC,0,$row->comision,$outlet->descuento_general);
						}
						if($suplemento > 0){
							$datos[$dia][$t][$i]['adultos'] = number_format($row->tipoCambio($tarifaDesglose->precio_normal),'2')." + ".number_format($row->tipoCambio($suplemento),'2')." SUP.";

							if ($tarifaOutlet && $row->precio!="OUTLET" && !$hotelesOutlet) {
								$datos[$dia][$t][$i]['adultos'] = $outletController->tarifaOutletVirtual($datos[$dia][$t][$i]['adultos'],0,$row->comision,$outlet->descuento_general);
							}
						}else{
							$datos[$dia][$t][$i]['adultos'] = number_format($costoAdultosTC,'2');
						}
						$precompraMenor = "fecha_inicio_precompra is null or current_date between fecha_inicio_precompra and fecha_final_precompra";
						$costoMenores = 0; $costoMenoresTC = 0;
						$menorgratis = 0; $niniopaga = 1;
						$suplemento = 0; $suplementoMenores = 0;
						
						for($n=1;$n<=$front_form['habitacion_'.$i]['num_ninios'];$n++){ //Ordenar edades menores mayor a menor
							if($front_form['habitacion_'.$i]['edad_'.$n] < $front_form['habitacion_'.$i]['edad_'.($n+1)]){
								$aux = $front_form['habitacion_'.$i]['edad_'.$n];
								$front_form['habitacion_'.$i]['edad_'.$n] = $front_form['habitacion_'.$i]['edad_'.($n+1)];
								$front_form['habitacion_'.$i]['edad_'.($n+1)] = $aux;

								$_SESSION['info_search']['habitaciones'][$i]['menores'][$n] = $_SESSION['info_search']['habitaciones'][$i]['menores'][$n + 1];
								$_SESSION['info_search']['habitaciones'][$i]['menores'][$n + 1] = $aux;

								$n=0;
							}
						}
						$convertir = 0;
						$numNinios=$front_form['habitacion_'.$i]['num_ninios'];
						for($n=1; $n<=$numNinios; $n++)
						{
							

							$tarifaMenor=DesgloseMenores::model()->find("id_tarifa=".$row->id_tarifa." and id_tipo_habitacion=".$generales["id_habitacion"]." and ".$front_form['habitacion_'.$i]['edad_'.$n]." <= edad_max_menor and num_evaluar=".$niniopaga." and es_junior=0 and(".$precompraMenor.") and(fecha_inicio is null or '".$fecha."' between fecha_inicio and fecha_final) ORDER BY precio ASC");

							if(empty($tarifaMenor)){
								$tarifaMenor=DesgloseMenores::model()->find("id_tarifa=".$row->id_tarifa." and id_tipo_habitacion=".$generales["id_habitacion"]." and ".$front_form['habitacion_'.$i]['edad_'.$n]." between edad_min_menor and edad_max_menor and es_junior=1 and(".$precompraMenor.") and(fecha_inicio is null or '".$fecha."' between fecha_inicio and fecha_final) ORDER BY precio ASC");
								
								if(empty($tarifaMenor)){
									$num_adultos+=1;
									$convertir++;
									$aux_menor= $num_ninios - $convertir;
									
									$tarifaDesglose = TarifaDesglose::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$generales["id_habitacion"].' and id_base_habitacion='.$num_adultos.' and '.$aux_menor.' <= max_menores and estatus=1');
									if ($tarifaDesglose) {
										 $front_form['habitacion_'.$i]['num_ninios'] = $aux_menor;
										 $front_form['habitacion_'.$i]['adultos'] = $num_adultos;
										 unset($front_form['habitacion_'.$i]['edad_'.$convertir]);
										 unset($_SESSION['front_form']['habitacion_'.$i]['edad_'.$convertir]);
									}else{
										$error = "El menor con edad ".$front_form['habitacion_'.$i]['edad_'.$n]." de la habitación ".$i." no tiene una tarifa definida para la fecha ".$fecha;
									}

									$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,$tarifaDesglose->id_base_habitacion,'A',NULL);
									$costoAdultos = $tarifaDesglose->precio_normal + $suplemento;
									$costoAdultosTC = $row->tipoCambio($tarifaDesglose->precio_normal) + $row->tipoCambio($suplemento);
									
									if ($tarifaOutlet && $row->precio!="OUTLET") {
										$costoAdultos = $outletController->tarifaOutletVirtual($costoAdultos,0,$row->comision,$outlet->descuento_general);
										$costoAdultosTC = $outletController->tarifaOutletVirtual($costoAdultosTC,0,$row->comision,$outlet->descuento_general);
									}
									if($suplemento > 0){
										$datos[$dia][$t][$i]['adultos'] = number_format($row->tipoCambio($tarifaDesglose->precio_normal),'2')." + ".number_format($row->tipoCambio($suplemento),'2')." SUP.";
										
										if ($tarifaOutlet) {
											$datos[$dia][$t][$i]['adultos'] = $outletController->tarifaOutletVirtual($datos[$dia][$t][$i]['adultos'],0,$row->comision,$outlet->descuento_general);
										}
									}else{
										$datos[$dia][$t][$i]['adultos'] = number_format($costoAdultosTC,'2');
									}
								}
							}
							if($tarifaMenor->es_junior != 1)$niniopaga++;
							if($front_form['habitacion_'.$i]['edad_'.$n] < $tarifaMenor->edad_min_menor || $nocheGratis == true)$tarifaMenor->precio = 0;

							$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,0,'N',$front_form['habitacion_'.$i]['edad_'.$n]);
							$suplementoMenores += $suplemento;
							$precioMenor = $tarifaMenor->precio + $suplemento;
							$costoMenores += $precioMenor;
							$precioMenorTC = $row->tipoCambio($tarifaMenor->precio) + $row->tipoCambio($suplemento);
							$costoMenoresTC += $precioMenorTC;
							$menores[$dia][$t][$i] .= "Menor ".$n.": $ ".number_format($precioMenorTC,'2')." / ";
							if($precioMenor == 0)$menorgratis++;
						}
						if ($tarifaOutlet && !$hotelesOutlet) {
							$costoMenores = $outletController->tarifaOutletVirtual($costoMenores,0,$row->comision,$outlet->descuento_general);
							$costoMenoresTC = $outletController->tarifaOutletVirtual($costoMenoresTC,0,$row->comision,$outlet->descuento_general);
						}
						if($suplementoMenores > 0){
							$datos[$dia][$t][$i]['menores'] = number_format($row->tipoCambio($costoMenores-$suplementoMenores),2)." + ".number_format($row->tipoCambio($suplementoMenores),2)." SUP.";
						}else{
							$datos[$dia][$t][$i]['menores'] = number_format($costoMenoresTC,'2');
						}
						$costoHabitacion = $costoAdultos + $costoMenores;
						$costoTotal += $costoHabitacion;
						$costoHabitacionTC = $costoAdultosTC + $costoMenoresTC;
						$costoTotalTC += $costoHabitacionTC;
						$datos[$dia][$t][$i]['fecha'] = implode("-", array_reverse(explode("-", $fecha)));
						$datos[$dia][$t][$i]['total'] = number_format($costoHabitacionTC,'2','.',',');
						$minNoches = MinNoches::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$tarifaDesglose->id_tipo_habitacion.' and "'.$fecha.'" between fecha_inicio and fecha_final');
						if(!empty($minNoches) && $minNoches->minimo > $Total[$t]['min_noches']){
							$Total[$t]['min_noches'] = $minNoches->minimo;
						}else if($row->min_noches > $Total[$t]['min_noches']){
							$Total[$t]['min_noches'] = $row->min_noches;
						}
						
						$Total[$t]['habitaciones'][$i]["costoHabitacion"] += $costoHabitacionTC;
						$habs++;
					}
					if(empty($Total[$t]['tarifa']))$Total[$t]['tarifa'] = $row->id_tarifa;
					$Total[$t]['moneda'] = $row->mostrar_conversion == 0 ? $row->moneda:'MXN';
					if($row->restricciones != "" && "<p>".$row->restricciones."</p>" != $Total[$t]['restricciones'])
						$Total[$t]['restricciones'] .= "<p>".$row->restricciones."</p>";
					$Total[$t]['nombre'] = $row->precio." ".$row->nombre_tarifa;
					$Total[$t]['total'] += $costoTotal;
					$Total[$t]['total_tc'] += $costoTotalTC;
					$t++;
				}
			}
			
			//se invierte donde se guardan los totales para no cambiar las variables en las vistas
			$Total[0]['total_neto'] = $Total[0]['total_tc'];
			$Total[0]['total_tc'] = $Total[0]['total'];
			$Total[0]['total'] = number_format($Total[0]['total_neto'],2);
			if($resultadosBusqueda['noches'] < $Total[0]['min_noches']){
				$error = "La tarifa tiene un mínimo de ".$Total[0]['min_noches']." para poder reservar.";
			}
			if($error == NULL)
			{
				if(empty($_SESSION['Cotizacion']))
				{
					$_SESSION['Datos'] = array();
					$_SESSION['Cotizacion'] = array();
					$_SESSION['Menores'] = array();
					$_SESSION['TotalCotiz'] = array();
					$_SESSION['time_out']= array();
					$_SESSION['CountCotiz'] = 0;
				}
				$hotel = Hoteles::model()->findByPk($generales['id_hotel']);
				$plan = Plan::model()->findByPk($generales['id_plan']);
				$habitacion = TipoHabitaciones::model()->findByPk($generales['id_habitacion']);
				array_push($_SESSION['time_out'], 1);
				array_push($datosArray,array('id_hotel'=>$hotel->id_hotel,'hotel'=>$hotel->nombre_hotel,'tarifa'=>$generales['id_tarifa'],'id_plan'=>$plan->id_plan,'plan'=>$plan->nombre,
											'fecha_inicio'=>date('d/m/Y',strtotime($resultadosBusqueda['fecha_inicial'])),'fecha_final'=>date('d/m/Y',strtotime($resultadosBusqueda['fecha_final'])),
											'noches'=>$resultadosBusqueda['noches'],'id_tipo_habitacion'=>$habitacion->id_tipo_habitacion,'tipo_habitacion'=>$habitacion->tipo_habitacion,
											'front_form'=>$front_form,'menorgratis'=>$menorgratis,'fecha_cotiza'=>date('Y-m-d H:i:s'),'tarifa_neta'=>$datosApi['precio_neto']));
				array_push($cotizacion,$datos);
				array_push($menoresArray,$menores);
				array_push($totalCotiz,$Total);
				$countCotiz++;
				// array_push($_SESSION['Cotizacion'],$datos);
				// array_push($_SESSION['Menores'],$menores);
				// array_push($_SESSION['TotalCotiz'],$Total);
				// $_SESSION['CountCotiz']++;
			}

			
			$_SESSION["Datos"] = $datosArray;
			$_SESSION["Cotizacion"] = $cotizacion;
			$_SESSION["Menores"] = $menoresArray;
			$_SESSION["TotalCotiz"] = $totalCotiz;
			$_SESSION["CountCotiz"] = $countCotiz;

			return array("datos"=>$datosArray,"cotizacion"=>$cotizacion,"menoresArray"=>$menoresArray,"totalCotiz"=>$totalCotiz,"countCotiz"=>$countCotiz);
	}

	public function createBooking($reservAux)
	{
		
			$session=new CHttpSession;
			$session->open();
				$reservAux=json_decode($reservAux,true);
				$id_reservacion=$reservAux['Reservacion']['Reservacion']['id_reservacion'];
				if (!$id_reservacion) {	
					$model=new Reservacion;
				}else{
					$model=Reservacion::model()->findByPk($id_reservacion);
				}	
				$guardarReservacionBanco = Yii::app()->createController('reservaBanco');
				$guardarReservacionBanco = $guardarReservacionBanco[0];
				echo $model = $guardarReservacionBanco->guardarReservacionBanco($model, $reservAux['Reservacion'], $reservAux['Datos'], $reservAux['carrito'], $reservAux['TotalCotiz'], $reservAux['ecomerce']);
	}
	public function consultarCheckrates($request){
		$hotelApi = new HotelApi();
		$estatus = $hotelApi->estatus();
		if($estatus=="OK")
		{
			$logHotelbeds['header'] = "recheck";
			$logHotelbeds['request'] = $request;
			$idlogws=$this->logWsRequest($logHotelbeds,'BedsRecheck');
			$response = $hotelApi->hotelAvailabilityCheckByRateKey($request);
		
			$logHotelbeds['response'] = $response;
			$reference=json_decode($request);
			$logHotelbeds['reference'] = $request;
			$this->logWsResponse($idlogws,$logHotelbeds);



			return $response;
		}
		else
		{
			return "No hubo conexión";
		}
			
	}
	public function actionBloqueo($id)
	{
		$model=new Reservacion;
		$bloqueo = Bloqueos::model()->findByPk($id);
		$model->id_bloqueo = $id;
		$model->id_hotel = $bloqueo->id_hotel;
		$model->id_tipo_plan = $bloqueo->id_tipo_plan;
		$model->id_agencia = $bloqueo->id_agencia;
		$model->id_usuario=Yii::app()->user->id;
		$model->fecha_inicial = implode("-", array_reverse(explode("-", $bloqueo->fecha_inicio)));
		$model->fecha_final = implode("-", array_reverse(explode("-", $bloqueo->fecha_final)));		
		if(isset($_GET['hab'])){
			$roomlistHabs = explode(',',$_GET['hab']);
			$model->num_habitaciones = count($roomlistHabs);
			$roomlistRow = Roominglist::model()->find('id_bloqueo='.$id.' and habitacion='.$roomlistHabs[0]);
			$model->id_agencia = $roomlistRow->id_agencia;
			$cliente = explode('/',$roomlistRow->nombre);
			$model->nombre_cliente = $cliente[0];
			$model->num_noches = $roomlistRow->noches;
			$model->fecha_inicial = implode("-", array_reverse(explode("-", $roomlistRow->fecha_inicio)));
			$model->fecha_final = implode("-", array_reverse(explode("-", $roomlistRow->fecha_final)));
			$model->observaciones = $roomlistRow->observaciones;
			if($model->idBloqueo->getNoches() == $model->num_noches){
				$readOnlyInput = true;
			}else
				$readOnlyInput = false;
		}
		$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$bloqueo->id_hotel);
		$base_habitacion = BaseHabitacion::model()->findAll();
		$model->subtotal=0;
		$model->comision=0;
		$model->iva=0;
		$model->saldo=0;
		$this->render('create',array(
			'model'=>$model,'tipo_habitacion'=>$tipo_habitacion,'base_habitacion'=>$base_habitacion,'idhab'=>$bloqueo->id_tipo_habitacion,
			'roomlistHabs'=>$roomlistHabs,'readOnlyInput'=>$readOnlyInput
		));
	}
	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$this->layout = "//layouts/ansonika_site";

		$model=$this->loadModel($id);
		//$model->manual = 0;
		$habitaciones = ReservacionDesglose::model()->findAll('id_reservacion='.$model->id_reservacion);
		$personas = ReservacionDesglosePersona::model()->findAll('id_reservacion='.$model->id_reservacion);
		$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$model->id_hotel);
		$base_habitacion = BaseHabitacion::model()->findAll();
		if(isset($_POST['Reservacion']))
		{
			$recibos = ReciboDetalles::model()->with('idRecibo')->findAll('id_reservacion='.$model->id_reservacion.' and estado!="C"');
			$pagos = OrdenesPagoDetalles::model()->with('idOrdenPago')->findAll('id_reservacion='.$model->id_reservacion.' and estado!="C"');
			$nuevo=new Reservacion;
			$nuevo = $this->guardarReservacion($nuevo);
			$importe = 0;
			$importePagos = 0;
			foreach($recibos as $row)
			{
				$importe += $row->importe;
				$row->id_reservacion = $nuevo->id_reservacion;
				$row->save(); 
			}
			foreach($pagos as $row)
			{
				$importePagos += $row->importe;
				$row->id_reservacion = $nuevo->id_reservacion;
				$row->save();
			}
			$model->estatus = 'C';
			$model->motivo = "Cancelado por Edición, Nuevo Cupón: <a href='".Yii::app()->createUrl('reservacion/view/id/'.$nuevo->id_reservacion)."'>".$nuevo->id_reservacion."</a>, Fecha: ".date('d/m/Y H:i:s');
			$model->save();
			$nuevo->id_usuario=Yii::app()->user->id;
			$nuevo->saldo = $nuevo->saldo - $importe;
			$nuevo->saldo_h = $nuevo->saldo_h - $importePagos;
			$nuevo->motivo = "Editado de Reservación #".$model->id_reservacion;
			$nuevo->save();
			$operacion = Yii::app()->createController('operacionesLog');
			$operacion = $operacion[0];
			$operacion->Create($nuevo->id_reservacion,4);
			$this->redirect(array('view','id'=>$nuevo->id_reservacion));
		}
		$model->fecha_inicial = implode("-", array_reverse(explode("-", $model->fecha_inicial)));
		$model->fecha_final = implode("-", array_reverse(explode("-", $model->fecha_final)));
		$this->render('update',array(
			'model'=>$model, 'habs'=>$habitaciones, 'personas'=>$personas, 'tipo_habitacion'=>$tipo_habitacion, 'base_habitacion'=>$base_habitacion,
		));
	}
	private function guardarReservacion($model)
	{
		$this->outlet = Outlet::model()->find('estatus=1');
		$model->attributes=$_POST['Reservacion'];
		$model->fecha_inicial = implode("-", array_reverse(explode("-", $model->fecha_inicial)));
		$model->fecha_final = implode("-", array_reverse(explode("-", $model->fecha_final)));
		$model->num_noches = $this->noches($model->fecha_inicial,$model->fecha_final);		
		$outletEstatus=$this->eventoOutlet($this->outlet);
		$comision = Agencias::model()->findByPk($model->id_agencia)->porcentaje_comision;
		if ($_POST['Reservacion']['id_bloqueo']) {
			$porcentaje = Bloqueos::model()->findByPk($_POST['Reservacion']['id_bloqueo'])->comision;
			if ($porcentaje>0) {
				$comision=$porcentaje;
			}
		}

		/*if ($model->idTarifa->precio=='OUTLET') {
			$comision = $this->outlet->comision_agencia;
		}

		
		if ($outletEstatus && !$_POST['Reservacion']['id_bloqueo'] ) {
			$comision = $this->outlet->comision_agencia;
		}*/
		




		$model->comision = $comision;
		if(empty($_POST['rateKey']))
		{
			$comision_hotel = Tarifa::model()->findByPk($model->id_tarifa);
			
		}
		else
		{
			//pasar a variables de configuracion, tarea pendiente 14 nov 2017
			$comision_hotel=20; 
			$model->id_tarifa=0;
			//$model->comision = 14; 
			if($model->idHotel->proveedor==1){
				$markup = Api::model()->findByPk(1)->markup;
			}else if($model->idHotel->proveedor==2){
				$markup = Api::model()->findByPk(4)->markup;
			}else if($model->idHotel->proveedor==3){
				$markup = Api::model()->findByPk(6)->markup;
			}
		}
		$model->libera_cupon=1;
	
		if($model->manual == 1)$model->total_tc = $model->total;
		$model->saldo = $model->total - ($model->total*($model->comision/100));
		if($model->manual == 0)$model->saldo_h = $model->total - ($model->total*($comision_hotel->comision/100));			
		$model->estatus = 'R';
		if($model->manual == 0 && $model->idTarifa->tipo_cambio != 0){
			if($model->idTarifa->tipo_cambio == 1){
				$model->tipo_cambio = $model->idHotel->tipo_cambio;
			}else if($model->idTarifa->tipo_cambio == 2){
				$model->tipo_cambio = $model->idTarifa->tasa_cambio;
			}
			$model->saldo = round($model->total_tc * $model->tipo_cambio,2);
			$model->saldo = $model->saldo - ($model->saldo*($model->comision/100));
		}
		//Asignar fecha límite si existe
		if(empty($_POST['rateKey']))
		{
			$fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$model->fecha_inicial.'" between fecha_inicio and fecha_final');

			if(!empty($model->idTarifa->fecha_limite) && strtotime($model->fecha_inicial) > strtotime($model->idTarifa->fecha_limite))
			{
				$model->fecha_limite = $model->idTarifa->fecha_limite;
			}
			else if(!empty($model->idTarifa->fecha_limite_dias)){
				$model->fecha_limite = date('Y-m-d',strtotime($model->fecha_inicial.' -'.($model->idTarifa->fecha_limite_dias + 2).' days'));
			}
			else{
				// $fechaLimite = FechaLimite::model()->find('id_hotel='.$model->id_hotel.' and "'.$model->fecha_inicial.'" between fecha_inicio and fecha_final');
				if(!empty($fechaLimite)){
					$model->fecha_limite = date('Y-m-d',strtotime($model->fecha_inicial.' -'.($fechaLimite->dias + 2).' days'));
				}
			}

			if (!empty($fechaLimite) && $model->idHotel->Destino->destinationsCode0->code!="HUA") {
				// echo "HUA";
				$model->fecha_limite_h = date('Y-m-d',strtotime($model->fecha_inicial.' -'.$fechaLimite->dias.' days')); 
			}


			if( ( !empty($model->fecha_limite) && strtotime($model->fecha_limite) < strtotime(date('Y-m-d')) ) || empty($model->fecha_limite) ){
				$hoy=date("Y-m-d");
					    
			    $datetime_fecha_inicial=new DateTime($model->fecha_inicial);
				$datetime_hoy=new DateTime($hoy);
				
				$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);
				
				$resultado_diferencia_dias= $diferencia->format('%a');

				if($resultado_diferencia_dias<=7 && empty($fechaLimite))
				{
			    	$fecha_limite=date("Y-m-d",strtotime($hoy));

				}else if($resultado_diferencia_dias>7 && $resultado_diferencia_dias<=15 && empty($fechaLimite))
				{
			    	$fecha_limite=date("Y-m-d",strtotime($hoy.' +1 days'));							

				}else if($resultado_diferencia_dias>15 && $resultado_diferencia_dias<=32 && empty($fechaLimite))
				{
			    	$fecha_limite=date("Y-m-d",strtotime($hoy.' +2 days'));

				}else if($resultado_diferencia_dias>32 && empty($fechaLimite))
				{
			    	$fecha_limite=date("Y-m-d",strtotime($model->fecha_inicial.' -31 days'));
				
				}elseif ( !empty($fechaLimite) && strtotime($model->fecha_inicial.' -'.$fechaLimite->dias.' days') < strtotime(date('Y-m-d')) ) {

					$fecha_limite=date("Y-m-d",strtotime($hoy));	
					$model->fecha_limite_h=date("Y-m-d",strtotime($hoy));
				}
			    
				if($fecha_limite<=$hoy)
		            $fecha_limite=$hoy;

				
				if (empty($fechaLimite)) {
		        	$model->fecha_limite_h = null;
		        }

				$model->fecha_limite = $fecha_limite;
			}
		}
		else
		{
			$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['fecha_limite']))); //json $_POST['fechaLimite'];
			
			
			if($model->idHotel->proveedor==2)
			{
				$ratePlan_data=json_decode(base64_decode($_SESSION["Datos"][0]["ratePlan"]));

				$datetime_hoy=new DateTime(date("Y-m-d"));
			    $datetime_fecha_inicial=new DateTime(date("Y-m-d",strtotime($model->fecha_inicial)));
				
				$diferencia = $datetime_fecha_inicial->diff($datetime_hoy);
				
				$resultado_diferencia_dias=$diferencia->format('%a');
				$dias_fecha_limite=$ratePlan_data->CancelPenalties->CancelPenalty->DeadLine->OffsetUnitMultiplier;

				if($dias_fecha_limite<=$resultado_diferencia_dias && (!is_null($dias_fecha_limite)))
				{
	            	$model->fecha_limite_h=date("Y-m-d H:i:s",strtotime($model->fecha_inicial.' -'.($dias_fecha_limite+1).' days'));                    	
				}else
				{							
	            	$model->fecha_limite_h=date("Y-m-d H:i:s");
				}

			}elseif ($model->idHotel->proveedor==4) { 
				//$model->fecha_limite=date('Y-m-d H:i:s', strtotime($_SESSION['Datos'][0]['fecha_limite']));
				$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['Datos'][0]['fecha_limite'])));
				$model->fecha_limite_h=$_SESSION['Datos'][0]['fecha_limite_h'];
 				$avisoCancelacion= $_SESSION['Datos'][0]['politicas_cancelacion'];
			}elseif ($model->idHotel->proveedor==5) {
			                 $fechaH= $_SESSION['Datos'][0]['fecha_limite_h'];
			                $fechaLimite= $_SESSION['Datos'][0]['fecha_limite'];
						    $model->fecha_limite_h = $fechaH; 
						    $model->fecha_limite = $fechaLimite;
						

			}else
			{
				$model->fecha_limite_h=$_SESSION['fecha_limite_h'];
			}
		}
		if(empty($model->id_bloqueo)){
			if(empty($_POST['rateKey']))
			{
				$model->politicas_cancelacion = $this->cancelaciones($model,$model->fecha_inicial,$model->id_tarifa);
			}
			else
			{
				$model->politicas_cancelacion=$_SESSION['politicas_cancelacion'];//$_POST['politicas_cancelacion'];	
			}
			if(empty($_POST['rateKey']))
			{
				//Checa si tiene allotment, poner codigo
				$fechaInicio = new DateTime($model->fecha_inicial);
				$fechaFinal = new DateTime($model->fecha_final);
				do{
					$allotment = Allotment::model()->find('id_hotel='.$model->id_hotel.' and "'.$fechaInicio->format('Y-m-d').'" between fecha_inicio and fecha_final');
					$fechaInicio->modify('+1 days');
					if(!empty($allotment)){
						$model->code = "W".date('YmdHis');
						break;
					}
				}
				while($fechaInicio < $fechaFinal);
				//Fin chequeo
			}else
			{
				//CONEXIONES AL WS SOCIOS ONLINE
				if($_POST['rateKey']!="OB")
				{
					if($model->idHotel->proveedor==1)###########################################################HOTELBEDS
					{

						foreach (json_decode(base64_decode($_POST['rateKey'])) as $i_room => $value_rateKey) 
						{
							$bookingResponse=$this->bookingBeds($value_rateKey,$i_room+1);
							$booking=json_decode($bookingResponse);
							$bookingReference=$booking->booking->reference;
							if(empty($bookingReference)){ echo "Ocurrió un error al intentar hacer la reservacion con el Socio Online"; exit; }
							$bookingReferences.="BR".$bookingReference.",";
						}
					
						$supplier=$booking->booking->hotel->supplier;
						
						$bookingReferences=trim($bookingReferences, ',');
						$model->code=$bookingReferences;
						$model->manual=2;

						$comision_hotel = Api::model()->findByPk(1)->markup;
						$model->saldo_h = $this->saldoHotel($model->total,$comision_hotel,"Api");

						//DESGLOSE COMENTARIOS Y PROMOCIONES DE LA TARIFA
						
						$desglose_rate=array();
						$desglose_rate['currency']=$_SESSION['Datos'][0]['currency'];
						$desglose_rate['rateClass']=$_SESSION['Datos'][0]['rate_class'];
			        	$desglose_rate["supplier"]=array('name'=>$supplier->name, 'vatNumber'=>$supplier->vatNumber);
						
						if($_POST['promociones'])
							$desglose_rate['promociones']=base64_decode($_POST['promociones']);				
						
						$model->desglose_rate=json_encode($desglose_rate);
					}else if($model->idHotel->proveedor==3)#################################################TRAVEL SOLUTION
					{
						$travelSolutionController = Yii::app()->createController('travelSolution');
						$travelSolutionController = $travelSolutionController[0];
						$bookingResponse=$travelSolutionController->createBookTravelSolution($model);
						//echo '<textarea rows="10" cols="50">'.$bookingResponse.'</textarea>';
						$booking=json_decode($bookingResponse);
						$bookingReference=$booking->confirmationid;//validar el estatus internet
						$rooms=$booking->Rooms->Room;
						if (count($rooms)>1) {
							foreach ($rooms as $keyroom => $room) {
								$model->fecha_limite_h = $room->CancellationPolicy->PaymentLimitDay;
							}
							$fechaLimiteH=strtotime($room->CancellationPolicy->PaymentLimitDay);
						}else{

							$model->fecha_limite_h = $rooms->CancellationPolicy->PaymentLimitDay;
							$fechaLimiteH=strtotime($rooms->CancellationPolicy->PaymentLimitDay);
						}
						if (empty($model->fecha_limite_h) || (strtotime(date('Y-m-d')>=$fechaLimiteH))) {
							$model->fecha_limite_h=date('Y-m-d');
						}
						
						if(empty($bookingReference) || $bookingReference==0){ echo "Hubo un Error al crear la reserva, la reserva no fue efectuada"; exit; }
						
						$comision_hotel = Api::model()->findByPk(6)->markup;
						$model->saldo_h = $this->saldoHotel($model->total,$comision_hotel,"Api");


						$model->code="TS".$bookingReference;
						$model->manual=2;

						$codigo_hotel=explode("/",$model->idHotel->codigo)[0];
						$hotelSocioOnline=$travelSolutionController->searchHotelTS($codigo_hotel);

						$desglose_rate=array();
						$desglose_rate['currency']=$booking->currency;
						$desglose_rate['operatorname']=$booking->operatorname;
						$desglose_rate['operatoremail']=$booking->operatoremail;
						
						if(!is_object($hotelSocioOnline->AdditionalCharges))
                        {
                            $hotelSocioOnline->AdditionalCharges=strip_tags($hotelSocioOnline->AdditionalCharges);
                            $desglose_rate['additionalCharges']=ucfirst($hotelSocioOnline->AdditionalCharges);
                        }	        	
						
						if($_POST['promociones'])
							$desglose_rate['promociones']=base64_decode($_POST['promociones']);				
						
						$model->desglose_rate=json_encode($desglose_rate);

						// $fotos = HotelesFotos::model()->findAll('id_hotel='.$model->id_hotel.' and logotipo=1 and foto LIKE "'.$hotelSocioOnline->Image.'"');
						// if(count($fotos)==0)
						// {			
			   //              $foto = new HotelesFotos;
						// 	$foto->id_hotel=$model->id_hotel;
						// 	$foto->foto=$hotelSocioOnline->Image;
						// 	$foto->logotipo=1;
			                
			   //              if(!$foto->save())
				  //              	print_r($foto->getErrors());
				            
				  //   	}

						//$model->desglose_rate=json_encode(array('currency'=>$booking->currency,'operatorname'=>$booking->operatorname,'operatoremail'=>$booking->operatoremail));
					}else if($model->idHotel->proveedor==4)
					{
						$riuController=Yii::app()->createController('riu');
						$riuController=$riuController[0];
						$riuReservacion=$riuController->bookingRiu();
						//$riuReservacion=json_decode($riuReservacion);
						
						$reservacion=json_decode($riuReservacion)[0];
						if (empty($reservacion->HotelResResponse->out->customerReservationCode) && empty($reservacion->HotelResResponse->out->hotelReservationCode) && $reservacion->HotelResResponse->out->state!="OK") {
							echo "Hubo un Error al crear la reserva, la reserva no fue efectuada";
							exit;
						}

						$comision_hotel = Api::model()->findByPk(7)->markup;
						$saldo_hotel = $this->saldoHotel($model->total,20,"comision");
						$model->saldo_h = $saldo_hotel;


						$model->code="RI".$reservacion->HotelResResponse->out->customerReservationCode."-".$reservacion->HotelResResponse->out->hotelReservationCode."-".$reservacion->HotelResResponse->out->hotelReservationID;
					}else if($model->idHotel->proveedor==5){
						$dingusController=Yii::app()->createController('dingus');
						$dingusController=$dingusController[0];
						$dingusReservacion=$dingusController->booking($model->idHotel->Cadena->url_dingus, $model->idHotel->Cadena->id);
						$reservacion=$dingusReservacion;
						$hotelResID=$reservacion['OTA_HotelResRS']['HotelReservations']['HotelReservation']['ResGlobalInfo']['HotelReservationIDs']['HotelReservationID']['@attributes']['ResID_Value'];
						if (empty($hotelResID)) {
							echo "Hubo un Error al crear la reserva, la reserva no fue efectuada";
							exit;
						}

						$comision_hotel = $model->idHotel->comision;
						$saldo_hotel = $this->saldoHotel($model->total,$comision_hotel,"comision");
						$model->saldo_h = $saldo_hotel;


						//$model->code="DI";
						$model->code="DI-".$hotelResID;
						$model->politicas_cancelacion=$_SESSION['Datos'][0]['politicas_cancelacion'];
					}else if($model->idHotel->proveedor==6){

						$comision_hotel = Api::model()->findByPk(9)->markup;
						$saldo_hotel = $this->saldoHotel($model->total,$comision_hotel,"Api");
						$model->saldo_h = $saldo_hotel;
					
					}
				}
				else
				{
					$codeHotel=  explode("/",Hoteles::model()->findByPk($_POST["Reservacion"]["id_hotel"])->codigo);				
					$omniBees = Yii::app()->createController('omniBees');
					$omniBees = $omniBees[0];
					$return=$omniBees->bookingOmniBees($codeHotel[0]);
					$array=json_decode($return);
					$bookingReference=$array->SendHotelResResult->HotelReservationsType->HotelReservations->HotelReservation->UniqueID->ID;
					if(empty($bookingReference)){ echo $return; exit; }

					$comision_hotel = $model->idHotel->comision;
					$saldo_hotel = $this->saldoHotel($model->total,$comision_hotel,"comision");
					$model->saldo_h = $saldo_hotel;

					$model->code="OB".$bookingReference;
					$model->manual=2;
				}
			}
		}
		if($outletEstatus && $model->idTarifa->precio=='OUTLET')
		{
			$model->fecha_limite=date('Y-m-d');
			if($model->code=="")
			{
				$model->code="RMT-OUTLET".date('Y-m-d');
			}
		}

		$model->tarifa_agencia=$model->saldo;
		$model->tarifa_neta=$model->saldo_h;
		if ($outlet  and $model->fecha_limite > date('Y-m-d',strtotime('+ 30 days')) && in_array($model->idHotel->proveedor, array(0,2,4,5))  ) {
				$model->fecha_limite =  date('Y-m-d',strtotime('+ 30 days'));
		}
		if($model->save())
		{
			if (!empty( $_SESSION['referencia'])) {
				$referencia=explode('-', $_SESSION['referencia']);
				$logBanco=LogBanco::model()->find('reference="'.$referencia[0].'" and id_recibo=0');
				$LogBanco->id_recibo=$model->id_reservacion;
				$logBanco->save();
			}
			if($_SESSION['ecomerce']['tipo_pago']>7)
			{
					$recibo = new Recibo;
					$importeComision = $_SESSION['ecomerce']['importe']*($_SESSION['ecomerce']['comisionBancomer']/100);
					$recibo->id_tipo = $_SESSION['ecomerce']['tipo_pago'];
					$recibo->id_planpago = $_SESSION['ecomerce']['planPago'];
					$recibo->id_banco = 2;
					$recibo->id_cuenta = 16;
					$recibo->importe =  $_SESSION['ecomerce']['importe'];
					$recibo->id_agencia = $model->id_agencia;
					$recibo->comision =  $_SESSION['ecomerce']['comisionBancomer'];
					$recibo->id_user = Yii::app()->user->getId();
					$recibo->observaciones = "PAGO REALIZADO CON BANCOMER POR SISTEMA DE RESERVACIONES. TIPO DE TARIFA".$_SESSION['ecomerce']['tipo_tarifa'];
					if($recibo->save()){
						$detalle = new ReciboDetalles;
						$detalle->id_recibo = $recibo->id_recibo;
						$detalle->id_reservacion = $model->id_reservacion;
						$detalle->concepto = "Pago Total Reserva #".$model->id_reservacion." Pax: ".$model->nombre_cliente." - Hotel: ".$model->idHotel->nombre_hotel." - ".$model->num_habitaciones." Hab(s).";
						$detalle->importe =   $_SESSION['ecomerce']['importe'];

					

						if($detalle->save())
						{
							$model->saldo = ($detalle->importe +  $importeComision) - $model->total_tc;
							$model->save();
						}
						/*$detalle = new ReciboDetalles;
						$_SESSION['tipo_pago']==9? $comisionBan=$_SESSION['comisionBancomer']:$comisionBan = $model->total*$_SESSION['comisionBancomer'];
						$_SESSION['tipo_pago']==9? $signo = "$".$comisionBan:$signo = $comisionBan."%";
						$detalle->id_recibo = $recibo->id_recibo;
						$detalle->id_reservacion = $model->id_reservacion;
						$detalle->concepto = "Comisión de Bancomer: ".$signo;
						$detalle->importe = $comisionBan;
						$detalle->save();*/
							
						$notificar = Usuarios::model()->findAll('aviso LIKE "%r%"');
						/*foreach($notificar as $user){
							$notificacion = new Notificacion;
							$notificacion->id_item = $model->id_reservacion;
							$notificacion->tipo = 2;
							$notificacion->id_users = $user->id_usuario;
							$notificacion->visto = 0;
							$notificacion->save();
						}*/
				}
			}
			//$habs = 1;
			$broker=explode('-', $model->code);
			$BR=$broker[0];
			$beds=$BR[1].$BR[0];
			$m=0;
			if (isset($_POST['num_habitaciones_aux'])) {
				// condicion que resuelve el problema de guardar habitaciones al editar reservacion
				$desgloseHabs = $_POST['num_habitaciones_aux'];
			}else{
				$desgloseHabs = $model->num_habitaciones;
			}

			for($i=1;$i<=$desgloseHabs;$i++)
			{
				if($_POST['Habitacion_'.$i] != NULL)
				{
					$habitacion=new ReservacionDesglose;
					$habitacion->attributes=$_POST['Habitacion_'.$i];
					$habitacion->id_reservacion = $model->id_reservacion;
					$desgloseB["desglose"]=array();
					for($d=0;$d<$model->num_noches;$d++)
					{
	        	    	array_push($desgloseB["desglose"], array("noche"=>$_SESSION['Cotizacion'][$m][$d][0][$i]['fecha'], "precio_adulto"=>$_SESSION['Cotizacion'][$m][$d][0][$i]['adultos'],"precio_menor"=>$_SESSION['Cotizacion'][$m][$d][0][$i]['menores']));
	        	    	$desgloseB["desglose"][$d]["precioPorMenor"]=array();
	        	    	for ($p=0; $p < $_SESSION['front_form']['habitacion_'.$i]['num_ninios']; $p++) 
	        	    	{
	        	    		array_push($desgloseB["desglose"][$d]["precioPorMenor"],$_SESSION['Cotizacion'][$m][$d][0][$i][$p]);
	        	    	} 
		            }

		        	
		        	$reference=explode(",", $model->code);
		        	$desgloseB["desglose"]["reference"]=$reference[$i-1];
		        	$desgloseB["desglose"]["planHotel"]=$_SESSION['Datos'][0]['boardName'];

		        	if($_POST['rateComments_'.$i])
						$desgloseB["desglose"]['rateComments']=$_POST['rateComments_'.$i];
								
					if($_POST['offers_'.$i])
					{
						$desgloseB["desglose"]['offers']=array();
						foreach(json_decode($_POST['offers_'.$i]) as $offer)
						{
	                        $importeOferta=$offer->amount/$markup;
							array_push($desgloseB["desglose"]['offers'], array("code"=>$offer->name, "name"=>$offer->name,"amount"=>$importeOferta));		            		
			            }
			        }


                    if(!empty($_POST['rateKey']))                  	
                   	$desgloseBeds=json_encode($desgloseB);
                   	else
                   	$desgloseBeds="";
					$habitacion->desgloseBeds=$desgloseBeds;
					if($model->manual == 0 && empty($model->id_bloqueo) && !empty($this->palaceResorts[$model->idHotel->codigo]))
					{
						//if (!$outletEstatus) {
							$wsResponse = $this->palaceWs($model,$habitacion,$i,$_POST['Adulto_1_'.$i]["nombre"],$_POST['Adulto_1_'.$i]["apellido"]);
						//}
						
						if(empty($wsResponse['error'])){
							$model->fecha_limite=implode('-',array_reverse(explode('/',$_SESSION['Datos'][0]['ratePlan'])));
            				//$avisoCancelacion=$_SESSION['Datos'][0]['politicas_cancelacion'];

							$model->code .= "WS".$wsResponse['folio'];
							$model->save();
						}
						else{
							$model->delete();
							throw new CHttpException(500,$wsResponse['error']);
						}
					}
					if($habitacion->save())
					{
						for($a=1;$a<=$habitacion->num_adultos;$a++)
						{
							$adulto=new ReservacionDesglosePersona;
							$adulto->nombre=$_POST['Adulto_'.$a.'_'.$i]["nombre"]." ".$_POST['Adulto_'.$a.'_'.$i]["apellido"];
							$adulto->tipo = 'A';
							$adulto->edad = 30;
							$adulto->id_desglose = $habitacion->id_desglose;
							$adulto->id_reservacion = $model->id_reservacion;
							$adulto->save();
						}
						for($n=1;$n<=$habitacion->num_ninios;$n++){ //Ordenar edades menores mayor a menor
							if($_POST["Ninio_".$n."_".$i.""]["edad"] < $_POST["Ninio_".($n+1)."_".$i.""]["edad"]){
								$aux = $_POST["Ninio_".$n."_".$i.""]["edad"];
								$aux2 = $_POST["Ninio_".$n."_".$i.""]["nombre"];
								$_POST["Ninio_".$n."_".$i.""]["edad"] = $_POST["Ninio_".($n+1)."_".$i.""]["edad"];
								$_POST["Ninio_".$n."_".$i.""]["nombre"] = $_POST["Ninio_".($n+1)."_".$i.""]["nombre"];
								$_POST["Ninio_".($n+1)."_".$i.""]["edad"] = $aux;
								$_POST["Ninio_".($n+1)."_".$i.""]["nombre"] = $aux2; 
								$n=0;
							}
						}
						for($n=1;$n<=$habitacion->num_ninios;$n++)
						{
							$ninio=new ReservacionDesglosePersona;
							$ninio->attributes=$_POST['Ninio_'.$n.'_'.$i];
							$ninio->tipo = 'N';
							$ninio->id_desglose = $habitacion->id_desglose;
							$ninio->id_reservacion = $model->id_reservacion;
							$ninio->save();
						}
					}else
					{
						print_r($habitacion->getErrors());
					}
					//$habs++;
				}
			}
			$notificar = Usuarios::model()->findAll('aviso LIKE "%r%"');
			foreach($notificar as $user){
				$notificacion = new Notificacion;
				$notificacion->id_item = $model->id_reservacion;
				$notificacion->tipo = 2;
				$notificacion->id_users = $user->id_usuario;
				$notificacion->visto = 0;
				$notificacion->save();
			}
				
					$this->enviaEmail($model);
				

			return $model;
		}
		else
		{
			print_r($model->getErrors());
		}
	}
	public function saldoHotel($importe,$comision,$tipo){
		
		if ($tipo == "Api") {
		
		$obtener_saldo_h = $importe * $comision;
		
		}else{
		
		$obtener_saldo_h = $importe - ($importe*($comision/100));
		
		}

		return $obtener_saldo_h;
	}
	public function reservarBeds($request)
	{
		$hotelApi = new HotelApi();
		$estatus = $hotelApi->estatus();
		if($estatus=="OK")
		{
			$logHotelbeds['header'] = "book";
			$logHotelbeds['request'] = $request;
			$idlogws=$this->logWsRequest($logHotelbeds,'Beds'); 
			$response = $hotelApi->bookingConfirmation($request);

			$logHotelbeds['response'] = $response;
			$booking=json_decode($response);
			$bookingReference=$booking->booking->reference;
			$logHotelbeds['reference'] = $bookingReference;
			$this->logWsResponse($idlogws,$logHotelbeds);
			return $response;
		}
		else
		{
			return "No hubo conexión";
		}
	}
	public function bookingBeds($rateKey,$i)
	{
		$request=array();
		$request["holder"]["name"]= $_POST['Adulto_1_'.$i]["nombre"];
		$request["holder"]["surname"]= $_POST['Adulto_1_'.$i]["apellido"];
		$request["rooms"][0]["rateKey"]=$rateKey;
		$request["rooms"][0]["paxes"]=array();
				
		for ($j=1; $j <= $_POST["Habitacion_".$i]["num_adultos"]; $j++) {
			$pax=array('roomId'=>1,'type'=>'AD','age'=>30,'name'=>$_POST['Adulto_'.$j.'_'.$i]["nombre"],'surname'=>$_POST['Adulto_'.$j.'_'.$i]["apellido"]);
			array_push($request["rooms"][0]["paxes"],$pax);				
		}
				
		for ($j=1; $j <= $_POST["Habitacion_".$i]["num_ninios"]; $j++) {
			$pax=array('roomId'=>1,'type'=>'CH','age'=>(int)$_POST["Ninio_".$j."_".$i.""]["edad"]);
			array_push($request["rooms"][0]["paxes"],$pax);
		}	
		
		$request["clientReference"]="RMT".date("YmdHi");
		$e=$this->reservarBeds(json_encode($request));
		return $e;
	}
	public function noches($fecha_inicio,$fecha_final)
	{
		$datetime1 = new DateTime($fecha_inicio);
		$datetime2 = new DateTime($fecha_final);
		$interval = $datetime1->diff($datetime2);
		$noches= $interval->format('%a');
		return $noches;
	}
	private function quitarCarrito($n)
	{
		unset($_SESSION['Datos'][$n],$_SESSION['Cotizacion'][$n],$_SESSION['Menores'][$n],$_SESSION['TotalCotiz'][$n]);
		$_SESSION['CountCotiz']--;
	}
	private function palaceWs($model,$habitacion,$numHab, $nombre, $apellido)
	{
		$ini = ini_set("soap.wsdl_cache_enabled","0");
		$client = new SoapClient($this->clientUrl);
		$wsResponse = array();
		$tarifa = Tarifa::model()->findByPk($model->id_tarifa);
		$tipo_hab = TipoHabitaciones::model()->findByPk($habitacion->id_tipo_habitacion);
		/*$nombre = $_POST['Adulto_1_'.$i]["nombre"]; 
		$apellido = $_POST['Adulto_1_'.$i]["apellido"];*/
		$adultos = $habitacion->num_adultos;
		$menores = $habitacion->num_ninios;
		$juniors = 0;
		$ninios = 0;
		$bebes = 0;
		$personas = $adultos + $menores;
		if($personas > 2){
			$tipo_cama = "D";
		}else{
			$tipo_cama = "K";
		}
		if($tipo_hab == "FL"){
			if($tipo_cama == "K"){
				$tipo_hab .= "1";
			}else if($tipo_cama == "D"){
				$tipo_hab .= "2";
			}
		}
		//$cliente = explode(' ',$model->nombre_cliente);
		for($n=1;$n<=$habitacion->num_ninios;$n++)
		{
			$ninio=new ReservacionDesglosePersona;
			$ninio->attributes=$_POST['Ninio_'.$n.'_'.$numHab];
			if($ninio->edad <= 3){
				$bebes++;
			}else if($ninio->edad > 3 && $ninio->edad <= 12){
				$ninios++;
			}else if($ninio->edad > 12 && $ninio->edad <= 17){
				$juniors++;
			}
		}
		$parametros = array("reservationRequest"=>array( 
			"data"=>array(
			 "referred"=>"false",
			 "Folio"=>0,
			 "Hotel"=>$model->idHotel->codigo, //"MPS",
			 "Room_Type"=>$tipo_hab->codigo, //"OV",
			 "Bed_Type"=>$tipo_cama, //"K",
			 "Arv_Date"=>$model->fecha_inicial."T00:00:00.0000000-05:00", //"2015-12-22T00:00:00.0000000-05:00",
			 "Nights"=>$model->num_noches,
			 /*"Ent_User"=>"RMY",
			 "Ent_Term"=>"RMY",*/
			 "Ent_User"=>"RMY",
			 "Ent_Term"=>"RMY",
			 "Guest_Type"=>"I",
			 "Amount"=>0,
			 "Origen"=>"None",
			 "Pax"=>array(
				"Adult"=>$adultos,
				"Kid"=>$juniors,
				"Child"=>$ninios,
				"Baby"=>$bebes,
			 ),
			 "Name"=>array(
				//"First_Name"=>$cliente[0]." ".$cliente[1],
				//"Last_Name"=>$cliente[2]." ".$cliente[3],
				"First_Name"=>$model->nombre_cliente,
				"Last_Name"=>$model->apellido_cliente,
				"Gender"=>"None",
				"Email"=>"fernandoeuan@rutamayatravel.com",//$model->idAgencia->email_agencia,
				"BirthDay"=>"0001-01-01T00:00:00.0000000-05:00",
			 )
			),
			"AgencyCode"=>"RMAYA",
			"PromotionCode"=>$tarifa->codigo, //"TOCSAI",
			"AgencyCreditCardExpirationMonth"=>0,
			"AgencyCreditCardExpirationYear"=>0,
			"AuthInfo"=>array(  
			 "Recnum"=>0,
			 "Ent_User"=>"RMY",
			 "Ent_Pass"=>"QMrq8UzEru",
			 "Ent_Term"=>"RMY"
			 )
			 )
		);
		//$result = $client->GetReservation($parametros);
//$xmlRequest = ArrToXml::parse($parametros);
$xml='<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"><soap:Body><GetReservation xmlns="http://localhost/xmlschemas/enterpriseservice/16-07-2009/"><reservationRequest xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservationRequest.xsd"><data><referred xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">false</referred><Folio xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">0</Folio><Hotel xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">'.$model->idHotel->codigo.'</Hotel><Room_Type xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">'.$tipo_hab->codigo.'</Room_Type><Bed_Type xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">'.$tipo_cama.'</Bed_Type><Arv_Date xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">'.$model->fecha_inicial.'T00:00:00.0000000-05:00</Arv_Date><Nights xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">'.$model->num_noches.'</Nights><Pax xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd"><Adult>'.$adultos.'</Adult><Child>'.$ninios.'</Child><Kid>'.$juniors.'</Kid><Baby>'.$bebes.'</Baby></Pax><Name xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd"><First_Name>'.$nombre.'</First_Name><Last_Name>'.$apellido.'</Last_Name><Gender>None</Gender><Email>fernandoeuan@rutamayatravel.com</Email><BirthDay>0001-01-01T00:00:00.0000000-05:00</BirthDay></Name><Guest_Type xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">I</Guest_Type><Ent_User xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">RMY</Ent_User><Ent_Term xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">RMY</Ent_Term><Amount xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">0</Amount><Origen xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/reservation.xsd">None</Origen></data><AgencyCode>RMAYA</AgencyCode><PromotionCode>'.$tarifa->codigo.'</PromotionCode><AgencyCreditCardExpirationMonth>0</AgencyCreditCardExpirationMonth><AgencyCreditCardExpirationYear>0</AgencyCreditCardExpirationYear><AuthInfo><Recnum xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">0</Recnum><Ent_User xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">RMY</Ent_User><Ent_Pass xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">QMrq8UzEru</Ent_Pass><Ent_Term xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">RMY</Ent_Term></AuthInfo></reservationRequest></GetReservation></soap:Body></soap:Envelope>';
//echo $xml;
	$xmlAux=$xml;
				$url = 'https://api.palaceresorts.com/EnterpriseServiceInterface/ServiceInterface.asmx?wsdl';
				$action = 'http://localhost/xmlschemas/enterpriseservice/16-07-2009/GetReservation';
				$client = new SoapClient(null, array(
				'location' => $url,
				'uri'      => "",
				'trace'    => 1,
				));
				try{
				    $result = $client->__doRequest($xml, $url, $action, 1);
					//print_r($result);
				    $xml = simplexml_load_string($result, NULL, NULL, "http://schemas.xmlsoap.org/soap/envelope/");
					$ns = $xml->getNamespaces(true);
					$soap = $xml->children($ns['soap']);
					$body = $soap->Body->children($ns['GetReservationResponse']);
					$result=$body->GetReservationResponse;
				//	echo "Folio:".$result->folioResponse->Folio;
				}catch (SoapFault $exception){
					echo "falló";
				    print_r($exception.$nombre);
				    echo " ".$nombre."-".$apellido."-".$i;
				    $ex=$exception;
				}
		$error = "";
		if($result->folioResponse->HasErrors!="false"){
		  $error = $result->folioResponse->ExceptionInfo->Type." ".$result->folioResponse->ExceptionInfo->Message;
		}
		  else
		{
		  $folio = (string) $result->folioResponse->Folio;
		}
		$wsResponse = array('error'=>$error,'folio'=>$folio);
			$logHotelbeds['header'] = "Book";
			$logHotelbeds['request'] = $xmlAux;
			$logHotelbeds['response'] = $logHotelbeds['response'] = $responselog;
			$logHotelbeds['reference'] = $folio;
			//$this->logWs($logHotelbeds,'Palace'); 
		return $wsResponse;
	}
	public function enviaEmail($model)
	{
		$this->outlet = Outlet::model()->find('estatus=1');
		$outletEstatus=$this->eventoOutlet($this->outlet);

		$encabezados  = "MIME-Version: 1.0\n";
		$encabezados .= "Content-type: text/html; charset=UTF-8\n";
		$encabezados .= "From:  Ruta Maya Travel <no-reply@rutamayatravel.com>\n";
		$encabezados .= "X-Sender: <contacto web>\n";
		$encabezados .= "X-Mailer: PHP\n";
		$encabezados .= "X-Priority: 3\n";
		$encabezados .= "Return-Path: <web page>\n";
		$subject = "Felicidades, su reservación ha sido creada con éxito";
		$cancelaciones = $this->cancelaciones($model,$model->fecha_inicial,$model->id_tarifa);
		$message = "<div align='center' style='width:400px;font-family:helvetica'>
						<img src='http://".$_SERVER['SERVER_NAME']."".Yii::app()->baseUrl."/images/logo_rutamaya.jpg' border='1'>
						<div style='background:#2196f3;color:#fff;padding:24px;font-size:24px;font-weight:bold'>
							Estimado ".$model->nombre_cliente." ".$model->apellido_cliente."<br>
							su reservación ha sido creada con éxito.
						</div>
						<h4>Los datos de su reservación son:</h4>
						<p>No. de Cupón: <strong>".$model->id_reservacion."</strong><br>
						Agencia: <strong>".$model->idAgencia->nombre_agencia."</strong><br>
						Hotel: <strong>".$model->idHotel->nombre_hotel."</strong><br>
						Fecha Entrada: <strong>".date('d/m/Y',strtotime($model->fecha_inicial))."</strong><br>
						Fecha Final: <strong>".date('d/m/Y',strtotime($model->fecha_final))."</strong><br>
						Plan: <strong>".$model->idTipoPlan->nombre."</strong><br>
						Noches: <strong>".$model->num_noches."</strong><br>
						No. de Habitaciones: <strong>".$model->num_habitaciones."</strong><br>
						Agente Preferido: <strong>".$model->idAgente->nombre_usuario."</strong><br></p>
						<p>Para ver más detalles del cupón haga clic en el link: <a href='https://".$_SERVER['SERVER_NAME']."".Yii::app()->baseUrl."/reservacion/view/id/".$model->id_reservacion."'>Ver Cupón</a></p>
						".($model->libera_cupon == 0 && !empty($model->fecha_limite) ? "<p>Su Fecha Límite de pago es: <strong>".date('d/m/Y',strtotime($model->fecha_limite))."</strong><br>Para descargar su orden de pago de clic en el siguiente link. Agradecemos su pronto pago.<br>
						<a href='https://".$_SERVER['SERVER_NAME']."/reservaciones/yii_rutamaya/index.php/site/proforma/".$model->id_reservacion."'>Descargar Orden de Pago</a></p>":"")."
						<hr>
						<h4>Políticas de Cancelación:</h4>
						<p>".(empty($cancelaciones) ? 'No Aplica':$cancelaciones)."</p>
						<hr>
						<h4>SI TIENES ALGUNA DUDA CONTÁCTANOS, CON GUSTO TE ASESORAREMOS</h4>
						<h4>Tels: (999) 925-54-43</h4>
						<h4>Atentamente el equipo de Ruta Maya Travel</h4>
					</div>";
		$subject2 = "RESERVA RMT#".$model->id_reservacion." ".strtoupper($model->nombre_cliente)." ".strtoupper($model->apellido_cliente);
		$desglose = ReservacionDesglose::model()->findAll('id_reservacion='.$model->id_reservacion);
		$num_adultos = 0;
		$num_menores = 0;
		$i = 1;

		/*<tr>
								<td style="font-size:16px">CLIENTE:</td>
								<td colspan="3" style="font-size:16px"><strong>'.strtoupper($model->nombre_cliente).' '.strtoupper($model->apellido_cliente).'</strong></td>
							</tr>*/
		$message2 = '<div style="font-family:Helvetica">
					<img src="http://'.$_SERVER['SERVER_NAME'].''.Yii::app()->baseUrl.'/images/logo_rutamaya.jpg" style="width:30px"><br>
					<table border="1" bordercolor="#000000">
						<tbody>
							<tr>
								<td align="center" colspan="4" style="background:#CCC; font-size:22px">SOLICITUD DE RESERVACION</td>    
							</tr>
							<tr>
								<td>MERIDA, YUC.</td>
								<td>FECHA:</td>
								<td colspan="2">'.date('d/m/Y').'</td>
							</tr>
							<tr>
								<td colspan="3">DEPARTAMENTO DE RESERVACIONES:</td>
								<td align="center">'.strtoupper($model->idHotel->contacto_reservas_1).'</td>
							</tr>
							<tr>
								<td style="font-size:16px">HOTEL:</td>
								<td colspan="3" style="font-size:16px"><strong>'.strtoupper($model->idHotel->nombre_hotel).'</strong></td>
							</tr>
							
							<tr>
								<td>FAVOR DE:</td>
								<td align="center" colspan="3" style="font-size:16px"><strong>CONFIRMAR</strong></td>
							</tr>
							<tr>
								<td>CUPÓN RMT:</td>
								<td colspan="3">'.$model->id_reservacion.'</td>
							</tr>';
		foreach($desglose as $hab)
		{	
			$pax = ReservacionDesglosePersona::model()->find('id_desglose='.$hab->id_desglose.' and id_reservacion='.$hab->id_reservacion);
			$menores = ReservacionDesglosePersona::model()->findAll('id_desglose='.$hab->id_desglose.' and id_reservacion='.$hab->id_reservacion.' and tipo="N"');
			$num_adultos += $hab->num_adultos;
			$num_menores += $hab->num_ninios;
			$message2 .= '<tr>
							<td><strong>PAX '.$i.'</strong></td>
							<td colspan="2"><strong>'.$pax->nombre.' </td><td>HAB '.$hab->idbasehabitacion->base_habitacion;
				if(!empty($menores))
				{
					$message2 .= ' + '.$hab->num_ninios.' MNRS / ';
					foreach($menores as $mnr){
						$message2 .= $mnr->edad.',';
					}
					$message2 = substr($message2, 0, -1);						
					$message2 .= ' AÑOS</strong></td>
								</tr>
								<tr>
									<td colspan="4">&nbsp;</td>
								</tr>';
				}
				else{
					$message2 .= '</strong></td></tr>
								<tr>
									<td colspan="4">&nbsp;</td>
								</tr>';
				}
			$i++;
		}
		$message2 .= '<tr>
						<td>IN:</td>
						<td colspan="3" style="background:#CCC;"><strong>'.date('d/m/Y',strtotime($model->fecha_inicial)).'</strong></td>
					</tr>
					<tr>
						<td>OUT:</td>
						<td colspan="3" style="background:#CCC;"><strong>'.date('d/m/Y',strtotime($model->fecha_final)).'</strong></td>
					</tr>
					<tr>
						<td colspan="4">&nbsp;</td>
					</tr>
					<tr>
						<td>NUM. NOCHES:</td>
						<td colspan="3"><strong>'.$model->num_noches.' NOCHES</strong></td>
					</tr>
					<tr>
						<td>No. HAB:</td>
						<td colspan="3"><strong>'.$model->num_habitaciones.'</strong></td>
					</tr>
					<tr>
						<td>TIPO:</td>
						<td colspan="3"><strong>'.$desglose[0]->idtipohabitacion->tipo_habitacion.'</strong></td>
					</tr>
					<tr>
						<td>No. ADTS</td>
						<td align="center">'.$num_adultos.'</td>
						<td>No. MNRS</td>
						<td align="center">'.$num_menores.'</td>
					</tr>
					<tr>
						<td>PLAN</td>
						<td colspan="3"><strong>'.$model->idTipoPlan->nombre.'</strong></td>
					</tr>
					<tr>
						<td>COD. TARIFA</td>
						<td colspan="3"><strong>'.$model->idTarifa->nombre_tarifa.' ('.$model->idTarifa->codigo.')</strong></td>
					</tr>
					<tr>
						<td align="center" colspan="4"><strong>OBSERVACIONES:</strong></td>
					</tr>
					<tr>
						<td colspan="4" rowspan="4" style="background:#CCC;"><strong>'.$model->observaciones.'</strong></td>
					</tr>';
		$message2 .= '</tbody></table><br>';
		$message2 .= "Enviado por: <strong>".$model->idAgente->nombre_usuario."</strong><br>
					Responder a: <strong>".$model->idAgente->email_usuario."</strong><br>
					<span style='color:#001e7b'>Av. Cupules #236 x 20 y 22 Col. García Ginerés.<br>Mérida, Yucatán, México.<br>Tels. 925-56-18 y 286-49-90<br><u>www.rutamayatravel.com</u></span></div>";
		$mail = new JPhpMailer;
		$mail->IsSMTP();
		$mail->Host = 'rutamayatravel.com'; 
		$mail->SMTPAuth = true;
		$mail->Username = 'no-reply@rutamayatravel.com'; 
		$mail->Port = '26'; 
		$mail->Password = 'Intelred76'; 
		$mail->SMTPKeepAlive = true;  
		$mail->Mailer = "smtp"; 
		$mail->IsSMTP();  
		$mail->SMTPAuth = true;  
		$mail->CharSet = 'utf-8';  
		$mail->SMTPDebug  = 0;
		$mail->SetFrom('no-reply@rutamayatravel.com', 'Sistema Ruta Maya Travel'); 
		$mail->Subject = $subject; 
		$mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; 
		$mail->MsgHTML($message);
		$mail->AddAddress($model->idUser->email_usuario, $model->idUser->nombre_usuario);
		$mail->AddAddress($model->idAgencia->email_agencia, $model->idAgencia->nombre_agencia);
		$mail->AddAddress($model->idAgente->email_usuario, $model->idAgente->nombre_usuario);
		$mail->Send();
		//envio de correo al hotel
		//si es modificacion no se envia el correo al hotel

		if(!empty($model->idHotel->email_reservas_1) && $model->manual == 0 && $model->idHotel->proveedor==0 && empty($model->id_bloqueo) && !isset($_GET['id'])){
			$mail->ClearAddresses();
			$mail->Subject = $subject2;
			$mail->MsgHTML($message2);
			if ($outletEstatus && $model->idTarifa->precio=='OUTLET' && $this->outlet->tipo=="VERANO") {
					$enviado=false;	
			}else
			{
				if($model->idTarifa->precio!='OUTLET' || $this->outlet->tipo!="VERANO")
				{
					$mail->AddAddress($model->idHotel->email_reservas_1, $model->idHotel->contacto_reservas_1);		
					//$mail->AddAddress('soporte@rutamayatravel.com');
					$enviado=true;
				}
			}
			$mail->AddAddress($model->idAgente->email_usuario, $model->idAgente->nombre_usuario);
			if($mail->Send())
					{
						if ($enviado) {
							$model->enviado_h=1;
							$model->save();	
						}
						
					}	
			
		}
	}
	public function actionLiberar($id)
	{
		$model=$this->loadModel($id);
		$model->libera_cupon=1;
		$model->fecha_liberacion=date('Y-m-d');
		$model->usuario_liberacion=Yii::app()->user->id;
		if($model->save()){
			$operacion = Yii::app()->createController('operacionesLog');
			$operacion = $operacion[0];
			$operacion->Create($model->id_reservacion,20);
			$this->redirect(array('view','id'=>$model->id_reservacion));
		}
	}
	public function actionPrefetch()
	{
		$session=new CHttpSession;
		$session->open();
		$model = new Reservacion;
		
		if(isset($_POST['Reservacion']))
		{
			$_SESSION['Reservacion']=$_POST;
			$model->attributes=$_POST['Reservacion'];
			$n = 0;

			// para guardar formulario en el cambio de session a array
			$_SESSION['Formulario_reservar'][0]['id_agencia'] = $model->id_agencia;
			$_SESSION['Formulario_reservar'][0]['id_agente'] = $model->id_agente;
			$_SESSION['Formulario_reservar'][0]['nombre_cliente'] = $model->nombre_cliente;
			$_SESSION['Formulario_reservar'][0]['apellido_cliente'] = $model->apellido_cliente;
			$_SESSION['Formulario_reservar'][0]['tel_cliente'] = $model->tel_cliente;

			$_SESSION['Datos'][$n]['id_agencia'] = $model->id_agencia;
			$_SESSION['Datos'][$n]['id_agente'] = $model->id_agente;
			$_SESSION['Datos'][$n]['nombre_cliente'] = $model->nombre_cliente;
			$_SESSION['Datos'][$n]['apellido_cliente'] = $model->apellido_cliente;
			$_SESSION['Datos'][$n]['tel_cliente'] = $model->tel_cliente;
			for($i=1;$i<=$model->num_habitaciones;$i++):
				$adultos = $_SESSION['Datos'][$n]['front_form']['habitacion_'.$i]['adultos'];
				for($a=1;$a<=$adultos;$a++){
					$_SESSION['Datos'][$n]['front_form']['habitacion_'.$i]['adulto_'.$a] = $_POST['Adulto_'.$a.'_'.$i]['nombre'];
					$_SESSION['Datos'][$n]['front_form']['habitacion_'.$i]['adulto_apellido_'.$a] = $_POST['Adulto_'.$a.'_'.$i]['apellido'];

					// para guardar formulario en el cambio de session a array
					$_SESSION['Formulario_reservar'][0]['habitaciones'][$i]['adulto_'.$a] = $_POST['Adulto_'.$a.'_'.$i]['nombre'];
					$_SESSION['Formulario_reservar'][0]['habitaciones'][$i]['adulto_apellido_'.$a] = $_POST['Adulto_'.$a.'_'.$i]['apellido'];

				}
				$num_ninios = $_SESSION['Datos'][$n]['front_form']['habitacion_'.$i]['num_ninios'];
				for($m=1;$m<=$num_ninios;$m++){
					$_SESSION['Datos'][$n]['front_form']['habitacion_'.$i]['ninio_'.$m] = $_POST['Ninio_'.$m.'_'.$i]['nombre'];
					$_SESSION['Datos'][$n]['front_form']['habitacion_'.$i]['ninio_apellido_'.$m] = $_POST['Ninio_'.$m.'_'.$i]['apellido'];

					// para guardar formulario en el cambio de session a array
					$_SESSION['Formulario_reservar'][0]['habitaciones'][$i]['ninio_'.$m] = $_POST['Ninio_'.$m.'_'.$i]['nombre'];
					$_SESSION['Formulario_reservar'][0]['habitaciones'][$i]['ninio_apellido_'.$m] = $_POST['Ninio_'.$m.'_'.$i]['apellido'];
				}

				
			endfor;
		}
		// echo json_encode($_SESSION['Formulario_reservar']);
		echo "Success";
	}
	public function actionProcess($paypalv=null)
	{
		$session=new CHttpSession;
		$session->open();
		$url_back = explode('?', $_POST['url']);
		$_SESSION['url']= $url_back[0];
		include_once("config.php");
		include_once("functions.php");
		include_once("paypal.class.php");
			$paypal= new MyPayPal();
			//if(_GET('paypal')=='checkout'){
			if($paypalv=='checkout'){
				if (!empty($_SESSION['Datos'][$_POST['itemcarrito']])) {
					$products = array();
					$n = $_POST['itemcarrito'];
					$num_habitaciones = $_SESSION['Datos'][$n]['front_form']['habs'];
					$fecha_inicial = str_replace('/','-',$_SESSION['Datos'][$n]['fecha_inicio']);
					$fecha_final = str_replace('/','-',$_SESSION['Datos'][$n]['fecha_final']);
					$num_noches = $_SESSION['Datos'][$n]['noches'];
					$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$_SESSION['Datos'][$n]['id_hotel'].' and estatus=1');
					$base_habitacion = BaseHabitacion::model()->findAll();
					$total = $_SESSION['TotalCotiz'][$n][0]['total_neto'];
					$desc = $num_habitaciones;
					$desc .=$num_habitaciones>1?' habitaciones':' habitación';
					$desc .= " para ".$num_noches;
					$desc .= $num_noches.$num_noches>1?' noches':' noche';
					$desc .= " del ".$fecha_inicial." al ".$fecha_final;
					/*for($i=1;$i<=$num_habitaciones;$i++){
						for($d=0;$d<$num_noches;$d++)
		                {
		                    if(!empty($_SESSION['Menores'][$n])){
		                        $desc.= "FECHA: ".$_SESSION['Cotizacion'][$n][$d][0][$i]['fecha']." PRECIO ADULTO: $".$_SESSION['Cotizacion'][$n][$d][0][$i]['adultos']."NO. DE MENORES: ".$_SESSION['Menores'][$n][$d][0][$i]." PRECIO POR MENORES: $".$_SESSION['Cotizacion'][$n][$d][0][$i]['menores']." SUB-TOTAL: $".$_SESSION['Cotizacion'][$n][$d][0][$i]['total']." ";
		                        //$desc.= "FECHA: ".$_SESSION['Cotizacion'][$n][$d][0][$i]['fecha']."/r/n";
		                    }
		                    else{
		                        $desc.= "FECHA: ".$_SESSION['Cotizacion'][$n][$d][0][$i]['fecha']." PRECIO ADULTO: $".$_SESSION['Cotizacion'][$n][$d][0][$i]['adultos']." PRECIO POR MENORES: $".$_SESSION['Cotizacion'][$n][$d][0][$i]['menores']." SUB-TOTAL: $".$_SESSION['Cotizacion'][$n][$d][0][$i]['total']." ";
		                        //$desc.= "FECHA: ".$_SESSION['Cotizacion'][$n][$d][0][$i]['fecha']."/r/n";
		                    }
		                } 
					}*/
					$products[0]['ItemName'] = "Reservacion de ".$_SESSION['Datos'][$n]['nombre_cliente']; //Item Name
					$products[0]['ItemPrice'] = _POST('itemprice'); //Item Price
					$products[0]['ItemNumber'] = 1; //Item Number
					//$products[0]['ItemDesc'] = _POST('itemdesc'); //Item Number
					$products[0]['ItemDesc'] = $desc; //Item Number
					$products[0]['ItemQty']	= 1; // Item Quantity
					$charges = array();
					$charges['TotalTaxAmount'] = 0;  //Sum of tax for all items in this order. 
					$charges['HandalingCost'] = 0;  //Handling cost for this order.
					$charges['InsuranceCost'] = 0;  //shipping insurance cost for this order.
					$charges['ShippinDiscount'] = 0; //Shipping discount for this order. Specify this as negative number.
					$charges['ShippinCost'] = 0; //Although you may change the value later, try to pass in a shipping amount that is reasonably accurate.
					$_SESSION['itemcarrito']=$_POST['itemcarrito'];
					$paypal->SetExpressCheckOut($products, $charges);
				}
				else
				{
					$this->redirect(array('error'));
				}	
			}
			elseif(_GET('token')!=''&&_GET('PayerID')!=''){
				$res=$paypal->DoExpressCheckoutPayment();
				//TRANSACCION EXITOSA
				if('Completed' == $res["PAYMENTINFO_0_PAYMENTSTATUS"]){
					$session=new CHttpSession;
					$session->open();
					$_SESSION['pagado'] = true;
					$this->redirect(array('create','carrito'=>$_SESSION['itemcarrito'],'res'=>1));
				}
				//TRANSACCION PENDIENTE
				elseif('Pending' == $res["PAYMENTINFO_0_PAYMENTSTATUS"]){
					$this->redirect(array('create','carrito'=>$_SESSION['itemcarrito'],'res'=>2));
					//header('Location: '.$_SESSION['url'].'?res=2');
				}
				//TRANSACCION INCOMPLETA O CON ERRORES
				else{
					$this->redirect(array('create','carrito'=>$_SESSION['itemcarrito'],'res'=>0,'error'=>$res['L_LONGMESSAGE0']));
					//header('Location: '.$_SESSION['url'].'?res=0&error='.$res['L_LONGMESSAGE0']');
				}
			}
			else{
			}
	}

	public function actionTcProcess()
	{
		$session=new CHttpSession;
		$session->open();
		$pago="cancelado";
		
		$referencia = Yii::app()->request->getPost('Ds_Order', 0);
		
		if (!empty($referencia)) {
			$reference=explode('-', $referencia);
			$logbanco=LogBanco::model()->find('reference="'.$referencia.'" and id_recibo=0');
			$pago=$logbanco->estatus;
		}
	
		switch ($pago) {
			case 'Aceptado':
				
				$_SESSION['pagado'] = true;
				// echo "si llego";
				echo $this->createBooking($logbanco->reserva);
				break;
			case 'Declinado':
				$logbanco->id_recibo=1;
				$logbanco->save();	
				break;
			default:
				
				$this->redirect(array('create','carrito'=>$reference[1],'cancel'=>1));
				break;
		}
		
	}

	public function actionTcProcessBanco($val)
	{
		$session=new CHttpSession;
		$session->open();
		$pago="Declinado";
		$reservacion=array();
		if (isset($_GET['reference']) && !empty($_GET['reference'])) {
			
			$logbanco=LogBanco::model()->find('reference="'.$_GET['reference'].'" AND tipo="RESERVACION"');
			
		}
		
		switch ($val) {
			case 'ok':
				if ($logbanco->id_recibo!=0) {
					$this->redirect(array('create','carrito'=>0,'cancel'=>1, 'error'=>$logbanco->error));
				}else{
 
					$this->redirect(array('view','id'=>$logbanco->id_recibo));
				}
					
				break;
			case 'ko':
				if ($_SESSION['referencia']) {
					$logbanco=LogBanco::model()->find('reference="'.$_SESSION['referencia'].'" AND tipo="RESERVACION"');
				}
				if ($logbanco) {
					$logbanco->error="No procedio el pago";
					$logbanco->save();
				}
				unset($_SESSION['referencia']);
				$this->redirect(array('CreateReservacion','carrito'=>0,'cancel'=>1, 'ref'=>$_GET['ref']));
				break;
			default:
				unset($_SESSION['referencia']);
				$this->redirect(array('CreateReservacion','carrito'=>0,'cancel'=>1, 'ref'=>$_GET['ref']));
				break;
		}
		
	}

	public function actionValidarfechalimite()
	{
		//if($_SERVER['REMOTE_ADDR'] != '108.179.229.76')
		//if($_SERVER['REMOTE_ADDR'] != '173.213.96.108')
		if($_SERVER['REMOTE_ADDR'] != '195.201.26.84')	
    		throw new CHttpException(403,'Access denied.');
		//$model = Reservacion::model()->findAll('fecha_limite is not null and id_bloqueo is null and current_date <= fecha_limite and libera_cupon=0 and estatus!="C"');
		$model = Reservacion::model()->findAll('fecha_limite is not null and id_bloqueo is null and current_date <= fecha_limite  and estatus!="C"');
		foreach($model as $row)
		{
			$pago = ReciboDetalles::model()->with('idRecibo')->findAll('id_reservacion='.$row->id_reservacion.' and estado!="C"');
			if(!empty($pago))
				continue;
			if(date('Y-m-d',strtotime('+2 days')) == $row->fecha_limite)
			{
				$this->emailFechalimite($row,1);
			}
			else if(date('Y-m-d',strtotime('now')) == $row->fecha_limite)
			{
				$row->motivo = "Fecha límite vencida<br />Fecha: ".date('d/m/Y H:i:s')." Cancelado por Sistema";
				$row->estatus = "C";
				$row->save();
				$this->emailFechalimite($row,2);
			}
		}
	}
	private function emailFechalimite($model,$tipo)
	{
		$encabezados  = "MIME-Version: 1.0\n";
		$encabezados .= "Content-type: text/html; charset=UTF-8\n";
		$encabezados .= "From:  Ruta Maya Travel <no-reply@rutamayatravel.com>\n";
		$encabezados .= "X-Sender: <contacto web>\n";
		$encabezados .= "X-Mailer: PHP\n";
		$encabezados .= "X-Priority: 3\n";
		$encabezados .= "Return-Path: <web page>\n";
		if($tipo == 1)
		{
			$subject = "Aviso de Fecha Límite de Reservación";
			$message = "<div align='center' style='width:400px;font-family:helvetica'>
							<img src='http://".$_SERVER['SERVER_NAME']."".Yii::app()->baseUrl."/images/logo_rutamaya.jpg' border='1'><br>
							<p>Estimada agencia de viajes ".$model->idAgencia->nombre_agencia." por este medio le informamos que su tiempo límite dado para el pago de la reserva <b>#".$model->id_reservacion."</b> se vence el dia
							".date('d/m/Y',strtotime($model->fecha_limite)).". Por lo cual le sugerimos tener en cuenta realizar el pago puntual para evitar cancelaciones.</p>
							<p>Saludos Cordiales<br>Depto. Contable<br>Ruta Maya Travel.</p>
							<p><span style='color:#001e7b'>Av. Cupules #236 x 20 y 22 Col. García Ginerés.<br>Mérida, Yucatán, México.<br>Tels. 925-56-18 y 286-49-90<br><u>www.rutamayatravel.com</u></span></p>
						</div>";
		}
		else{
			$subject = "Tiempo Límite de Reservación Agotado";
			$message = "<div align='center' style='width:400px;font-family:helvetica'>
							<img src='http://".$_SERVER['SERVER_NAME']."".Yii::app()->baseUrl."/images/logo_rutamaya.jpg' border='1'><br>
							<p>Estimada agencia de viajes ".$model->idAgencia->nombre_agencia.", por este medio le informamos que su tiempo límite dado para el pago de la reserva <b>#".$model->id_reservacion."</b> se ha vencido. 
							Por lo cual lamentablemente su reserva ha quedado cancelada. En caso de querer reinstalarla, hacemos de su conocimiento que quedaría sujeta a espera y tarifa vigente.</p>
							<p>Para cualquier aclaración le pedimos comunicarse con nosotros al area contable a los telefonos (999)9255443 ó (999)2864990</p>
							<p>Atentamente<br>Depto. Contable<br>Ruta Maya Travel</p>
							<p><span style='color:#001e7b'>Av. Cupules #236 x 20 y 22 Col. García Ginerés.<br>Mérida, Yucatán, México.<br>Tels. 925-56-18 y 286-49-90<br><u>www.rutamayatravel.com</u></span></p>
						</div>";
		}
		$mail = new JPhpMailer;
		$mail->IsSMTP();
		$mail->Host = 'rutamayatravel.com'; 
		$mail->SMTPAuth = true;
		$mail->Username = 'no-reply@rutamayatravel.com'; 
		$mail->Port = '26'; 
		$mail->Password = 'Intelred76'; 
		$mail->SMTPKeepAlive = true;  
		$mail->Mailer = "smtp"; 
		$mail->IsSMTP();  
		$mail->SMTPAuth = true;  
		$mail->CharSet = 'utf-8';  
		$mail->SMTPDebug  = 0;
		$mail->SetFrom('no-reply@rutamayatravel.com.mx', 'Sistema Ruta Maya Travel'); 
		$mail->Subject = $subject; 
		$mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; 
		$mail->MsgHTML($message);
		$mail->AddAddress($model->idUser->email_usuario, $model->idUser->nombre_usuario);
		$mail->AddAddress($model->idAgente->email_usuario, $model->idAgente->nombre_usuario);
		$mail->AddAddress($model->idAgencia->email_agencia, $model->idAgencia->nombre_agencia);
		$mail->AddAddress('contabilidad@rutamayatravel.com', 'Contabilidad');
		$mail->Send();
	}
	public function actionUpdateCc()
	{
		$model=$this->loadModel($_POST['Reservacion']['id_reservacion']);
		if(isset($_POST['Reservacion']))
		{
			$model->attributes=$_POST['Reservacion'];
			if($model->save())
			{	
				$operacion = Yii::app()->createController('operacionesLog');
				$operacion = $operacion[0];
				$operacion->Create($model->id_reservacion,19);		
				$this->redirect(array('view','id'=>$_POST['Reservacion']['id_reservacion']));
			}
			else
			{
				print_r($model->getErrors());
				$this->reservacion($_POST['Reservacion']['id_reservacion']);
			}
		}
	}
	public function actionAgregarinformacion()
	{
		if(isset($_POST['observacion'])){
			$model = $this->loadModel($_POST['idCupon']);
			$model->observaciones = $_POST['observacion'];
			$model->save();
			echo $model->observaciones;
		}
	}
	public function actionCambiartarifaneta()
	{
		if(isset($_POST['idCupon'])){
			$model = $this->loadModel($_POST['idCupon']);
			$model->saldo_h = $_POST['tarifa_neta'];
			if($model->save()){
				echo "OK!";
			}else{
				echo "Error!";
			}
		}
	}
	public function actionModificartipocambio()
	{
		if(isset($_POST['idCupon']) && is_numeric($_POST['tipo_cambio'])){
			$model = $this->loadModel($_POST['idCupon']);
			$model->tipo_cambio = $_POST['tipo_cambio'];
			$pagos = ReciboDetalles::model()->with('idRecibo')->findAll('id_reservacion='.$model->id_reservacion.' and estado!="C"');
			$totalimporte = 0;
			foreach($pagos as $row){
				$totalimporte += $row->importe;
			}
			$totalcambio = round($model->total_tc * $model->tipo_cambio,2);
			$model->saldo = $totalcambio - ($totalcambio*($model->comision/100));
			$model->saldo = round($model->saldo - $totalimporte,2);
			if($model->save()){
				$operacion = Yii::app()->createController('operacionesLog');
				$operacion = $operacion[0];
				$operacion->Create($model->id_reservacion,28);
				echo CJSON::encode(array('totalcambio'=>$totalcambio,'saldo'=>$model->saldo));
			}
		}
	}
	public function verificaClave($clave)
	{
		$clave = Claves::model()->find('clave="'.$clave.'"');
		if(!empty($clave)){
			return $clave;
		}else{
			return NULL;
		}
	}
	public function actionCancelar($id)
	{
		$model=$this->loadModel($id);


		// echo "<textarea>".CJSON::encode($model)."</textarea>";
		// exit;
		$usuarioCancela=$this->verificaClave($_POST['clave_confirmacion']);
		$penalizar = isset($_POST['penalizar']) ? TRUE:FALSE;
		$penalizacion = isset($_POST['penalizacion']) ? $_POST['penalizacion']:0;
		if(!empty($_POST['clave_confirmacion']) && !empty($usuarioCancela))
		{
			switch ($model->idHotel->proveedor) {
				case 4:
					$riuControl=Yii::app()->createController('riu')[0];
					$riuControl->cancelarRiu($model->code, 'CANCELLATION');
				break;

				case 5:
				     
				break;

				case 6:
					if(!empty($this->palaceResorts[$model->idHotel->codigo]))
					{
						$ini = ini_set("soap.wsdl_cache_enabled","0");
						$client = new SoapClient($this->clientUrl);
						$folios = explode('WS',$model->code);
						$url = 'https://api.palaceresorts.com/EnterpriseServiceInterface/ServiceInterface.asmx?wsdl';
						$action = 'http://localhost/xmlschemas/enterpriseservice/16-07-2009/CancellingReservations';
						for($n=1;$n<count($folios);$n++){
							/*$parametros = array("cancellationRequest"=>array(
								"Data"=>array(
									"cancellationList"=>array(
										"Hotel"=>$model->idHotel->codigo,
										"Folio"=>$folios[$n],
										"Reason"=>$_POST['reason'],
										"Cancelled"=>false,
									)
								),
								"AuthInfo"=>array(
								 "Recnum"=>0,			
								 "Ent_User"=>"RMY",
								 "Ent_Pass"=>"QMrq8UzEru",
								 "Ent_Term"=>"RMY"
								 )
								 )
							);
							*/
						$xml='<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"><soap:Body><CancellingReservations xmlns="http://localhost/xmlschemas/enterpriseservice/16-07-2009/"><cancellationRequest xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationRequest.xsd"><Data><cancellationList><Hotel xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationList.xsd">'.$model->idHotel->codigo.'</Hotel><Folio xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationList.xsd">'.$folios[$n].'</Folio><Reason xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationList.xsd">'.$_POST['reason'].'</Reason><Ent_User xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationList.xsd">RMY</Ent_User><Ent_Term xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationList.xsd">RMY</Ent_Term><Cancelled xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/cancellationList.xsd">false</Cancelled></cancellationList></Data><AuthInfo><Recnum xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">0</Recnum><Ent_User xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">RMY</Ent_User><Ent_Pass xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">QMrq8UzEru</Ent_Pass><Ent_Term xmlns="http://localhost/pr_xmlschemas/hotel/01-03-2006/authInfo.xsd">RMY</Ent_Term></AuthInfo></cancellationRequest></CancellingReservations></soap:Body></soap:Envelope>';
						$client = new SoapClient(null, array(
									'location' => $url,
									'uri'      => "",
									'trace'    => 1,
									));
						try{
							$xmlAux=$xml;
						    $result = $client->__doRequest($xml, $url, $action, 1);
						    $resultAux=$result;
							//print_r($result);
						    $xml = simplexml_load_string($result, NULL, NULL, "http://schemas.xmlsoap.org/soap/envelope/");
							$ns = $xml->getNamespaces(true);
							$soap = $xml->children($ns['soap']);
							$body = $soap->Body->children($ns['CancellingReservationsResponse']);
							$result=$body->CancellingReservationsResponse;
						//	echo "Folio:".$result->folioResponse->Folio;
						}catch (SoapFault $exception){
							echo "falló";
						    print_r($exception);
						    $ex=$exception;
						}
							$error = ""; 
							$logHotelbeds = array();
							$logHotelbeds['header'] = "PalaceCancel";
							$logHotelbeds['request'] = $xmlAux;
							$logHotelbeds['response'] = $resultAux;
							$logHotelbeds['reference'] = $model->idHotel->codigo;		
							//$this->logWs($logHotelbeds,'Palace');
							//$result = $client->CancellingReservations($parametros);
							if($result->cancellationResponse->HasErrors==true){
								$errorWS = "Error de Webservice: ".$result->cancellationResponse->ExceptionInfo->Type;
								$this->redirect(array('view','id'=>$model->id_reservacion,'errorWS'=>$errorWS));
							}
							else{
								$cancellation = true;
							}
						}
					}
				break;

				default:
					# code...
				break;
			}
			
//termina palace




			$recibos = ReciboDetalles::model()->with('idRecibo')->findAll('id_reservacion='.$model->id_reservacion.' and estado!="C"');
			$importe = 0;
			$cancelados = "";
			foreach($recibos as $row)
			{
				if($penalizar == TRUE && $row->importe == $penalizacion){
					$penalizado = TRUE;
					continue;
				}
				$importe += $row->importe;
				$cancelarecibo = Recibo::model()->findByPk($row->id_recibo);
				$cancelarecibo->estado = 'C';
				$cancelarecibo->motivo = "Cancelación de Reservación #".$model->id_reservacion;
				$cancelarecibo->save();
				$cancelados .= "#".$row->id_recibo." ";
				$otrasreservas = ReciboDetalles::model()->findAll('id_recibo='.$row->id_recibo.' and id_reservacion!='.$model->id_reservacion);
				if(count($otrasreservas) > 0){
					$importeotras = 0; $reservas = "";
					foreach($otrasreservas as $otras){
						$importeotras += $otras->importe;
						$reservacion = Reservacion::model()->findByPk($otras->id_reservacion);
						$reservacion->saldo += $otras->importe;
						$reservacion->save();
						$reservas .= "#".$otras->id_reservacion." ";
					}
					$this->Crearnota($importeotras,$model,"Cancelación de Reservación #".$model->id_reservacion." - Importe de Reservas: ".$reservas);
				}
			}
			if($importe > 0)
			{	
				if($penalizar == TRUE && $penalizado == FALSE && $importe > $penalizacion){
					$importe = $importe-$penalizacion;
					$recibo = new Recibo;
					$recibo->id_tipo = 11;
					$recibo->importe = $penalizacion;
					$recibo->id_agencia = $model->id_agencia;
					$recibo->id_user = Yii::app()->user->id;
					if($recibo->save()){
						$detalle = new ReciboDetalles;
						$detalle->id_recibo = $recibo->id_recibo;
						$detalle->id_reservacion = $model->id_reservacion;
						$detalle->importe = $penalizacion;
						$detalle->concepto = 'Pago de Penalización Reserva #'.$model->id_reservacion.' Pax: '.$model->nombre_cliente.' '.$model->apellido_cliente.' - Hotel: '.$model->idHotel->nombre_hotel.' - '.$model->num_habitaciones.' Hab.';
						$detalle->save();
					}
				}
				$this->Crearnota($importe,$model,"Cancelación de Reservación #".$model->id_reservacion." Recibos Cancelados: ".$cancelados);
			}
			$model->saldo+=$importe;
			$model->motivo=$_POST['motivo']."<br />Fecha: ".date('d/m/Y H:i:s')." Autorizó: ".$usuarioCancela->idUsuario->nombre_usuario;
			$model->estatus='C';
			if($model->id_bloqueo != ""){
				$roominglist = Roominglist::model()->findAll('id_reservacion='.$model->id_reservacion);
				foreach($roominglist as $hab){
					$hab->id_reservacion = NULL;
					$hab->save();
				}
			}
			if($model->save()){
				$operacion = Yii::app()->createController('operacionesLog');
				$operacion = $operacion[0];
				$operacion->Create($model->id_reservacion,5);
				$this->redirect(array('view','id'=>$model->id_reservacion));	
			}else{
				print_r($model->getErrors());
			}
		}
		else if(!empty($_POST['clave_confirmacion'])){
			$this->redirect(array('view','id'=>$model->id_reservacion,'error_clave'=>1));
		}
		else{
			$model->motivo=$_POST['motivo'];
			$model->estatus='PC';
			if($model->save()){
				$this->redirect(array('view','id'=>$model->id_reservacion));
			}
		}
	}
	public function Crearnota($importe,$model,$concepto)
	{
		$notacredito = new NotaCredito;
		$notacredito->importe = $importe;
		$notacredito->id_tipo = 11;
		$notacredito->id_agencia = $model->id_agencia;
		$notacredito->id_ref = $model->id_reservacion;
		$notacredito->tipo_ref = "RESERVACION";
		$notacredito->concepto = $concepto;
		$notacredito->estatus = "A";
		$notacredito->id_user = Yii::app()->user->id;
		$notacredito->save();
	}
	public function actionReinstalarReservacion($id)
	{
		$model=$this->loadModel($id);
		$usuarioCancela=$this->verificaClave($_POST['clave_confirmacion']);
		if(isset($_POST['clave_confirmacion']) && !empty($usuarioCancela))
		{
			$model->estatus = "RE";
			$model->motivo .= "<br />Se reinstaló: ".date('d/m/Y H:i:s')." Autorizó: ".$usuarioCancela->idUsuario->nombre_usuario;
			if($model->save()){
				$operacion = Yii::app()->createController('operacionesLog');
				$operacion = $operacion[0];
				$operacion->Create($model->id_reservacion,31);
				$this->redirect(array('view','id'=>$model->id_reservacion));
			}
		}
		else{
			$this->redirect(array('view','id'=>$model->id_reservacion,'error_clave'=>1));
		}
	}
	public function actionSendHotel()
	{
		$this->renderPartial("_form");
	}
	public function actionEnviohotel()
	{
		$encabezados  = "MIME-Version: 1.0\n";
		$encabezados .= "Content-type: text/html; charset=UTF-8\n";
		$encabezados .= "From:  Ruta Maya Travel <".Yii::app()->user->email.">\n";
		$encabezados .= "X-Sender: <contacto web>\n";
		$encabezados .= "X-Mailer: PHP\n";
		$encabezados .= "X-Priority: 3\n";
		$encabezados .= "Return-Path: <web page>\n";
		$fecha = date("d-m-Y H:i:s");
		$recipent = $_POST["email_envio2"];
		$subject = $_POST['asunto'];
		$message = $_POST['mensaje'];
		// message lines should not exceed 70 characters (PHP rule), so wrap it
		// send mail
		mail($recipent,$subject,$message,$encabezados);
		mail($uss->email,$subject,$message,$encabezados);
		echo 'Mensaje Enviado!';
	}
	public function actionPagoscupon()
	{

			$model=Reservacion::model()->findByPk($_POST["idCupon"]);
			$tipo="";
			$pagoscupon='pagoscupon';

		if ($_POST['tipo']=='tour') {
			
			$model=TourReservacion::model()->findByPk($_POST["idCupon"]);
			$tipo=' and tipo="Tour"';
			$pagoscupon='/tourReservacion/pagoscupon';
		}
			
		
		$pagos = ReciboDetalles::model()->findAll('id_reservacion='.$_POST["idCupon"].$tipo);
		$this->renderPartial($pagoscupon,array('model'=>$model,'pagos'=>$pagos));
	}
	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
            $session=new CHttpSession;
            $session->open();		
            $criteria = new CDbCriteria();            
                $model=new Reservacion('search');
                $model->unsetAttributes();  // clear any default values
                if(isset($_GET['Reservacion']))
		{
                        $model->attributes=$_GET['Reservacion'];
                       if (!empty($model->id_reservacion)) $criteria->addCondition("id_reservacion = '".$model->id_reservacion."'");
                       if (!empty($model->id_agencia)) $criteria->addCondition("id_agencia = '".$model->id_agencia."'");
                       if (!empty($model->id_hotel)) $criteria->addCondition("id_hotel = '".$model->id_hotel."'");
                       if (!empty($model->id_usuario)) $criteria->addCondition("id_usuario = '".$model->id_usuario."'");
                       if (!empty($model->id_agente)) $criteria->addCondition("id_agente = '".$model->id_agente."'");
                       if (!empty($model->fecha_inicial)) $criteria->addCondition("fecha_inicial = '".$model->fecha_inicial."'");
                       if (!empty($model->fecha_final)) $criteria->addCondition("fecha_final = '".$model->fecha_final."'");
                       if (!empty($model->num_noches)) $criteria->addCondition("num_noches = '".$model->num_noches."'");
                       if (!empty($model->observaciones)) $criteria->addCondition("observaciones = '".$model->observaciones."'");
                       if (!empty($model->estatus)) $criteria->addCondition("estatus = '".$model->estatus."'");
                       if (!empty($model->log)) $criteria->addCondition("log = '".$model->log."'");
                       if (!empty($model->subtotal)) $criteria->addCondition("subtotal = '".$model->subtotal."'");
                       if (!empty($model->comision)) $criteria->addCondition("comision = '".$model->comision."'");
                       if (!empty($model->iva)) $criteria->addCondition("iva = '".$model->iva."'");
                       if (!empty($model->total)) $criteria->addCondition("total = '".$model->total."'");
                       if (!empty($model->saldo)) $criteria->addCondition("saldo = '".$model->saldo."'");
                       if (!empty($model->porc_com_agencia)) $criteria->addCondition("porc_com_agencia = '".$model->porc_com_agencia."'");
                       if (!empty($model->num_habitaciones)) $criteria->addCondition("num_habitaciones = '".$model->num_habitaciones."'");
                       if (!empty($model->nombre_cliente)) $criteria->addCondition("nombre_cliente = '".$model->nombre_cliente."'");
                       if (!empty($model->apellido_cliente)) $criteria->addCondition("apellido_cliente = '".$model->apellido_cliente."'");
                       if (!empty($model->tel_cliente)) $criteria->addCondition("tel_cliente = '".$model->tel_cliente."'");
                       if (!empty($model->id_tarifa)) $criteria->addCondition("id_tarifa = '".$model->id_tarifa."'");
                       if (!empty($model->code)) $criteria->addCondition("code = '".$model->code."'");
                       if (!empty($model->factura)) $criteria->addCondition("factura = '".$model->factura."'");
                       if (!empty($model->libera_cupon)) $criteria->addCondition("libera_cupon = '".$model->libera_cupon."'");
                       if (!empty($model->id_tipo_plan)) $criteria->addCondition("id_tipo_plan = '".$model->id_tipo_plan."'");
                       if (!empty($model->comision_bancaria)) $criteria->addCondition("comision_bancaria = '".$model->comision_bancaria."'");
                    $session['Reservacion_records']=Reservacion::model()->findAll($criteria); 
		}
       			if($_SESSION["tipoUsuario"]=="Agencia"){
						$model->id_agencia=$_SESSION["idAgencia"];
                 		$criteria->addCondition("id_agencia = '".$model->id_agencia."'");
						$criteria->order = 'log DESC';
//						if($_GET["xpagar"]==1) 
				  }
                $this->render('index',array(
			'model'=>$model,
		));
	}
	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Reservacion('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Reservacion']))
			$model->attributes=$_GET['Reservacion'];
		$this->render('admin',array(
			'model'=>$model,
		));
	}
	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Reservacion::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'Cupón no existente.');
		return $model;
	}
	public function loadModelAgencia($id)
	{
		$agencias=Agencias::model()->findByPk($id);
		if($agencias===null)
			throw new CHttpException(404,'Cupón no existente.');
			/*$this->render('view',array('error'=>'error'));*/
		return $agencias;
	}
	public function loadModelHotel($id)
	{
		$hoteles=Hoteles::model()->findByPk($id);
		if($hoteles===null)
			//throw new CHttpException(404,'Cupón no existente.');
			$this->render('view',array(
			'error'=>'error',
		));
		return $hoteles;
	}
	public function loadModelCategoria($hotel)
	{
		if($hotel->proveedor==1)
		{
			$codigo=$hotel->estrellas;
			$categorias=Categories::model()->find('codigo="'.$codigo.'"');
			$categoria=$categorias->description;
		}
		else if($hotel->proveedor==3)
		{
			if($hotel->estrellas!="Array")
            {
                $countCategoria=strlen($hotel->estrellas);
                if($countCategoria==2)
                {
                    $estrellas=substr($hotel->estrellas, 1);
                }else
                {
                    $estrellas=substr($hotel->estrellas, 1,-1);                                               
                }

                $categorias=Categorias::model()->findByPk($estrellas);
				$categoria=$categorias->categoria;
            }


		}
		else
		{
			$categorias=Categorias::model()->findByPk($hotel->id_categoria);
			$categoria=$categorias->categoria;
		}
		if($categorias===null){
			throw new CHttpException(404,'Cupón no existente.');
			//$this->render('view',array('error'=>'error'));
		}
		return $categoria;
	}
	public function loadModelTipoPlan($model)
	{
		if(strtotime($model->log) < strtotime('2015-05-21')){
			$tipoplan=TipoPlan::model()->findByPk($model->id_tipo_plan);
		}else{
			$tipoplan=Plan::model()->findByPk($model->id_tipo_plan);
		}

		if($model->idHotel->proveedor==2)
		{
			

			$desgloseReservacion = ReservacionDesglose::model()->findAll('id_reservacion='.$model->id_reservacion);

			$desglose=json_decode($desgloseReservacion[0]->desgloseBeds);

			$plan["nombre"]=$desglose->desglose->planHotel;
			$tipoplan=json_decode(json_encode($plan));

		}
		
		return $tipoplan;
	}
	public function loadModelDestinos($id)
	{
		$destinos=Zonasbeds::model()->findByPk($id);
		if($destinos===null)
		{
			throw new CHttpException(404,'Cupón no existente.');
			//$this->render('view',array('error'=>'error'));
		}
		return $destinos;
	}
	public function loadModelUsuarios($id)
	{
		$usuarios=Usuarios::model()->findByPk($id);
		if($usuarios===null)
			//throw new CHttpException(404,'Cupón no existente.');
			$this->render('view',array(
			'error'=>'error',
		));
		return $usuarios;
	}
	public function loadModelReservdesgloce($id)
	{
		$reserv_des=VwReservacionDesglose::model()->findByPk($id);
		if($reserv_des===null)
			//throw new CHttpException(404,'Cupón no existente.');
			$this->render('view',array(
			'error'=>'error',
		));
		return $reserv_des;
	}
	public function loadModelTarifa($id)
	{
		$tarifa=Tarifa::model()->findByPk($id);
		if($tarifa===null)
			//throw new CHttpException(404,'Cupón no existente.');
			$this->render('view',array(
			'error'=>'error',
		));
		return $tarifa;
	}
	public function loadModelTarifaMenores($id_tarifa,$id_tipo_habitacion,$id_base_habitacion,$num_menores)
	{
		$tarifaMenor = DesgloseMenores::model()->find("id_tarifa=".$id_tarifa." and id_tipo_habitacion=".$id_tipo_habitacion." and id_base_habitacion=".$id_base_habitacion);
		$preciomenor = $tarifaMenor->precio;
		if($num_menores <= $tarifaMenor->num_menores_gratis)
		{
			$preciomenor = 0;
		}
		else
		{
			$menorespagan = $num_menores - $tarifaMenor->num_menores_gratis;
			$preciomenor = $menorespagan * $preciomenor;
		}
		return $preciomenor;
	}

	public function cancelaciones($model,$fecha_inicio,$id_tarifa=null)##EL METODO EXISTE TAL CUÁL EN BusquedaController y SiteController
	{
		$avisoCancelacion = "";
		$cancelacion = Cancelacion::model()->findAll('id_hotel='.$model->id_hotel.' and "'.$fecha_inicio.'" between fecha_inicio and fecha_final ORDER BY dias DESC');
		if(empty($cancelacion))
			$cancelacion = Cancelacion::model()->findAll('id_hotel is null and "'.$fecha_inicio.'" between fecha_inicio and fecha_final ORDER BY dias DESC');
		foreach($cancelacion as $row){
			$fecha = strtotime($fecha_inicio." -".$row->dias." days");
			if(strtotime(date('Y-m-d')) <= $fecha){
				$avisoCancelacion .= "<p>Si cancela hasta el ".date('d/m/Y',$fecha)." tiene penalidad de ".$row->penalizacion." noches</p>";
			}
		}
		if(!empty($cancelacion)){
			$fecha = strtotime($fecha_inicio." -".($row->dias - 1)." days");
			if($fecha < strtotime('now')){
				$fecha = strtotime('now');
			}
			$avisoCancelacion .= "<p>A partir del ".date('d/m/Y',$fecha)." tiene penalización de toda la estancia.</p>";
		}

		if($avisoCancelacion=="")
		{
	        $siteController = Yii::app()->createController('site');
            $siteController = $siteController[0];

            $fecha_limite=$siteController->getFechaLimitePago($model->id_tarifa,$fecha_inicio,$model->id_hotel);

			$avisoCancelacion="<p>Si cancela hasta el ".date("d/m/Y",strtotime($fecha_limite))." tiene penalidad de 0 noches.</p>";
			$avisoCancelacion .= "<p>A partir del ".date('d/m/Y',strtotime($fecha_limite.' +1 days'))." tiene penalización de toda la estancia.</p>";
		}
		return $avisoCancelacion;
	}
	public function checarPenalizacion($model,$fecha_inicio)
	{
		$penalizacion = 0;
		$dias = $this->noches(date('Y-m-d'),$fecha_inicio);
		$cancelacion = Cancelacion::model()->findAll('id_hotel='.$model->id_hotel.' and "'.$fecha_inicio.'" between fecha_inicio and fecha_final ORDER BY dias DESC');
		if(empty($cancelacion))
			$cancelacion = Cancelacion::model()->findAll('id_hotel is null and "'.$fecha_inicio.'" between fecha_inicio and fecha_final ORDER BY dias DESC');
		foreach($cancelacion as $row){
			if($dias < $row->dias){
				continue;
			}else{
				$penalizacion = $row->penalizacion;
				break;
			}
		}
		if(!empty($cancelacion) && $dias < $row->dias){
			$penalizacion = 100;
		}
		return $penalizacion;
	}
	public function actionAgregarhabitacion()
	{
		if(isset($_POST['nueva']))
		{
			$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$_POST['id_hotel'].' and estatus=1');
			$base_habitacion = BaseHabitacion::model()->findAll();
			$this->renderPartial('habitacion_agregar',array('i'=>$_POST['nueva'],'tipo_habitacion'=>$tipo_habitacion,'base_habitacion'=>$base_habitacion));
		}
	}
	public function actionBuscarplan()
	{
		if($_POST['id_hotel'] != "")
		{
			$plan = Plan::model()->with('planHotels')->findAll('id_hotel='.$_POST['id_hotel']);
			echo CJSON::encode($plan);
		}
	}
	public function actionCargarhabitaciones()
	{
		if(isset($_POST['num_habitaciones']) && isset($_POST['id_hotel']))
		{
			$habs = $_POST['num_habitaciones'];
			if($_POST['id_bloqueo'] != "")
			{
				$bloqueo = Bloqueos::model()->findByPk($_POST['id_bloqueo']);
			}
			$tipo_habitacion = TipoHabitaciones::model()->findAll('id_hotel='.$_POST['id_hotel'].' and estatus=1');
			$base_habitacion = BaseHabitacion::model()->findAll();
			$this->renderPartial('habitacion',array('habs'=>$habs,'tipo_habitacion'=>$tipo_habitacion,'base_habitacion'=>$base_habitacion,'idhab'=>isset($bloqueo) ? $bloqueo->id_tipo_habitacion:NULL));
		}
	}
	public function actionCargarbase()
	{
		if(isset($_POST['tipo_hab']))
		{
			$model = TipoHabitaciones::model()->findByPk($_POST['tipo_hab']);
			$base = BaseHabitacion::model()->findAll();
			$html = '<option value="">SELECCIONAR</option>';
			foreach($base as $row){
				if($row->id_base_habitacion > $model->max_adultos)break;
				$html .= '<option value="'.$row->id_base_habitacion.'">'.$row->base_habitacion.'</option>';
			}
			echo $html;
		}
	}
	public function actionCargaradultos()
	{
		if(isset($_POST['num_adultos']))
		{
			$this->renderPartial('adulto_manual',array('num_adultos'=>$_POST['num_adultos'],'hab'=>$_POST['hab']));
		}
	}
	public function actionCargarmenores()
	{
		if(isset($_POST['num_ninios']))
		{
			$this->renderPartial('menor_manual',array('num_ninios'=>$_POST['num_ninios'],'hab'=>$_POST['hab']));
		}
	}
	public function actionCargarrestriccion()
	{
		if($_POST['id_hotel'] != "" && $_POST['fecha_entrada'] != "")
		{
			$fecha_entrada = implode('-',array_reverse(explode('-',$_POST['fecha_entrada'])));
			$restriccion = Tarifa::model()->find('id_hotel='.$_POST['id_hotel'].' and "'.$fecha_entrada.'" between fecha_inicial and fecha_final');
			echo CJSON::encode($restriccion);
		}
	}
	public function Sumarsuplemento($tarifa,$fecha,$base,$persona,$edad)
	{
		if($persona == 'A')
		{
			$suplementos = Suplemento::model()->findAll('id_tarifa='.$tarifa.' and persona="'.$persona.'" and "'.$fecha.'" between fecha_inicio and fecha_final');
		}
		else if($edad != NULL)
		{		
			$suplementos = Suplemento::model()->findAll('id_tarifa='.$tarifa.' and persona="'.$persona.'" and "'.$fecha.'" between fecha_inicio and fecha_final and '.$edad.' between edad_min and edad_max');
		}
		else{
			$suplementos = Suplemento::model()->findAll('id_tarifa='.$tarifa.' and persona="'.$persona.'" and "'.$fecha.'" between fecha_inicio and fecha_final');
		}
		$importe = 0;
		foreach($suplementos as $row)
		{
			$importe+=$row->publico;
		}
		if($persona == 'A')$importe *= $base;
		return $importe;
	}
	public function actionCotizar()
	{
		$model=new Reservacion;
		$model->attributes=$_POST['Reservacion'];
		$datos=array(); $menores=array();
		$error=NULL; $ocultaT = array();
		$Total = array();
		$maxT = 0;
		$hora = "and curtime() between hora_inicio and hora_final";
		$fecha_promo = "and current_date between fecha_promo_inicio and fecha_promo";
		$early_booking = "and (early_booking is null or DATEDIFF('".implode("-", array_reverse(explode("-", $model->fecha_inicial)))."',current_date) <= early_booking)";
		$release = "and (t.release is null or DATEDIFF('".implode("-", array_reverse(explode("-", $model->fecha_inicial)))."',current_date) >= t.release)";
		if($_SESSION["agenciaUsuario"] != 9){
			$tarifaAgencias = 'and not exists(select NULL from tbl_tarifa_agencia tarifaAgencias where tarifaAgencias.id_tarifa=t.id_tarifa and tarifaAgencias.id_agencia!='.$_SESSION["agenciaUsuario"].')';
			$agenciaUsuario = Agencias::model()->findByPk($_SESSION["agenciaUsuario"]);
			$tarifaEstados = 'and exists(select NULL from tbl_tarifa_estados tarifaEstados where tarifaEstados.id_tarifa=t.id_tarifa and tarifaEstados.id_estado='.$agenciaUsuario->id_estado_agencia.')';
		}
		for($dia=0;$dia<$model->num_noches;$dia++)
		{
			$fecha = date("Y-m-d", strtotime(implode("-", array_reverse(explode("-", $model->fecha_inicial))))+$dia*24*60*60);
			$fechadia = strtotime(implode("-", array_reverse(explode("-", $model->fecha_inicial))))+$dia*24*60*60;
			if($model->id_bloqueo != "")
			{
				$bloqueo = Bloqueos::model()->findByPk($model->id_bloqueo);
				$tipo_precio = $bloqueo->idTarifa->precio;
				$tarifa = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'t.id_tarifa='.$bloqueo->id_tarifa.' and id_tipo_plan='.$model->id_tipo_plan.' '.$fecha_promo.' '.$hora.' and precio="'.$tipo_precio.'" and estatus=1 and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final '.$tarifaAgencias.' '.$tarifaEstados.' and not exists(select NULL from tbl_fechas_bloqueadas tarifaFechasbloqueadas where "'.$fecha.'" between tarifaFechasbloqueadas.fecha_inicio and tarifaFechasbloqueadas.fecha_final and tarifaFechasbloqueadas.id_tipo_habitacion is null and tarifaFechasbloqueadas.id_tarifa=t.id_tarifa)', 'order'=>'precio'));
			}
			else{
				$tarifa = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'id_hotel='.$model->id_hotel.' and id_tipo_plan='.$model->id_tipo_plan.' '.$fecha_promo.' '.$hora.' '.$early_booking.' '.$release.' and precio NOT IN("GRUPAL","BLOQUEO","BODA") and estatus=1 and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final '.$tarifaAgencias.' '.$tarifaEstados.' and not exists(select NULL from tbl_fechas_bloqueadas tarifaFechasbloqueadas where "'.$fecha.'" between tarifaFechasbloqueadas.fecha_inicio and tarifaFechasbloqueadas.fecha_final and tarifaFechasbloqueadas.id_tipo_habitacion is null and tarifaFechasbloqueadas.id_tarifa=t.id_tarifa)', 'order'=>'precio'));
			}
			if($maxT > count($tarifa))
			{
				$tarifaComb = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'id_hotel='.$model->id_hotel.' and id_tipo_plan='.$model->id_tipo_plan.' '.$fecha_promo.' '.$hora.' '.$early_booking.' '.$release.' and precio="NORMAL" and promocontigua=1 and estatus=1 and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final '.$tarifaAgencias.' '.$tarifaEstados.' and not exists(select NULL from tbl_fechas_bloqueadas tarifaFechasbloqueadas where "'.$fecha.'" between tarifaFechasbloqueadas.fecha_inicio and tarifaFechasbloqueadas.fecha_final and tarifaFechasbloqueadas.id_tipo_habitacion is null and tarifaFechasbloqueadas.id_tarifa=t.id_tarifa)', 'limit'=>1));
				if(!empty($tarifaComb)){
					$tarifa = (object) array_merge((array) $tarifa, (array) $tarifaComb);
					$combinada = true;
					$combT = $maxT - 1;
				}else{
					$tarifa = (object) array_merge((array) $tarifa, (array) $tarifa);
					$combinada = true;
					$combT = $maxT - 1;
				}
			}
			else if($maxT < count($tarifa)){
				$datos[$dia-1][$maxT] = $datos[$dia-1][$maxT-1];
				if(!empty($menores[$dia-1][$maxT-1]))$menores[$dia-1][$maxT] = $menores[$dia-1][$maxT-1];
				$Total[$maxT]['total'] += $Total[$maxT-1]['total'];
				$Total[$maxT]['total_tc'] += $Total[$maxT-1]['total_tc'];
				/*$hide = count($tarifa) - $maxT;
				if($hide==1){
					if(count($tarifa)==3)$ocultaT[2] = true;
					if(count($tarifa)==2)$ocultaT[1] = true;
				}else if($hide == 2){
					if(count($tarifa)==3){
						$ocultaT[2] = true;
						$ocultaT[1] = true;
					}
					if(count($tarifa)==4){
						$ocultaT[2] = true;
						$ocultaT[3] = true;
					}
				}	*/			
			}
			if(empty($tarifa))
			{
				$error = "Actualmente este hotel no dispone de tarifas para la fecha ".$fecha.". Le sugerimos modificar e intentar de nuevo, o le invitamos a contactar a nuestros ejecutivos vía telefónica o chat para la generación de una cotización.";
				break;
			}
			$t = 0;
			foreach($tarifa as $row)
			{
				$costoTotal = 0; $costoTotalTC = 0;
				$habs = 1;
				for($i=1;$habs<=$model->num_habitaciones;$i++)
				{
					if(($_POST["Habitacion_".$i.""]) != NULL)
					{
						$habBloqueada = FechasBloqueadas::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$_POST["Habitacion_".$i.""]["id_tipo_habitacion"].' and "'.$fecha.'" between fecha_inicio and fecha_final');
						if(empty($habBloqueada)){							
							$tarifaDesglose = TarifaDesglose::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$_POST["Habitacion_".$i.""]["id_tipo_habitacion"].' and id_base_habitacion='.$_POST["Habitacion_".$i.""]["id_base_habitacion"].' and '.$_POST["Habitacion_".$i.""]["num_ninios"].' <= max_menores and estatus=1');
						}
						if(empty($tarifaDesglose)){
							if(count($tarifa) > 1 && count($ocultaT) < count($tarifa)){
								$ocultaT[$t] = true;
							}else{
								$error = "No se encontró una tarifa de ".$_POST["Habitacion_".$i.""]["id_base_habitacion"]." adultos que acepte un máximo numero de menores de ".$_POST["Habitacion_".$i.""]["num_ninios"]." para la habitación ".$i.". O la habitación está bloqueada para la fecha ".$fecha;
							}
							break;
						}
						$nocheGratis = NochesGratis::model()->find('id_tarifa='.$row->id_tarifa.' and (id_tipo_habitacion is null or id_tipo_habitacion='.$_POST["Habitacion_".$i.""]["id_tipo_habitacion"].')');
						$suplemento = 0;
						if(!empty($nocheGratis) && (($dia+1) % $nocheGratis->noche == 0)){
							if(($dia+1) > $nocheGratis->noche && $nocheGratis->acumulable != 1){
								$nocheGratis = false;
							}else{
								$tarifaDesglose->precio_normal = 0;
								$nocheGratis = true;
							}
						}
						$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,$tarifaDesglose->id_base_habitacion,'A',NULL);
						$costoAdultos = $tarifaDesglose->precio_normal + $suplemento;
						$costoAdultosTC = $row->tipoCambio($tarifaDesglose->precio_normal) + $row->tipoCambio($suplemento);
						if($suplemento > 0){
							$datos[$dia][$t][$i]['adultos'] = number_format($row->tipoCambio($tarifaDesglose->precio_normal),'2')." + ".number_format($row->tipoCambio($suplemento),'2')." SUP.";
						}else{
							$datos[$dia][$t][$i]['adultos'] = number_format($costoAdultosTC,'2');
						}
						$costoMenores = 0; $costoMenoresTC = 0;
						$menorgratis = 0; $niniopaga = 1;
						$precompraMenor = "fecha_inicio_precompra is null or current_date between fecha_inicio_precompra and fecha_final_precompra";
						for($n=1;$n<=$_POST["Habitacion_".$i.""]["num_ninios"];$n++){ //Ordenar edades menores mayor a menor
							if($_POST["Ninio_".$n."_".$i.""]["edad"] < $_POST["Ninio_".($n+1)."_".$i.""]["edad"]){
								$aux = $_POST["Ninio_".$n."_".$i.""]["edad"];
								$_POST["Ninio_".$n."_".$i.""]["edad"] = $_POST["Ninio_".($n+1)."_".$i.""]["edad"];
								$_POST["Ninio_".($n+1)."_".$i.""]["edad"] = $aux; 
								$n=0;
							}
						}
						for($n=1;$n<=$_POST["Habitacion_".$i.""]["num_ninios"];$n++)
						{
							$tarifaMenor=DesgloseMenores::model()->find("id_tarifa=".$row->id_tarifa." and id_tipo_habitacion=".$_POST["Habitacion_".$i.""]["id_tipo_habitacion"]." and ".$_POST["Ninio_".$n."_".$i.""]["edad"]." <= edad_max_menor and num_evaluar=".$niniopaga." and es_junior=0 and(".$precompraMenor.") and(fecha_inicio is null or '".$fecha."' between fecha_inicio and fecha_final) ORDER BY precio ASC");
							if(empty($tarifaMenor)){
								$tarifaMenor=DesgloseMenores::model()->find("id_tarifa=".$row->id_tarifa." and id_tipo_habitacion=".$_POST["Habitacion_".$i.""]["id_tipo_habitacion"]." and ".$_POST["Ninio_".$n."_".$i.""]["edad"]." between edad_min_menor and edad_max_menor and es_junior=1 and(".$precompraMenor.") and(fecha_inicio is null or '".$fecha."' between fecha_inicio and fecha_final) ORDER BY precio ASC");
								if(empty($tarifaMenor)){
									if(count($tarifa) > 1 && count($ocultaT) < count($tarifa)){
										$ocultaT[$t] = true;
									}else{
										$error = "El menor con edad ".$_POST["Ninio_".$n."_".$i.""]["edad"]." de la habitación ".$i." no tiene una tarifa definida para la fecha ".$fecha;
									}
									break;
								}
							}
							if($tarifaMenor->es_junior != 1)$niniopaga++;
							if($_POST["Ninio_".$n."_".$i.""]["edad"] < $tarifaMenor->edad_min_menor || $nocheGratis == true)$tarifaMenor->precio = 0;
							$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,0,'N',$_POST["Ninio_".$n."_".$i.""]["edad"]);
							$precioMenor = $tarifaMenor->precio + $suplemento;
							$costoMenores += $precioMenor;
							$precioMenorTC = $row->tipoCambio($tarifaMenor->precio) + $row->tipoCambio($suplemento);
							$costoMenoresTC += $precioMenorTC;
							$menores[$dia][$t][$i] .= "Menor ".$n.": $ ".number_format($precioMenorTC,'2','.',',')." / ";
						}
						$datos[$dia][$t][$i]['menores'] = number_format($costoMenoresTC,'2','.',',');
						$costoHabitacion = $costoAdultos + $costoMenores;
						$costoTotal += $costoHabitacion;
						$costoHabitacionTC = $costoAdultosTC + $costoMenoresTC;
						$costoTotalTC += $costoHabitacionTC;
						$datos[$dia][$t][$i]['fecha'] = implode("-", array_reverse(explode("-", $fecha)));
						$datos[$dia][$t][$i]['total'] = number_format($costoHabitacionTC,'2','.',',');
						$minNoches = MinNoches::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$tarifaDesglose->id_tipo_habitacion.' and "'.$fecha.'" between fecha_inicio and fecha_final');
						if(!empty($minNoches) && $minNoches->minimo > $Total[$t]['min_noches']){
							$Total[$t]['min_noches'] = $minNoches->minimo;
						}else if($row->min_noches > $Total[$t]['min_noches']){
							$Total[$t]['min_noches'] = $row->min_noches;
						}
						$habs++;
					}
				}
				if($combinada == true && $Total[$t]['codigo'] != $row->codigo)
				{
					if(strpos($Total[$t]['nombre'], $row->nombre_tarifa) === FALSE){
						$Total[$t]['nombre'] .= " + ".$row->nombre_tarifa;
					}
					if($row->restricciones != ""){
						$Total[$t]['restricciones'] .= "<br><br>Otras Restricciones: ".$row->restricciones;
					}
					$Total[$t]['codigo'] = $row->codigo;
				}
				else{
					if(empty($Total[$t]['tarifa']))$Total[$t]['tarifa'] = $row->id_tarifa;
					$Total[$t]['nombre'] = $row->precio." ".$row->nombre_tarifa;
					if($row->restricciones != "" && "<p>".$row->restricciones."</p>" != $Total[$t]['restricciones'])
						$Total[$t]['restricciones'] .= "<p>".$row->restricciones."</p>";
					$Total[$t]['moneda'] = $row->mostrar_conversion == 0 ? $row->moneda:'MXN';
					$Total[$t]['codigo'] = $row->codigo;
				}
				$Total[$t]['total'] += $costoTotal;
				$Total[$t]['total_tc'] += $costoTotalTC;
				$t++;
				if($maxT < $t) $maxT = $t;
			}
		}
		echo CJSON::encode(array(
				'error'=>$error,
				'oculta'=>$ocultaT,
				'tarifas'=>$maxT,
				'noches'=>$model->num_noches,
				'habs'=>$model->num_habitaciones,
				'resul'=>$datos,
				'menores'=>$menores,
				'total'=>$Total
			));
	}
	public function actionSumardias()
	{
		if($_POST['fecha_inicial'] != "" && $_POST['noches'] > 0)
		{
			$fecha = array_reverse(explode("-", $_POST['fecha_inicial']));
			$nuevafecha = date('Y-m-d',mktime(0,0,0,$fecha[1],$fecha[2]+$_POST['noches'],$fecha[0]));
			$nuevafecha = implode("-", array_reverse(explode("-", $nuevafecha)));
			echo CJSON::encode(array(
				'fecha_final'=>$nuevafecha
			));
		}
	}
	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='reservacion-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
        public function actionGenerateExcel()
	{
            $session=new CHttpSession;
            $session->open();		
             if(isset($session['Reservacion_records']))
               {
                $model=$session['Reservacion_records'];
               }
               else
                 $model = Reservacion::model()->findAll();
		Yii::app()->request->sendFile(date('YmdHis').'.xls',
			$this->renderPartial('excelReport', array(
				'model'=>$model
			), true)
		);
	}
        public function actionGeneratePdf() 
	{
           $session=new CHttpSession;
           $session->open();
		Yii::import('application.extensions.bootstrap.gii.*');
		require_once('bootstrap/tcpdf/tcpdf.php');
		require_once('bootstrap/tcpdf/config/lang/eng.php');
             if(isset($session['Reservacion_records']))
               {
                $model=$session['Reservacion_records'];
               }
               else
                 $model = Reservacion::model()->findAll();
		$html = $this->renderPartial('expenseGridtoReport', array(
			'model'=>$model
		), true);
		//die($html);
		$pdf = new TCPDF();
		$pdf->SetCreator(PDF_CREATOR);
		$pdf->SetAuthor(Yii::app()->name);
		$pdf->SetTitle('Reservacion Report');
		$pdf->SetSubject('Reservacion Report');
		//$pdf->SetKeywords('example, text, report');
		$pdf->SetHeaderData('', 0, "Report", '');
		$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, "Example Report by ".Yii::app()->name, "");
		$pdf->setHeaderFont(Array('helvetica', '', 8));
		$pdf->setFooterFont(Array('helvetica', '', 6));
		$pdf->SetMargins(15, 18, 15);
		$pdf->SetHeaderMargin(5);
		$pdf->SetFooterMargin(10);
		$pdf->SetAutoPageBreak(TRUE, 0);
		$pdf->SetFont('dejavusans', '', 7);
		$pdf->AddPage();
		$pdf->writeHTML($html, true, false, true, false, '');
		$pdf->LastPage();
		$pdf->Output("Reservacion_002.pdf", "I");
	}
	public function actionVer($id_reservacion)
	{
		$this->reservacion($id_reservacion);
	}
	public function actionBuscar()
	{
		$id_reservacion=$_POST['search'];
		
			$idReservacion=substr(strtoupper($id_reservacion), 0, 1);
			$idReservacionIsNumeric = is_numeric($id_reservacion)? $id_reservacion:	substr($id_reservacion, 1);
		
		if (is_numeric($idReservacionIsNumeric)) {
			switch ($idReservacion) {
				case 'A':
				$this->redirect(array('activities/view','id'=>$idReservacionIsNumeric));
				break;
				case 'T':
				$this->redirect(array('tourReservacion/view','id'=>$idReservacionIsNumeric));
				break;
				default:
				$this->redirect(array('reservacion/view','id'=>$idReservacionIsNumeric));
				break;
			}
		}else{
			$_SESSION['searching']['nombre'] = $id_reservacion;
			$this->redirect(array('reservas/reservaciones'));
			// $exist_letter = $this->has_letter($_POST['search']);
			
			// if ($exist_letter==true) {
			// 	$countLetter = strlen($_POST['search']);

			// 	if ($countLetter>1) {
			// 	}
			// }
		}
		
		

		//$this->reservacion($id_reservacion);
	}

	public function has_letter($x){ 
		
		if (preg_match("/[\p{L}]/u",$x)) { 
			return true; 
		}
		return false; 
	}

	public function reservacion($id_reservacion)
	{


		$model=$this->loadModel($id_reservacion);
		$agencia=$this->loadModelAgencia($model->id_agencia);
		$hoteles=$this->loadModelHotel($model->id_hotel);
		$direccion=$this->direccionAgencia($agencia);
		$direchotel=$this->direccionHotel($hoteles);		
		$logotipo=$this->HotelLogo($model->id_hotel);
		$categorias=$this->loadModelCategoria($hoteles);
		$tipoplan=$this->loadModelTipoPlan($model);
		$destinos=$this->loadModelDestinos($hoteles->id_destino);
		$usuarios=$this->loadModelUsuarios($model->id_agente);
		$reserv_desgloce= $this->reservdesgloce($model->id_reservacion);
		$desgloseReserva = $this->desgloseReservacion($model);
		$personas=$this->personas($model->id_reservacion);
		$modelRecibo = new Recibo;
		$modelRecibo->id_agencia = $model->id_agencia;
		$modelComision = new Reservacion;
		if(empty($model->id_bloqueo)){
			$cancelaciones = $this->cancelaciones($model,$model->fecha_inicial,$model->id_tarifa);
		}
		if(strtotime(date('Y-m-d')) <= strtotime($model->fecha_inicial)){
			$penalizacion = $this->checarPenalizacion($model,$model->fecha_inicial);
		}else{
			$penalizacion = 100;
		}
		if($penalizacion > 0){
			$importePenalizacion = 0;
			$t = $desgloseReserva[2];
			if($penalizacion < 100){
				for($i=0;$i<$penalizacion;$i++){
					$importePenalizacion += $desgloseReserva[4][$i][$t];
				}
				if($desgloseReserva[1][$t]['moneda'] != "MXN" && !empty($model->tipo_cambio)){
					$importePenalizacion = round($importePenalizacion * $model->tipo_cambio,2);
				}
				$importePenalizacion = round($importePenalizacion - $importePenalizacion*($model->comision/100),2);
			}
			else{
				$importePenalizacion = $model->saldo;
			}
			$pagos = ReciboDetalles::model()->with('idRecibo')->findAll('id_reservacion='.$model->id_reservacion.' and estado!="C"');
			$totalPagos = 0;
			foreach($pagos as $row){
				$totalPagos += $row->importe;
			}
			$penalizacion = array('noches'=>$penalizacion,'importe'=>$importePenalizacion,'totalPagos'=>$totalPagos);
		}




		$this->render('view',array(
			'model'=>$model,
			'agencia'=>$agencia,
			'direccion'=>$direccion,
			'hoteles'=>$hoteles,
			'logotipo'=>$logotipo,
			'direchotel'=>$direchotel,
			'categorias'=>$categorias,
			'tipoplan'=>$tipoplan,
			'destinos'=>$destinos,
			'usuarios'=>$usuarios,
			'reserv_desgloce'=>$reserv_desgloce,
			'desgloseReserva'=>$desgloseReserva,
			'tarifa'=>$tarifa,
			'personas'=>$personas,
			'modelRecibo'=>$modelRecibo,
			'modelComision'=>$modelComision,
			'cancelaciones'=>$cancelaciones,
			'penalizacion'=>$penalizacion
		));
	}


		public function actionEcomerce()
		{
			$dash = Yii::app()->createController('dashboard');
			$dash = $dash[0];
			$tasa_cambio=$dash->tasaCambioActual();
			$currency=$tasa_cambio['importe']? $tasa_cambio['importe']:25.5;
			if ($_POST['total']) {
			 $_SESSION['ecomerce']['tipo_pago'] = $_POST['tpago'];
			 $_SESSION['ecomerce']['comisionBancomer'] = $_POST['cargo'];
			 $_SESSION['ecomerce']['tipo_tarifa'] = $_POST['ttarifa'];
			 $_SESSION['ecomerce']['importe'] = $_POST['importe'];
			 $_SESSION['ecomerce']['planPago'] = $_POST['planPago'];
			 $_SESSION['TotalCotiz'][$_POST['carrito']][0]['total_tc']=$_POST['total'];
			 $moneda = (string)$_POST['moneda'];
			 $Ds_Merchant_Amount=$_POST['total']*100;
			 if ($moneda=="USD") {
			 	$monto = ($_POST['total']*$currency);
			 	$Ds_Merchant_Amount =  number_format($monto, 2, '.', '');
			 }else if($moneda=="EUR"){
			 	$monto = ($_POST['total']*25);
			 	$Ds_Merchant_Amount =  number_format($monto, 2, '.', '');
			 }
             $Ds_Merchant_Order=date('dm')."RMT".date('is');
             $Ds_Merchant_MerchantCode="4130906";
             $Ds_Merchant_Currency="484";
             $Ds_Merchant_TransactionType=0;
             $CLAVE_SECRETA="4ru1ta3ma0ya9tr0av6e";
             $str= $Ds_Merchant_Amount.$Ds_Merchant_Order.$Ds_Merchant_MerchantCode.$Ds_Merchant_Currency.$Ds_Merchant_TransactionType.$CLAVE_SECRETA;
             header('Content-Type: application/json');
				$data['clave']= sha1($str);
				$data['total']= $Ds_Merchant_Amount;
				$data['order']= $Ds_Merchant_Order;
				$data['transaccion']= $Ds_Merchant_TransactionType;
				$data['moneda'] = $moneda;
				$data['urlOk']= "https://".$_SERVER["SERVER_NAME"].Yii::app()->createUrl('reservacion/tcProcessBanco', array('val'=>'ok', 'reference'=>$Ds_Merchant_Order));
				$data['urlKo']= "https://".$_SERVER["SERVER_NAME"].Yii::app()->createUrl('reservacion/tcProcessBanco', array('val'=>'ko', 'ref'=>$Ds_Merchant_Order, 'cancel'=>1));
			 echo json_encode($data, JSON_FORCE_OBJECT);
			}elseif ($_POST['Ds_Merchant_Order']) {
				$order=explode('-',$_POST['Ds_Merchant_Order']);
				// $reservacion=array('Reservacion'=>$_SESSION['Reservacion'], 'Datos'=>$_SESSION['Datos'][$_SESSION['Reservacion']['carrito']], 'carrito'=>$_SESSION['Cotizacion'], 'TotalCotiz'=>$_SESSION['TotalCotiz'], 'ecomerce'=>$_SESSION['ecomerce']);
				$reservacion=array(
					'Reservacion'=>$_SESSION['Reservacion'], 
					'Datos'=>$_SESSION['Datos'][$_SESSION['Reservacion']['carrito']], 
					'carrito'=>$_SESSION['Cotizacion'], 
					'TotalCotiz'=>$_SESSION['TotalCotiz'], 
					'ecomerce'=>$_SESSION['ecomerce'],
					'DatosGenerales'=>$_SESSION['Datos_generales'],
					'ResultadoBusqueda'=>$_SESSION["resultadoBusquedaHoteles"],
					'CountCotiz'=> $_SESSION['CountCotiz'],
					'Total_noche' => $_SESSION['Total_noche'],
					'Menores'=>$_SESSION['Menores'],
				);
				$model = new LogBanco;
				$model->header='Bancomer';
				$model->estatus='enviado';
				$model->request=json_encode($_POST);
				$model->response='no';
				$model->reference=$_POST['Ds_Merchant_Order'];
				$model->reserva=json_encode($reservacion);
				$model->tipo="RESERVACION";
				if($model->save())
					$this->reservacionProvisional("https://".$_SERVER['SERVER_NAME'].Yii::app()->createUrl("admin/reservacion/cuponProvisional"),$model->reference);
			}                           
		}
	public function actionEcomerceAgencias()
	{
			header('Access-Control-Allow-Origin: *');
			header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method");
			header("Access-Control-Allow-Methods: GET, POST, OPTIONS, PUT, DELETE");
			header("Allow: GET, POST, OPTIONS, PUT, DELETE");

			$dash = Yii::app()->createController('dashboard');
			$dash = $dash[0];
			$tasa_cambio=$dash->tasaCambioActual();
			$currency=$tasa_cambio['importe']? $tasa_cambio['importe']:23;
			if ($_POST['total']) {
			 
			 $moneda = (string)$_POST['moneda'];
			 $Ds_Merchant_Amount=$_POST['total']*100;
			 if ($moneda=="USD") {
			 	$monto = ($_POST['total']*$currency);
			 	$Ds_Merchant_Amount =  number_format($monto, 2, '.', '');
			 }else if($moneda=="EUR"){
			 	$monto = ($_POST['total']*25);
			 	$Ds_Merchant_Amount =  number_format($monto, 2, '.', '');
			 }
             $Ds_Merchant_Order=date('dm')."RMT".date('is');
             $Ds_Merchant_MerchantCode="4130906";
             $Ds_Merchant_Currency="484";
             $Ds_Merchant_TransactionType=0;
             $CLAVE_SECRETA="4ru1ta3ma0ya9tr0av6e";
             $str= $Ds_Merchant_Amount.$Ds_Merchant_Order.$Ds_Merchant_MerchantCode.$Ds_Merchant_Currency.$Ds_Merchant_TransactionType.$CLAVE_SECRETA;
          
				$data['clave']= sha1($str);
				$data['total']= $Ds_Merchant_Amount;
				$data['order']= $Ds_Merchant_Order;
				$data['transaccion']= $Ds_Merchant_TransactionType;
				$data['moneda'] = $moneda;
				$data['urlOk']= "https://".$_POST['url']."?val=ok&reference=".$Ds_Merchant_Order;
				$data['urlKo']= "https://".$_POST['url']."?val=ko&ref=".$Ds_Merchant_Order."&cancel=1";
				$data['ecomerce']['tipo_pago'] = $_POST['tpago'];
				$data['ecomerce']['comisionBancomer'] = $_POST['cargo'];
				$data['ecomerce']['tipo_tarifa'] = $_POST['ttarifa'];
				$data['ecomerce']['importe'] = $_POST['importe'];
				$data['ecomerce']['planPago'] = $_POST['planPago'];
			 	$data['TotalCotiz'][$_POST['carrito']][0]['total_tc']=$_POST['total'];
			 echo json_encode($data, JSON_FORCE_OBJECT);
			}elseif ($_POST['Ds_Merchant_Order']) {
			$order=explode('-',$_POST['Ds_Merchant_Order']);
			// $reservacion=array('Reservacion'=>$_SESSION['Reservacion'], 'Datos'=>$_SESSION['Datos'][$_SESSION['Reservacion']['carrito']], 'carrito'=>$_SESSION['Cotizacion'], 'TotalCotiz'=>$_SESSION['TotalCotiz'], 'ecomerce'=>$_SESSION['ecomerce']);
			/*$reservaObj=json_decode($_POST['reservacion']);
			$reservacion=array(
				'Reservacion'=>$reservaObj->Reservacion, 
				'Datos'=>$reservaObj->Datos[$reservaObj->Reservacion->carrito], 
				'carrito'=>$reservaObj->Cotizacion, 
				'TotalCotiz'=>$reservaObj->TotalCotiz, 
				'ecomerce'=>$reservaObj->ecomerce,
				'DatosGenerales'=>$reservaObj->Datos_generales,
				'ResultadoBusqueda'=>$reservaObj->resultadoBusquedaHoteles,
				'CountCotiz'=> $reservaObj->CountCotiz,
				'Total_noche' =>$reservaObj->Total_noche,
				'Menores'=>$reservaObj->Menores,
			);*/
			$model = new LogBanco;
			$model->header='Bancomer';
			$model->estatus='enviado';
			$model->request=json_encode($_POST);
			$model->response='no';
			$model->reference=$_POST['Ds_Merchant_Order'];
			$model->reserva=$_POST['reservacion'];
			$model->tipo="RESERVACION";
			$model->save();
			//if($model->save())
				//$this->reservacionProvisional("https://".$_SERVER['SERVER_NAME'].Yii::app()->createUrl("admin/reservacion/cuponProvisional"),$model->reference);
		}                           
	}
	public function actionReservacionProvisional()
	{
		$this->reservacionProvisional("https://".$_SERVER['SERVER_NAME'].Yii::app()->createUrl("admin/reservacion/cuponProvisional"),'2108RMT1446');
	}
	public function reservacionProvisional($url,$ds_order)
	{

	 	$curl = curl_init();

		curl_setopt_array($curl, array(
		  CURLOPT_URL => $url,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 30,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "POST",
		  CURLOPT_POSTFIELDS => "ref=".$ds_order,
		  CURLOPT_HTTPHEADER => array(
		    "Content-Type: application/x-www-form-urlencoded",
		    "cache-control: no-cache"
		  ),
		));

		$response = curl_exec($curl);
		$err = curl_error($curl);

		curl_close($curl);

		if ($err) {
		  echo "cURL Error #:" . $err;
		} else {
			var_dump($response);
		  echo $url."---".$response;
		}
	}

	public function desgloseReservacion($model)
	{
		$outletController = Yii::app()->createController('outlet');
		$outletController = $outletController[0];
		$outlet=Outlet::model()->find("estatus=1");
		$tarifaOutlet=$outletController->validacionTarifas($outlet);

		$datos=array(); $menores=array(); $precioNoche=array();
		$Total = array();
		$maxT = 0;
		$fecha_promo = 'and "'.date('Y-m-d',strtotime($model->log)).'" between fecha_promo_inicio and fecha_promo';
		$precompraMenor = 'fecha_inicio_precompra is null or "'.date('Y-m-d',strtotime($model->log)).'" between fecha_inicio_precompra and fecha_final_precompra';
		for($dia=0;$dia<$model->num_noches;$dia++)
		{
			$fecha= date("Y-m-d", strtotime(implode("-", array_reverse(explode("-", $model->fecha_inicial))))+$dia*24*60*60);
			$fechadia = strtotime(implode("-", array_reverse(explode("-", $model->fecha_inicial))))+$dia*24*60*60;
			if($model->id_bloqueo != "")
			{
				$bloqueo = Bloqueos::model()->findByPk($model->id_bloqueo);
				$tipo_precio = $bloqueo->idTarifa->precio;
				$tarifa = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'id_hotel='.$model->id_hotel.' and id_tipo_plan='.$model->id_tipo_plan.' '.$fecha_promo.' and precio="'.$tipo_precio.'" and estatus=1 and dia="'.date("N",$fechadia).'" and "'.$fecha.'" between t.fecha_inicial and t.fecha_final', 'order'=>'precio'));
			}
			else{
				$tarifa = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'id_hotel='.$model->id_hotel.' and id_tipo_plan='.$model->id_tipo_plan.' '.$fecha_promo.' and precio NOT IN("GRUPAL","BLOQUEO","BODA") and estatus=1 and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final', 'order'=>'precio'));
			}
			if($maxT > count($tarifa))
			{
				$tarifaComb = Tarifa::model()->with('tarifaDiasvalidos')->findAll(array('condition'=>'id_hotel='.$model->id_hotel.' and id_tipo_plan='.$model->id_tipo_plan.' '.$fecha_promo.' and precio="NORMAL" and promocontigua=1 and estatus=1 and dia='.date("N",$fechadia).' and "'.$fecha.'" between t.fecha_inicial and t.fecha_final', 'limit'=>1));
				if(!empty($tarifaComb)){
					$tarifa = (object) array_merge((array) $tarifa, (array) $tarifaComb);
					$combinada = true;
					$combT = $maxT - 1;
				}else{
					$tarifa = (object) array_merge((array) $tarifa, (array) $tarifa);
					$combinada = true;
					$combT = $maxT - 1;
				}
			}
			$t = 0;
			foreach($tarifa as $row)
			{
				$costoTotal = 0;
				$habitacion = ReservacionDesglose::model()->findAll('id_reservacion='.$model->id_reservacion);
				$i=1;
				foreach($habitacion as $hab)
				{							
					$tarifaDesglose = TarifaDesglose::model()->find('id_tarifa='.$row->id_tarifa.' and id_tipo_habitacion='.$hab->id_tipo_habitacion.' and id_base_habitacion='.$hab->id_base_habitacion.'');
					$nocheGratis = NochesGratis::model()->find('id_tarifa='.$row->id_tarifa.' and (id_tipo_habitacion is null or id_tipo_habitacion='.$hab->id_tipo_habitacion.')');
					if(!empty($nocheGratis) && (($dia+1) % $nocheGratis->noche == 0)){
						if(($dia+1) > $nocheGratis->noche && $nocheGratis->acumulable != 1){
							$nocheGratis = false;
						}else{
							$tarifaDesglose->precio_normal = 0;
							$nocheGratis = true;
						}
					}
					$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,$tarifaDesglose->id_base_habitacion,'A',NULL);
					$costoAdultos = $model->tipoCambio($tarifaDesglose->precio_normal) + $model->tipoCambio($suplemento);

					if ($tarifaOutlet && $outlet->tipo=="SEMANA ESPECIAL" && strtotime($model->log) > strtotime(date('2020-03-11 17:40:47')) && $model->id_bloqueo==null) {
						$costoAdultos = $outletController->tarifaOutletVirtual($costoAdultos,0,$row->comision,$outlet->descuento_general);
					}

					$datos[$dia][$t][$i]['adultos'] = number_format($costoAdultos,'2','.',',');
					$costoMenores = 0;
					$menorgratis = 0;
					$persona = ReservacionDesglosePersona::model()->findAll('id_desglose='.$hab->id_desglose.' and tipo="N"');
					$n=1;
					$niniopaga = 1;
					foreach($persona as $menor)
					{
						$tarifaMenor=DesgloseMenores::model()->find("id_tarifa=".$row->id_tarifa." and id_tipo_habitacion=".$hab->id_tipo_habitacion." and ".$menor->edad." <= edad_max_menor and num_evaluar=".$niniopaga." and es_junior=0 and(".$precompraMenor.") and(fecha_inicio is null or '".$fecha."' between fecha_inicio and fecha_final) ORDER BY precio ASC");
						if(empty($tarifaMenor)){
							$tarifaMenor=DesgloseMenores::model()->find("id_tarifa=".$row->id_tarifa." and id_tipo_habitacion=".$hab->id_tipo_habitacion." and ".$menor->edad." between edad_min_menor and edad_max_menor and es_junior=1 and(".$precompraMenor.") and(fecha_inicio is null or '".$fecha."' between fecha_inicio and fecha_final) ORDER BY precio ASC");
						}
						if($tarifaMenor->es_junior != 1)$niniopaga++;
						if($menor->edad < $tarifaMenor->edad_min_menor || $nocheGratis == true)$tarifaMenor->precio = 0;
						$suplemento = $this->Sumarsuplemento($row->id_tarifa,$fecha,0,'N',$menor->edad);
						$precioMenor = $model->tipoCambio($tarifaMenor->precio) + $model->tipoCambio($suplemento);
						$costoMenores += $precioMenor;
						$menores[$dia][$t][$i] .= "Menor ".$n.": $ ".number_format($precioMenor,'2','.',',')." / ";
						$n++;
					}
					if ($tarifaOutlet && $outlet->tipo=="SEMANA ESPECIAL" || $outlet->tipo=="MEGA OUTLET" && $model->id_bloqueo==null && $row->precio!="OUTLET") {
						$costoMenores = $outletController->tarifaOutletVirtual($costoMenores,0,$row->comision,$outlet->descuento_general);
					}
					
					$datos[$dia][$t][$i]['menores'] = number_format($costoMenores,'2','.',',');
					$costoHabitacion = $costoAdultos + $costoMenores;
					$costoTotal += $costoHabitacion;
					$precioNoche[$dia][$t] += $costoHabitacion;
					$datos[$dia][$t][$i]['fecha'] = implode("-", array_reverse(explode("-", $fecha)));
					$datos[$dia][$t][$i]['total'] = number_format($costoHabitacion,'2','.',',');
					$i++;
				}
				if($combinada == true && $Total[$t]['codigo'] != $row->codigo)
				{
					if(strpos($Total[$t]['nombre'], $row->nombre_tarifa) === FALSE){
						$Total[$t]['nombre'] .= " + ".$row->nombre_tarifa;
						$Total[$t]['codigo'] .= " + ".$row->codigo;
					}
					if($row->restricciones != ""){
						$Total[$t]['restricciones'] .= "<br><br>Otras Restricciones: ".$row->restricciones;
					}
				}
				else{
					$Total[$t]['tarifa'] = $row->id_tarifa;
					$Total[$t]['nombre'] = $row->precio." ".$row->nombre_tarifa;
					$Total[$t]['codigo'] = $row->codigo;
					$Total[$t]['min_noches'] = $row->min_noches;
					$Total[$t]['restricciones'] = $row->restricciones;
					$Total[$t]['moneda'] = ($model->total > $model->total_tc && !empty($model->tipo_cambio)) ? 'MXN':$row->moneda;
				}
				$Total[$t]['total'] += $costoTotal;
				$t++;
				if($maxT < $t) $maxT = $t;
			}
		}
		for($j=0;$j<$maxT;$j++)
		{
			if(number_format($Total[$j]['total'],1) == number_format($model->total,1))
			{
				$t = $j;
			}
		}
		return array($datos,$Total,$t,$menores,$precioNoche);
	}
	public function direccionAgencia($id)
	{
//		$agencia=$this->loadModelAgencia($id);
		$agencia=$id;		
		$direccion = "Calle ".$agencia->calle_agencia." ".$agencia->cruzamientos_agencia." #Ext ".$agencia->num_exterior_agencia." Col ".$agencia->id_colonia_agencia." CP ".$agencia->cp_agencia;
		return $direccion;
	}
	public function direccionHotel($id)
	{
//		$hotel=$this->loadModelHotel($id);
	$hotel=$id;
		$direccion = "Calle ".$hotel->calle_hotel." ".$hotel->cruzamientos_hotel." #Ext ".$hotel->num_exterior_hotel." Col ".$hotel->id_colonia_hotel." CP ".$hotel->cp_hotel;
		return $direccion;
	}
	public function HotelLogo($id)
	{
		$sql="SELECT * FROM tbl_hoteles_fotos WHERE id_hotel='".$id."' AND logotipo=1";	
		$row=Yii::app()->db->createCommand($sql)->queryRow();
		return $row[foto];
	}
	public function reservdesgloce($id)
	{
		//$sql="SELECT * FROM vw_reservacion_desglose  WHERE id_reservacion='".$id."'";	
$sql="select `rd`.`desgloseBeds` AS `desgloseBeds`, `rd`.`estatus` AS `estatus`, `rd`.`id_reservacion` AS `id_reservacion`,`rd`.`id_desglose` AS `id_desglose`,`bh`.`base_habitacion` AS `base_habitacion`,
`th`.`tipo_habitacion` AS `tipo_habitacion`, `rd`.`id_tipo_habitacion` AS `id_tipo_habitacion`, `rd`.`id_base_habitacion` AS `id_base_habitacion`,`rd`.`num_adultos` AS `num_adultos`,`rd`.`num_ninios` AS `num_menores`,
(select group_concat(`tbl_reservacion_desglose_persona`.`edad` separator ',') AS `group_concat(edad)` 
from `tbl_reservacion_desglose_persona`
where `tbl_reservacion_desglose_persona`.`id_desglose` = `rd`.`id_desglose` and `tbl_reservacion_desglose_persona`.`tipo` = 'N') AS `edades_menores`
from `tbl_reservacion_desglose` `rd`
join `tbl_base_habitacion` `bh` on `rd`.`id_base_habitacion` = `bh`.`id_base_habitacion`
join `tbl_tipo_habitaciones` `th` on `rd`.`id_tipo_habitacion` = `th`.`id_tipo_habitacion`
join `tbl_reservacion` `r` on `r`.`id_reservacion` = `rd`.`id_reservacion` 
where `rd`.id_reservacion='".$id."'
group by `rd`.`id_desglose`";
		$row=Yii::app()->db->createCommand($sql)->queryAll();
		foreach($row as $data){		
			$arreglo[] = $data;
		} 
		return $arreglo;	 
	}
	public function personas_des($id_desglose)
	{
		$sql="SELECT * 
		FROM tbl_reservacion_desglose_persona  
		WHERE id_desglose='".$id_desglose."'";	
		$row=Yii::app()->db->createCommand($sql)->queryAll();
		foreach($row as $data){		
			$arreglo[] = $data;
		} 
		return $arreglo;	 
	}
	public function personas($id)
	{
		$sql="SELECT * 
		FROM tbl_reservacion_desglose_persona  
		WHERE id_reservacion='".$id."'";	
		$row=Yii::app()->db->createCommand($sql)->queryAll();
		foreach($row as $data){		
			$arreglo[] = $data;
		} 
		return $arreglo;	 
	}
	public function cupon($cupon)
	{
		$model=$this->loadModel($cupon);
		if ($model->code=="") {
			$model->libera_cupon=1;
//			$model->save();
		echo "Cupón Liberado";
		}
	}
	public function eventoOutlet($outlet)
	{
		
    	 $activo=($outlet->fecha_inicio<=date("Y-m-d") && $outlet->fecha_final>=date("Y-m-d"))? true:false;
    	 return $activo;
	}

/*	public function logWs($data, $ws)
	{
		$logWsControl=Yii::app()->createController('logWs');
		$logWsControl=$logWsControl[0];
		return $logWsControl->Create($data, $ws);
	}*/
	public function logWsRequest($data, $ws)
	{
		$logWsControl=Yii::app()->createController('logWs');
		$logWsControl=$logWsControl[0];
		return $logWsControl->logCreate($data, $ws);
	}
	public function logWsResponse($id, $data)
	{
		$logWsControl=Yii::app()->createController('logWs');
		$logWsControl=$logWsControl[0];
		return $logWsControl->Update($id, $data);
	}
	public function actionCambioMoneda() {

		$nuevo_total_reserva = floatval($_POST["nuevo_total_reserva"]);
		$model_reserva = Reservacion::model()->findByPk($_POST["id_reserva"]);

		$total_anterior = $model_reserva->total;

		$model_reserva->total = $nuevo_total_reserva;
		/*echo CJSON::encode($model_reserva);
		exit;*/
		if($model_reserva->save()) {
			$model_log = new OperacionesLog;
			$model_log->id_referencia = $model_reserva->id_reservacion;
			$model_log->id_operacion_tipo = 40;
			$model_log->descripcion = "Cambio de moneda, total anterior: ". $total_anterior .", nuevo saldo: ". $nuevo_total_reserva;
			$model_log->id_usuario = Yii::app()->user->id;
			$model_log->save();
			$this->redirect(array('view','id'=>$model_reserva->id_reservacion));
		} else {
			echo json_encode($model_reserva->getErrors());
		}
	}
}
